<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160317223910 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $workflowJson = '{
	"uuid": "46a9e1b2-a89f-4daa-b00d-36c7341db07a",
	"name": "Update Settings Workflow",
	"tag": "system,dev",
	"isActive": true,
	"steps": [{
		"uuid": "0eddcc4d-72dc-448c-a8ae-7d30a57838cb",
		"name": "On Settings Update",
		"stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
		"arguments": {
			"resource": "system_settings"
		},
		"left": 300,
		"top": 130
	}, {
		"uuid": "a1e4a95b-2056-47ae-80db-cbbf77ec4e96",
		"name": "Update Settings",
		"stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
		"left": 300,
		"top": 370,
		"arguments": {
			"script": "/wf/workflow/tasks/workflow.tasks.update_settings/"
		}
	}],
	"routes": [{
		"uuid": "fa44278d-93a8-4419-a68b-f7a5cc02de3f",
		"sourceStep": "/api/3/workflow_steps/0eddcc4d-72dc-448c-a8ae-7d30a57838cb",
		"targetStep": "/api/3/workflow_steps/a1e4a95b-2056-47ae-80db-cbbf77ec4e96"
	}],
	"triggerStep": "/api/3/workflow_steps/0eddcc4d-72dc-448c-a8ae-7d30a57838cb"
}';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }


    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;

        $workflowObject = $this->container->get('serializer')->deserialize(
            $this->workflowJson,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());

        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), '46a9e1b2-a89f-4daa-b00d-36c7341db07a');

        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }
}
