<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160324223335 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $workflowJson = '{
	"uuid": "6832e556-b9c7-497a-babe-feda3bd27dbf",
	"name": "Delay",
	"displayName": "Delay",
	"widget": null,
	"collection": "/api/3/step_type_collections/c06cd820-a031-433b-9094-220dda64b4e4",
	"arguments": {
		"script": "/wf/workflow/tasks/workflow.tasks.delay/"
	},
	"parent": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
	"icon": "fa fa-hourglass-2",
	"background": "#f75c4c"
}';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow_step_type');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $this->workflowJson,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());

        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow_step_type');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), '6832e556-b9c7-497a-babe-feda3bd27dbf');

        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }
}
