<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Cybersponse\CoreBundle\Entity\Picklist;
use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160328210922 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    protected $container;

    protected $picklistJson = '{
	"color": null,
	"icon": null,
	"itemValue": "SLA",
	"orderIndex": 0,
	"listName": "/api/3/picklist_names/23cf57fc-2a17-460f-abd8-14604bcc59f3",
	"uuid": "9d06744c-692f-408c-b6ca-2a08d60021a8"
}';

    protected $picklistNameJson = '{
    "name": "ContractsType",
    "uuid": "23cf57fc-2a17-460f-abd8-14604bcc59f3"
}';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        /** @var ResourceInterface $picklistResource */
        $picklistResource = $this->container->get('resource.picklist');
        $context = $picklistResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $picklistObject = $this->container->get('serializer')->deserialize(
            $this->picklistJson,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        /** @var ResourceInterface $picklistNameResource */
        $picklistNameResource = $this->container->get('resource.picklistnames');

        $picklistNameObject = $this->container->get('serializer')->deserialize(
            $this->picklistNameJson,
            $picklistNameResource->getEntityClass(),
            'json-ld',
            $picklistNameResource->getDenormalizationContext()
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        /** @var ObjectManager $picklistManager */
        $picklistManager = $managerRegistry->getManagerForClass($picklistResource->getEntityClass());

        $picklistManager->persist($picklistObject);
        $picklistManager->persist($picklistNameObject);
        $picklistManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        /** @var ResourceInterface $picklistResource */
        $picklistResource = $this->container->get('resource.picklist');

        $managerRegistry = $this->container->get('doctrine');
        /** @var ObjectManager $picklistManager */
        $picklistManager = $managerRegistry->getManagerForClass($picklistResource->getEntityClass());

        /** @var Picklist $picklistToDelete */
        $picklistToDelete = $picklistManager->find($picklistResource->getEntityClass(), '9d06744c-692f-408c-b6ca-2a08d60021a8');
        $picklistManager->remove($picklistToDelete);
        $picklistManager->remove($picklistToDelete->getListName());

        $picklistManager->flush();
    }
}
