<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160404201012 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $workflowJson = '{
      "uuid": "98f6ea3d-6153-473c-ad96-58010fe4f1ce",
      "name": "Password Reset Notification",
      "tag": "system,dev",
      "isActive": true,
      "steps": [{
          "uuid": "fdd3c431-482f-40c2-b229-66fae35b7639",
          "name": "New user?",
          "arguments": {
            "conditions": [
              {
                "condition": "{{ vars.request.data.newUser == True }}",
                "step_iri": "/api/3/workflow_steps/0dcd87b5-7b91-44e2-aad9-ddc6cc0e6be7"
              },
              {
                "condition": "{{ 8 == 8 }}",
                "step_iri": "/api/3/workflow_steps/1931b721-059f-48f6-8c4d-219a0436ce94"
              }
            ]
          },
          "left": 480,
          "top": 620,
          "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28"
        }, {
          "uuid": "1931b721-059f-48f6-8c4d-219a0436ce94",
          "name": "Send email to an existing user",
          "arguments": {
            "to": [
              "{{ vars.email }}"
            ],
            "from_str": "",
            "subject": "CyberSponse password reset",
            "content": "Greetings,\\n\\nAn administrator has requested a password reset for your CyberSponse account. To create a new password, you may visit the following link:\\n\\n{{vars.request.baseUri}}/login/{{vars.token}}\\n\\nThe above link will be valid for 1 hour. To request a new link after this time, please contact an administrator.\\n\\nAttempting to use your old password may result in your account being locked.\\n\\nRegards,\\nCyberSponse Inc."
          },
          "left": 653,
          "top": 754,
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778"
        }, {
          "uuid": "0dcd87b5-7b91-44e2-aad9-ddc6cc0e6be7",
          "name": "Send email to new user",
          "arguments": {
            "to": [
              "{{ vars.email }}"
            ],
            "from_str": "",
            "subject": "CyberSponse password reset",
            "content": "Greetings,\\n\\nAn administrator has requested a password reset for your CyberSponse account. To create a new password, you may visit the following link:\\n\\n{{vars.request.baseUri}}/login/{{vars.token}}\\n\\nThe above link will be valid for 1 hour. To request a new link after this time, please contact an administrator.\\n\\nRegards, \\nCyberSponse Inc."
          },
          "left": 320,
          "top": 760,
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778"
        }, {
          "uuid": "a3e4b247-cb96-42a3-a51a-351626a3cf35",
          "name": "On Password Change",
          "arguments": {
            "resource": "passwordChange"
          },
          "left": 388,
          "top": 129,
          "stepType": "/api/3/workflow_step_types/df26c7a2-4166-4ca5-91e5-548e24c01b5f"
        }, {
          "uuid": "2e56786b-8d1a-413a-a01d-434172170e64",
          "name": "Set email and uuid",
          "arguments": {
            "email": "{{vars.request.data.email}}",
            "uuid": "{{vars.request.data.uuid}}"
          },
          "left": 620,
          "top": 254,
          "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f"
        }, {
          "uuid": "ce9e4698-b2cb-4317-a822-c7d9881a5c92",
          "name": "Fetch token",
          "arguments": {
            "script": "/wf/workflow/tasks/pro_shop.tasks.crudhub_crud/",
            "arguments": {
              "collection": "/api/auth/token/?uuid={{vars.uuid}}",
              "method": "get",
              "resource": ""
            }
          },
          "left": 400,
          "top": 386,
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de"
        }, {
          "uuid": "4150d22e-f7ee-4136-a827-a1d984483148",
          "name": "Set token",
          "arguments": {
            "token": "{{vars.result.token}}"
          },
          "left": 620,
          "top": 491,
          "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f"
        }],
      "routes": [
        {
          "uuid": "e41a5fa2-c680-4d1c-88a6-b02758f5a5fd",
          "targetStep": "/api/3/workflow_steps/2e56786b-8d1a-413a-a01d-434172170e64",
          "sourceStep": "/api/3/workflow_steps/a3e4b247-cb96-42a3-a51a-351626a3cf35"
        },
        {
          "uuid": "b624e11f-2cd9-4c85-8522-640f761c5ada",
          "targetStep": "/api/3/workflow_steps/ce9e4698-b2cb-4317-a822-c7d9881a5c92",
          "sourceStep": "/api/3/workflow_steps/2e56786b-8d1a-413a-a01d-434172170e64"
        },
        {
          "uuid": "72908bcb-a020-44ee-9587-28c0560d5a13",
          "targetStep": "/api/3/workflow_steps/4150d22e-f7ee-4136-a827-a1d984483148",
          "sourceStep": "/api/3/workflow_steps/ce9e4698-b2cb-4317-a822-c7d9881a5c92"
        },
        {
          "uuid": "aac9f259-384a-4805-a337-b6eb4f29bd74",
          "targetStep": "/api/3/workflow_steps/fdd3c431-482f-40c2-b229-66fae35b7639",
          "sourceStep": "/api/3/workflow_steps/4150d22e-f7ee-4136-a827-a1d984483148"
        },
        {
          "uuid": "2f08a44a-ef8e-4ac2-afd3-07417ea1fe8d",
          "targetStep": "/api/3/workflow_steps/1931b721-059f-48f6-8c4d-219a0436ce94",
          "sourceStep": "/api/3/workflow_steps/fdd3c431-482f-40c2-b229-66fae35b7639"
        },
        {
          "uuid": "29cfd97f-8032-4318-a551-4969817f24ed",
          "targetStep": "/api/3/workflow_steps/0dcd87b5-7b91-44e2-aad9-ddc6cc0e6be7",
          "sourceStep": "/api/3/workflow_steps/fdd3c431-482f-40c2-b229-66fae35b7639"
        }
      ],
      "triggerStep": "/api/3/workflow_steps/a3e4b247-cb96-42a3-a51a-351626a3cf35"
    }';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        //Remove it first
        $this->down($schema);

        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $this->workflowJson,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );

        /** @var ManagerRegistry $managerRegistry */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());

        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        /** @var ManagerRegistry $managerRegistry */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), '98f6ea3d-6153-473c-ad96-58010fe4f1ce');

        if (!is_null($workflowToDelete)) {
            $workflowManager->remove($workflowToDelete);
            $workflowManager->flush();
        }
    }
}
