<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Cybersponse\CoreBundle\Api\Bulk\DenormalizationResult;
use Cybersponse\CoreBundle\Api\Bulk\DenormalizationResultCollection;
use Cybersponse\CoreBundle\Serializer\TypeAgnosticCollectionNormalizer;
use Doctrine\Common\Collections\Criteria;
use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\ORM\EntityRepository;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160414170749 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    //region WorkflowsToInsert
    private $workflows = '[
  {
    "@type": "Workflow",
    "name": "Create Task Notification",
    "isActive": true,
    "tag": "system,dev",
    "triggerStep": "/api/3/workflow_steps/7ce10c45-0d87-4765-9d22-755e1e4bfa6d",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "tasks"
        },
        "left": 313,
        "top": 187,
        "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
        "uuid": "7ce10c45-0d87-4765-9d22-755e1e4bfa6d"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check Task Assigned Person",
        "arguments": {
          "workflowReference": "/api/3/workflows/473494e3-92e7-4f68-9d30-a1392a1cdb56",
          "arguments": []
        },
        "left": 311,
        "top": 312,
        "stepType": "/api/3/workflow_step_types/74932bdc-b8b6-4d24-88c4-1a4dfbc524f3",
        "uuid": "c52547af-3793-4631-af3e-851f44310552"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "66e99828-f364-46dc-bda6-026da5830f0e",
        "name": "Start -> Check Task Assigned Person",
        "targetStep": "/api/3/workflow_steps/c52547af-3793-4631-af3e-851f44310552",
        "sourceStep": "/api/3/workflow_steps/7ce10c45-0d87-4765-9d22-755e1e4bfa6d"
      }
    ],
    "uuid": "3b7818e8-acba-4e3f-bf3e-60729023f9f1"
  },
  {
    "@type": "Workflow",
    "name": "Notify User if Task Assigned",
    "tag": "abstract,system,dev",
    "triggerStep": "/api/3/workflow_steps/fcabbe4e-a644-4995-81fc-5545cb370e60",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Notify User",
        "arguments": {
          "workflowReference": "/api/3/workflows/78088d8f-a087-4240-9241-fa1fb691384b",
          "arguments": []
        },
        "left": 520,
        "top": 420,
        "stepType": "/api/3/workflow_step_types/74932bdc-b8b6-4d24-88c4-1a4dfbc524f3",
        "uuid": "afccab11-34e5-4fe5-95ed-2ec094c85a45"
      },
      {
        "@type": "WorkflowStep",
        "name": "Do Nothing",
        "arguments": {
          "script": "https://dev.venom.cyber:8888/wf/workflow/tasks/workflow.tasks.no_op/",
          "arguments": []
        },
        "left": 240,
        "top": 420,
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "be5a6af3-bd28-4cba-9315-22a7e4e32ecd"
      },
      {
        "@type": "WorkflowStep",
        "name": "On Task Event",
        "left": 380,
        "top": 189,
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "fcabbe4e-a644-4995-81fc-5545cb370e60"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if AssignedToPerson is Set",
        "arguments": {
          "conditions": [
            {
              "condition": "{{ (vars.request.data.assignedToPerson == None) }}",
              "step_iri": "/api/3/workflow_steps/be5a6af3-bd28-4cba-9315-22a7e4e32ecd"
            },
            {
              "condition": "{{ true }}",
              "step_iri": "/api/3/workflow_steps/afccab11-34e5-4fe5-95ed-2ec094c85a45"
            }
          ]
        },
        "left": 380,
        "top": 300,
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "5a008f40-0ee0-4291-8123-e626cc3b209f"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "3c33a61e-6647-489d-a739-922506e5a235",
        "name": "Check if AssignedToPerson is Set -> Do Nothing",
        "targetStep": "/api/3/workflow_steps/be5a6af3-bd28-4cba-9315-22a7e4e32ecd",
        "sourceStep": "/api/3/workflow_steps/5a008f40-0ee0-4291-8123-e626cc3b209f"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "830b71da-492c-4ec5-9169-88af8fbfc287",
        "name": "Check if AssignedToPerson is Set -> Notify User",
        "targetStep": "/api/3/workflow_steps/afccab11-34e5-4fe5-95ed-2ec094c85a45",
        "sourceStep": "/api/3/workflow_steps/5a008f40-0ee0-4291-8123-e626cc3b209f"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "da195b33-36f7-4f25-b54e-84024298d23b",
        "name": "On Task Event -> Check if AssignedToPerson is Set",
        "targetStep": "/api/3/workflow_steps/5a008f40-0ee0-4291-8123-e626cc3b209f",
        "sourceStep": "/api/3/workflow_steps/fcabbe4e-a644-4995-81fc-5545cb370e60"
      }
    ],
    "uuid": "473494e3-92e7-4f68-9d30-a1392a1cdb56"
  },
  {
    "@type": "Workflow",
    "name": "Notify Person of Task Playbook",
    "tag": "abstract,system,dev",
    "triggerStep": "/api/3/workflow_steps/10f9773f-a25a-4ae7-a60d-c02f6ac458d2",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Send User Email Step",
        "arguments": {
          "to": [
            "{{ vars.request.data.assignedToPerson.email }}"
          ],
          "from_str": "",
          "content": "Hey {{ vars.request.data.assignedToPerson.firstname }}, the following task has been assigned to you:\n\nTask Name:\n{{ vars.request.data.name }}\n\nYou can view this task by clicking here:\n{% set idParts = vars.request.data[\'@id\'].split(\'/\') %}\n{{ vars.request.baseUri + \'/modules/tasks/\' + (idParts | last) }}\n\nThanks,\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).name }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).url }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).phoneMain }}",
          "subject": "Task Notification"
        },
        "left": 248,
        "top": 414,
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
        "uuid": "463ab331-8c60-412c-a9b4-4bdc1b505e91"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check Notification Preferences",
        "arguments": {
          "conditions": [
            {
              "condition": "{{ (vars.request.data.assignedToPerson[\'@settings\'] + \'/user/notifications/email\') | fromIRI }}",
              "step_iri": "/api/3/workflow_steps/463ab331-8c60-412c-a9b4-4bdc1b505e91"
            },
            {
              "condition": "{{ true }}",
              "step_iri": "/api/3/workflow_steps/adb2ab1b-d6cd-4c9b-a444-50fdb63cf795"
            }
          ]
        },
        "left": 383,
        "top": 287,
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "34659f1d-7583-4f6f-b10f-1ce70c49c23d"
      },
      {
        "@type": "WorkflowStep",
        "name": "On Task Event",
        "left": 380,
        "top": 172,
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "10f9773f-a25a-4ae7-a60d-c02f6ac458d2"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send Email To Admin Instead",
        "arguments": {
          "to": [
            "soc@cybersponse.com"
          ],
          "from_str": "",
          "content": "Administrator,\n\nThe following task has been assigned to {{ vars.request.data.assignedToPerson.firstname }} {{ vars.request.data.assignedToPerson.lastname }}:\n\nTask Name:\n{{ vars.request.data.name }}\n\nYou can view this task by clicking here:\n{% set idParts = vars.request.data[\'@id\'].split(\'/\') %}\n{{ vars.request.baseUri + \'/modules/tasks/\' + (idParts | last) }}\n\nThanks,\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).name }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).url }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).phoneMain }}",
          "subject": "Task Notification"
        },
        "left": 540,
        "top": 413,
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
        "uuid": "adb2ab1b-d6cd-4c9b-a444-50fdb63cf795"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "10ca3f6b-9d9d-4bf1-9e85-3fb5e2c5d10e",
        "targetStep": "/api/3/workflow_steps/adb2ab1b-d6cd-4c9b-a444-50fdb63cf795",
        "sourceStep": "/api/3/workflow_steps/34659f1d-7583-4f6f-b10f-1ce70c49c23d"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "2ae4e4cf-2f16-4104-8ef2-f481cd5fd14b",
        "targetStep": "/api/3/workflow_steps/463ab331-8c60-412c-a9b4-4bdc1b505e91",
        "sourceStep": "/api/3/workflow_steps/34659f1d-7583-4f6f-b10f-1ce70c49c23d"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "7e11dc14-3108-4d3c-b5b2-c3e681dbf7be",
        "name": "On Task Event -> Check Notification Preferences",
        "targetStep": "/api/3/workflow_steps/34659f1d-7583-4f6f-b10f-1ce70c49c23d",
        "sourceStep": "/api/3/workflow_steps/10f9773f-a25a-4ae7-a60d-c02f6ac458d2"
      }
    ],
    "uuid": "78088d8f-a087-4240-9241-fa1fb691384b"
  },
  {
    "@type": "Workflow",
    "name": "Update Task Notification",
    "isActive": true,
    "tag": "system,dev",
    "triggerStep": "/api/3/workflow_steps/461d5188-d54c-47e2-a6fd-4f002b1527b1",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "On Task Update",
        "arguments": {
          "resource": "tasks"
        },
        "left": 440,
        "top": 200,
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "461d5188-d54c-47e2-a6fd-4f002b1527b1"
      },
      {
        "@type": "WorkflowStep",
        "name": "Do Nothing",
        "arguments": {
          "script": "https://dev.venom.cyber:8888/wf/workflow/tasks/workflow.tasks.no_op/",
          "arguments": []
        },
        "left": 560,
        "top": 360,
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "d193ce0c-aa90-4054-bd8c-962f80b015eb"
      },
      {
        "@type": "WorkflowStep",
        "name": "Try Email Assigned Person",
        "arguments": {
          "workflowReference": "/api/3/workflows/473494e3-92e7-4f68-9d30-a1392a1cdb56",
          "arguments": []
        },
        "left": 320,
        "top": 360,
        "stepType": "/api/3/workflow_step_types/74932bdc-b8b6-4d24-88c4-1a4dfbc524f3",
        "uuid": "8c4af03b-8234-40cc-a2b7-03ca64759945"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if \"Assigned To Person\" Changed",
        "arguments": {
          "conditions": [
            {
              "condition": "{{ (vars.request.data.assignedToPerson[\'@id\'] != vars.previous.data.assignedToPerson[\'@id\']) }}",
              "step_iri": "/api/3/workflow_steps/8c4af03b-8234-40cc-a2b7-03ca64759945"
            },
            {
              "condition": "{{ true }}",
              "step_iri": "/api/3/workflow_steps/d193ce0c-aa90-4054-bd8c-962f80b015eb"
            }
          ]
        },
        "left": 440,
        "top": 280,
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "2e718b7f-2192-45f8-a6a7-920ede3e7427"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "797fb065-1b2e-44eb-9beb-26cf5013d6fa",
        "name": "On Task Update -> Check if \"Assigned To Person\" Changed",
        "targetStep": "/api/3/workflow_steps/2e718b7f-2192-45f8-a6a7-920ede3e7427",
        "sourceStep": "/api/3/workflow_steps/461d5188-d54c-47e2-a6fd-4f002b1527b1"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "e6b581d5-77a6-410b-859f-693e42145073",
        "name": "Check if \"Assigned To Person\" Changed -> Check Task Assigned Person",
        "targetStep": "/api/3/workflow_steps/8c4af03b-8234-40cc-a2b7-03ca64759945",
        "sourceStep": "/api/3/workflow_steps/2e718b7f-2192-45f8-a6a7-920ede3e7427"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "f588f818-a144-4c98-99d1-5e013b151617",
        "name": "Check if \"Assigned To Person\" Changed -> Do Nothing",
        "targetStep": "/api/3/workflow_steps/d193ce0c-aa90-4054-bd8c-962f80b015eb",
        "sourceStep": "/api/3/workflow_steps/2e718b7f-2192-45f8-a6a7-920ede3e7427"
      }
    ],
    "uuid": "a65f4563-0635-438f-a570-58e329a3ae2f"
  }
]';
    //endregion

    //region Old
    private $oldWorkflow = '{
  "@type": "Workflow",
  "name": "Task Notification Playbook",
  "isActive": true,
  "tag": "system,dev",
  "triggerStep": "/api/3/workflow_steps/a0171aeb-cc64-4cd5-9a1b-d12587d64476",
  "steps": [
    {
      "@type": "WorkflowStep",
      "name": "Task Create Trigger",
      "arguments": {
        "resource": "tasks"
      },
      "left": 380,
      "top": 171,
      "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
      "uuid": "a0171aeb-cc64-4cd5-9a1b-d12587d64476"
    },
    {
      "@type": "WorkflowStep",
      "name": "Check Notification Preferences",
      "arguments": {
        "conditions": [
          {
            "condition": "{{ (vars.request.data.assignedToPerson[\'@settings\'] + \'/user/notifications/email\') | fromIRI }}",
            "step_iri": "/api/3/workflow_steps/463ab331-8c60-412c-a9b4-4bdc1b505e91"
          },
          {
            "condition": "true",
            "step_iri": "/api/3/workflow_steps/adb2ab1b-d6cd-4c9b-a444-50fdb63cf795"
          }
        ]
      },
      "left": 383,
      "top": 287,
      "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
      "uuid": "34659f1d-7583-4f6f-b10f-1ce70c49c23d"
    },
    {
      "@type": "WorkflowStep",
      "name": "Send User Email Step",
      "arguments": {
        "to": [
          "{{ vars.request.data.assignedToPerson.email }}"
        ],
        "from_str": "",
        "content": "Hey {{ vars.request.data.assignedToPerson.firstname }}, the following task has been assigned to you:\n\nTask Name:\n{{ vars.request.data.name }}\n\nYou can view this task by clicking here:\n{% set idParts = vars.request.data[\'@id\'].split(\'/\') %}\n{{ vars.request.baseUri + \'/modules/tasks/\' + (idParts | last) }}\n\nThanks,\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).name }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).url }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).phoneMain }}"
      },
      "left": 271,
      "top": 428,
      "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
      "uuid": "463ab331-8c60-412c-a9b4-4bdc1b505e91"
    },
    {
      "@type": "WorkflowStep",
      "name": "Send Email To Admin Instead",
      "arguments": {
        "to": [
          "soc@cybersponse.com"
        ],
        "from_str": "",
        "content": "Administrator,\n\nThe following task has been assigned to {{ vars.request.data.assignedToPerson.firstname }} {{ vars.request.data.assignedToPerson.lastname }}:\n\nTask Name:\n{{ vars.request.data.name }}\n\nYou can view this task by clicking here:\n{% set idParts = vars.request.data[\'@id\'].split(\'/\') %}\n{{ vars.request.baseUri + \'/modules/tasks/\' + (idParts | last) }}\n\nThanks,\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).name }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).url }}\n   {{ (vars.request.data.assignedToPerson.companyId | fromIRI).phoneMain }}"
      },
      "left": 494,
      "top": 428,
      "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
      "uuid": "adb2ab1b-d6cd-4c9b-a444-50fdb63cf795"
    }
  ],
  "routes": [
    {
      "@type": "WorkflowRoute",
      "uuid": "10ca3f6b-9d9d-4bf1-9e85-3fb5e2c5d10e",
      "targetStep": "/api/3/workflow_steps/adb2ab1b-d6cd-4c9b-a444-50fdb63cf795",
      "sourceStep": "/api/3/workflow_steps/34659f1d-7583-4f6f-b10f-1ce70c49c23d"
    },
    {
      "@type": "WorkflowRoute",
      "uuid": "2ae4e4cf-2f16-4104-8ef2-f481cd5fd14b",
      "targetStep": "/api/3/workflow_steps/463ab331-8c60-412c-a9b4-4bdc1b505e91",
      "sourceStep": "/api/3/workflow_steps/34659f1d-7583-4f6f-b10f-1ce70c49c23d"
    },
    {
      "@type": "WorkflowRoute",
      "uuid": "cd085d45-ff5d-4d82-93d3-8d44e1764c94",
      "targetStep": "/api/3/workflow_steps/34659f1d-7583-4f6f-b10f-1ce70c49c23d",
      "sourceStep": "/api/3/workflow_steps/a0171aeb-cc64-4cd5-9a1b-d12587d64476"
    }
  ],
  "uuid": "78088d8f-a087-4240-9241-fa1fb691384b"
}';
    //endregion

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        //Remove it first
        $this->down($schema);

        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $workflowObjects = $this->container->get('serializer')->deserialize(
            $this->workflows,
            TypeAgnosticCollectionNormalizer::TYPE_AGNOSTIC_TYPE,
            'json-ld'
        );

        /** @var ManagerRegistry $managerRegistry */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());

        //Remove old workflow object for new insertion
        $oldWorkflowObject = $workflowManager->find($workflowResource->getEntityClass(), '78088d8f-a087-4240-9241-fa1fb691384b');
        $workflowManager->remove($oldWorkflowObject);
        $workflowManager->flush();

        $objectsToPersist = [];

        /** @var DenormalizationResultCollection $denormalizationResultCollection */
        foreach($workflowObjects as $resourceName => $denormalizationResultCollection) {
            $objectsToPersist = array_merge($objectsToPersist, array_map(function(DenormalizationResult $denormalizationResult) use ($workflowManager) {
                $workflowManager->persist($denormalizationResult->getResult());
            }, $denormalizationResultCollection->getArrayCopy()));
        }

        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        /** @var ManagerRegistry $managerRegistry */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());

        /** @var EntityRepository $workflowRepository */
        $workflowRepository = $workflowManager->getRepository($workflowResource->getEntityClass());

        $criteria = new Criteria();
        $criteria->where($criteria->expr()->in('uuid', [
            '3b7818e8-acba-4e3f-bf3e-60729023f9f1',
            '473494e3-92e7-4f68-9d30-a1392a1cdb56',
            '78088d8f-a087-4240-9241-fa1fb691384b',
            'a65f4563-0635-438f-a570-58e329a3ae2f'
        ]));

        $workflowsToDelete = $workflowRepository->matching($criteria);

        if (!empty($workflowsToDelete)) {
            foreach($workflowsToDelete as $workflowToDelete) {
                $workflowManager->remove($workflowToDelete);
            }
            $workflowManager->flush();
        }

        $oldWorkflowObject = $this->container->get('serializer')->deserialize(
            $this->oldWorkflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $workflowResource->getDenormalizationContext()
        );

        $workflowManager->persist($oldWorkflowObject);
        $workflowManager->flush();
    }
}
