<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Cybersponse\WorkflowBundle\Entity\WorkflowStep;
use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\Common\Persistence\ObjectManager;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160504230954 extends AbstractMigration implements ContainerAwareInterface
{

    /** @var ContainerInterface */
    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
     * Finds the Fetch Token step of the Password Reset Notification workflow
     * and updates the method to the given $methodName
     *
     * @param string $methodName
     */
    protected function findAndUpdateFetchTokenStep($methodName) {
        /** @var ManagerRegistry $managerRegistry */
        $managerRegistry = $this->container->get('doctrine');

        /** @var ObjectManager $entityManager */
        $entityManager = $managerRegistry->getManagerForClass(WorkflowStep::class);

        /*  @var WorkflowStep $passwordResetStep */
        $passwordResetStep = $entityManager->find(WorkflowStep::class, 'ce9e4698-b2cb-4317-a822-c7d9881a5c92');
        $arguments = $passwordResetStep->getArguments();
        $arguments['arguments']['method'] = $methodName;
        $passwordResetStep->setArguments($arguments);

        $entityManager->persist($passwordResetStep);
        $entityManager->flush();
    }
    
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->findAndUpdateFetchTokenStep('post');
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $this->findAndUpdateFetchTokenStep('get');
    }
}
