<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160623202416 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->renameArguments('resource', 'route');
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $this->renameArguments('route', 'resource');
    }

    /**
     * @param $fromString
     * @param $toString
     */
    private function renameArguments($fromString, $toString)
    {
        $fetchResults = $this->connection->fetchAll("SELECT uuid, arguments FROM workflow_steps WHERE steptype_uuid = 'df26c7a2-4166-4ca5-91e5-548e24c01b5f'");
        foreach ($fetchResults as $fetchResult) {
            $arguments = $fetchResult['arguments'];

            if (is_null($arguments)) {
                continue;
            }

            $argumentsJson = json_decode($arguments, true);
            if (!array_key_exists($fromString, $argumentsJson)) {
                continue;
            }

            $argumentsJson[$toString] = $argumentsJson[$fromString];
            unset($argumentsJson[$fromString]);
            $this->addSql("UPDATE workflow_steps SET arguments = :arguments WHERE uuid = :uuid;", [
                'arguments' => json_encode($argumentsJson),
                'uuid' => $fetchResult['uuid']
            ]);
        }
    }
}
