<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160714043437 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // First, Criticality had an item missing a color, so give it one
        $this->addSql('UPDATE picklists 
                       SET color = \'#1e2124\'
                       WHERE uuid = \'fc5d4398-8920-4f3a-abe9-dd445b849454\'');
        
        // For any picklist in which not all items have a color assigned to them,
        // set all colors to null
        $this->addSql('UPDATE picklists 
                       SET color = NULL 
                       WHERE listname NOT IN (
                           SELECT pn.uuid 
                           FROM picklist_names pn
                           JOIN picklists p ON pn.uuid = p.listname 
                           GROUP BY pn.uuid
                           HAVING EVERY(p.color IS NOT NULL)
                       );');
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // Return the 'None' option of Criticality back to null color
        $this->addSql('UPDATE picklists 
                       SET color = NULL
                       WHERE uuid = \'fc5d4398-8920-4f3a-abe9-dd445b849454\'');
        
        // Picklists with an incomplete set of colors had all colors blown away,
        // so can't down those
    }
}