<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Symfony\Component\Console\Application;
use Symfony\Component\Console\Input\ArrayInput;
use Symfony\Component\Console\Output\BufferedOutput;
use Symfony\Component\Console\Output\NullOutput;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160715233124 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $environment = $this->container->getParameter('kernel.environment');
        $command = sprintf('/usr/bin/php -d xdebug.remote_enable=0 app/console fos:elastica:populate --env=%s --index=files', $environment);
        exec($command, $output, $errorCode);

        if ($errorCode !== 0) {
            throw new \Exception(sprintf('Could not reset the files index. Message: %s', json_encode($output, true)));
        }
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // None
    }
}
