<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20160818023909 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addSql("CREATE TABLE backups.\"20160818023909_modules\"
                       (
                         uuid VARCHAR(36),
                         name VARCHAR(255),
                         description TEXT
                       );
                       
                       INSERT INTO backups.\"20160818023909_modules\" (uuid, name, description)
                         SELECT uuid, name, description FROM public.modules;
                       
                       ALTER TABLE public.module_permissions DROP CONSTRAINT fk_a3c6c6bd6b4315aa;
                       ALTER TABLE public.module_permissions
                         ADD CONSTRAINT fk_a3c6c6bd6b4315aa
                       FOREIGN KEY (module_uuid) REFERENCES modules (uuid) ON UPDATE CASCADE;
                       
                       ALTER TABLE modules ADD system BOOLEAN DEFAULT NULL;
                       ALTER TABLE modules ADD type VARCHAR(255) DEFAULT NULL;
                       ALTER TABLE public.modules ALTER COLUMN description TYPE TEXT USING description::TEXT;
                       UPDATE public.modules SET system = false WHERE name not in ('application', 'security', 'workflows', 'files', 'activities', 'reporting');
                       
                       UPDATE modules SET type = name;
                       
                       UPDATE modules SET name = description, description = CONCAT('Allows interactions with the ', description, ' Module') WHERE type not in ('application', 'security', 'workflows', 'files', 'activities', 'reporting');
                       
                       UPDATE modules SET uuid = '9df920ef-d564-4591-9283-76882ca38b9c', name = 'Application', system = True, description = 'Allows interactions with Application Modules (Pick Lists, Modules, View Templates, System Settings, Model Metadata, Grid/Graph Queries). \"Read\" + \"Update\" permissions will make the Application Administration page visible to a user. \"Read\" access required for basic interaction with the application interface for all human users. \"Update\" access for modifying application configuration.' WHERE type = 'application';
                       UPDATE modules SET uuid = 'd9b38047-86ad-4988-895e-e6f04e5bc91f', name = 'Security', system = True, description = 'Allows interactions with Security Modules (Teams, Team Hieararchy, Roles, User Authentication, Appliances). \"Read\" is required for users to be able to see which teams own a record. \"Read\" + \"Update\" permissions will make the Security Administration pages visible to a user and should only be applied to users tasked with managing application access.' WHERE type = 'security';
                       UPDATE modules SET uuid = '326583bc-6211-414f-b8fa-0018f6612e49', name = 'Playbooks', system = True, description = 'Allows interactions with Playbook Modules (Playbooks, Steps, Routes, Collections). \"Read\" permission will make the Playbook Designer visible to a user, but will not allow in-depth viewing of steps. \"Update\" is required for modification.' WHERE type = 'workflows';
                       UPDATE modules SET uuid = 'e1049b52-3ecb-4109-b18e-581599d1af6b', name = 'Files', system = True, description = 'Allows interactions with Files (the actual binaries associated with Attachments)' WHERE type = 'files';
                       UPDATE modules SET uuid = 'abf8fa08-76cf-4751-957e-0dd7d1927863', name = 'Audit Log Activities', system = True, description = 'Allows viewing of Audit Log Activities' WHERE type = 'activities';
                       UPDATE modules SET uuid = '9154e0a8-d9e9-4315-a975-1ff5a9c5d832', name = 'Reporting', system = True, description = 'Allows interactions with the Reporting Engine' WHERE type = 'reporting';
                       
                       ALTER TABLE public.module_permissions DROP CONSTRAINT fk_a3c6c6bd6b4315aa;
                       ALTER TABLE public.module_permissions
                         ADD CONSTRAINT fk_a3c6c6bd6b4315aa
                       FOREIGN KEY (module_uuid) REFERENCES modules (uuid);");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $this->addSql("ALTER TABLE public.module_permissions DROP CONSTRAINT fk_a3c6c6bd6b4315aa;
                       ALTER TABLE public.module_permissions
                         ADD CONSTRAINT fk_a3c6c6bd6b4315aa
                       FOREIGN KEY (module_uuid) REFERENCES modules (uuid) ON UPDATE CASCADE;
                       
                       UPDATE modules SET description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = modules.type;
                       
                       UPDATE modules SET uuid = backup.uuid, name = backup.name, description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = 'application' AND backup.name = modules.type; 
                       UPDATE modules SET uuid = backup.uuid, name = backup.name, description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = 'security' AND backup.name = modules.type; 
                       UPDATE modules SET uuid = backup.uuid, name = backup.name, description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = 'workflows' AND backup.name = modules.type; 
                       UPDATE modules SET uuid = backup.uuid, name = backup.name, description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = 'files' AND backup.name = modules.type; 
                       UPDATE modules SET uuid = backup.uuid, name = backup.name, description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = 'activities' AND backup.name = modules.type; 
                       UPDATE modules SET uuid = backup.uuid, name = backup.name, description = backup.description FROM backups.\"20160818023909_modules\" as backup WHERE backup.name = 'reporting' AND backup.name = modules.type; 
                       
                       ALTER TABLE public.module_permissions DROP CONSTRAINT fk_a3c6c6bd6b4315aa;
                       ALTER TABLE public.module_permissions
                         ADD CONSTRAINT fk_a3c6c6bd6b4315aa
                       FOREIGN KEY (module_uuid) REFERENCES modules (uuid);
                       
                       UPDATE modules SET name = type;
                       ALTER TABLE public.modules DROP COLUMN system;
                       ALTER TABLE public.modules DROP COLUMN type;
                       ALTER TABLE public.modules ALTER COLUMN description TYPE VARCHAR(255);
                       
                       DROP TABLE backups.\"20160818023909_modules\";");
    }
}
