<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20170424072401 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {

        $this->addSql(" CREATE TABLE public.workflow_versions (
            uuid character varying(36) NOT NULL,
            createuser character varying(36) DEFAULT NULL::character varying,
            workflow_uuid character varying(36) DEFAULT NULL::character varying,
            modifyuser character varying(36) DEFAULT NULL::character varying,
            createdate timestamp(0) without time zone DEFAULT NULL::timestamp without time zone,
            note character varying(255) DEFAULT NULL::character varying,
            json jsonb,
            autosave boolean DEFAULT false NOT NULL,
            id integer NOT NULL,
            modifydate timestamp(0) without time zone DEFAULT NULL::timestamp without time zone
        );");

        $this->addSql("ALTER TABLE public.workflow_versions OWNER TO cyberpgsql;");
        $this->addSql("ALTER TABLE public.workflow_versions ADD CONSTRAINT workflow_versions_pkey PRIMARY KEY (uuid);");
        $this->addSql("ALTER TABLE public.workflow_versions ADD CONSTRAINT fk_d2bfbfc8887e6918 FOREIGN KEY (modifyuser) REFERENCES public.actors(uuid) ON DELETE SET NULL;");
        $this->addSql("ALTER TABLE public.workflow_versions ADD CONSTRAINT fk_d2bfbfc894e0409d FOREIGN KEY (workflow_uuid) REFERENCES public.workflows(uuid);");
        $this->addSql("ALTER TABLE public.workflow_versions ADD CONSTRAINT fk_d2bfbfc8df736b67 FOREIGN KEY (createuser) REFERENCES public.actors(uuid) ON DELETE SET NULL;");

        $this->addSql("ALTER TABLE workflows ADD COLUMN createuser varchar(36) NULL;");
        $this->addSql("ALTER TABLE workflows ADD COLUMN modifyuser varchar(36) NULL;");
        $this->addSql("ALTER TABLE workflows ADD COLUMN createdate TIMESTAMP(0) WITHOUT TIME ZONE NULL;");
        $this->addSql("ALTER TABLE workflows ADD COLUMN modifydate TIMESTAMP(0) WITHOUT TIME ZONE NULL;");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $this->addSql("ALTER TABLE public.workflow_versions DROP CONSTRAINT workflow_versions_pkey;");
        $this->addSql("ALTER TABLE public.workflow_versions DROP CONSTRAINT fk_d2bfbfc8887e6918;");
        $this->addSql("ALTER TABLE public.workflow_versions DROP CONSTRAINT fk_d2bfbfc894e0409d;");
        $this->addSql("ALTER TABLE public.workflow_versions DROP CONSTRAINT fk_d2bfbfc8df736b67;");
        $this->addSql("DROP TABLE IF EXISTS public.workflow_versions;");
        $this->addSql("ALTER TABLE workflows DROP COLUMN createuser;");
        $this->addSql("ALTER TABLE workflows DROP COLUMN modifyuser;");
        $this->addSql("ALTER TABLE workflows DROP COLUMN createdate;");
        $this->addSql("ALTER TABLE workflows DROP COLUMN modifydate;");
    }
}
