<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20170505070337 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->renameArguments("", "do-not-reply@cybersponse.com");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $this->renameArguments("do-not-reply@cybersponse.com", "");
    }

    /**
     * @param $fromString
     * @param $toString
     */
    private function renameArguments($emailId, $emaiIdOld)
    {
        $fetchResults = $this->connection->fetchAll("SELECT uuid, arguments FROM public.workflow_steps where arguments @> '{\"from_str\":\"".$emaiIdOld."\"}'");
        foreach ($fetchResults as $fetchResult) {
            $arguments = $fetchResult['arguments'];

            if (is_null($arguments)) {
                continue;
            }

            $argumentsJson = json_decode($arguments, true);
            if (!array_key_exists('from_str', $argumentsJson)) {
                continue;
            }

            $argumentsJson['from_str'] = $emailId;
            $this->addSql("UPDATE workflow_steps SET arguments = :arguments WHERE uuid = :uuid;", [
                'arguments' => json_encode($argumentsJson),
                'uuid' => $fetchResult['uuid']
            ]);
        }
    }}
