<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20171206120901 extends AbstractMigration implements ContainerAwareInterface
{

    /** @var ContainerInterface */
    private $container;

    protected $picklistJsonRunning = '
  {
    "itemValue": "Running",
    "orderIndex": 1,
    "color": "#46a31a",
    "icon": null,
    "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
    "uuid": "c7e3ac7c-9556-4fae-9899-0394ce982f0a"
  }
';

    protected $picklistJsonStopped = '{
        "uuid": "8eb5d9e6-176f-41ee-92e6-cda1c5dec7fc",
        "@type": "Picklist",
        "icon": null,
        "itemValue": "Stopped",
        "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
        "id": 290,
        "color": "#a82f14",
        "orderIndex": 2
    }';

    protected $picklistJsonDraft = '{
        "uuid": "51c7463e-571c-4788-bc09-fbda4d864ad0",
        "@type": "Picklist",
        "icon": null,
        "itemValue": "Draft",
        "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
        "id": 289,
        "color": "#949494",
        "orderIndex": 0
    }';

    protected $picklistNameJson = '{
				"name": "SchedularStatus",
				"uuid": "fcefb7d8-2bf3-4505-967f-443ffc396034"
			}';


    private $workflowJson=[
        '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "03 Refresh Schedule",
    "description": "Update the details of the schedule",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system,dev,schedule",
    "isActive": true,
    "parameters": [

    ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/f5840d4d-0555-4c3c-8cff-c6755445f1a4",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Call Map playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/map",
          "arguments": {
            "collection": "{{vars.request.data.records}}",
            "workflow_iri": "/api/3/workflows/ad09d809-0339-4ef1-819b-3b3ae398003c"
          }
},
"status": null,
        "left": "106",
        "top": "160",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "5fc36d83-dc6e-49b4-b3aa-fbcf5980798f"
      },
      {
          "@type": "WorkflowStep",
        "name": "start trigger",
        "arguments": {
          "route": "b8bc4b68-c6fa-4c1f-bb19-505bee12c88f",
          "title": "Update Schedule",
          "resources": [
              "schedules"
          ],
          "inputVariables": [

          ]
        },
        "status": null,
        "left": "120",
        "top": "8",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "f5840d4d-0555-4c3c-8cff-c6755445f1a4"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "a18c5780-ef09-4bf6-b01a-e691977579e5",
        "name": "start trigger -> Call Map playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/5fc36d83-dc6e-49b4-b3aa-fbcf5980798f",
        "sourceStep": "/api/3/workflow_steps/f5840d4d-0555-4c3c-8cff-c6755445f1a4"
      }
    ],
    "uuid": "059d1d15-4ba3-4ee2-8426-2431ec4cbf63"
  }',
        '{
      "@type": "Workflow",
    "triggerLimit": null,
    "name": "05 Stop Schedule",
    "description": "Stops the schedule",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system,dev,schedule",
    "isActive": true,
    "parameters": [

  ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/91a452d0-01b3-4023-b7a8-53914414394e",
    "steps": [
      {
          "@type": "WorkflowStep",
        "name": "start trigger",
        "arguments": {
          "route": "04c4a1c0-f343-437c-95d9-e1e1f76146ad",
          "title": "Stop Schedule",
          "resources": [
              "schedules"
          ],
          "inputVariables": [

          ]
        },
        "status": null,
        "left": "40",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "91a452d0-01b3-4023-b7a8-53914414394e"
      },
      {
          "@type": "WorkflowStep",
        "name": "Call Map playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/map",
          "arguments": {
              "collection": "{{vars.request.data.records}}",
            "workflow_iri": "/api/3/workflows/f1a3e870-7410-4a9f-bb58-579e24f9ad11"
          }
        },
        "status": null,
        "left": "40",
        "top": "200",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "bfba09c0-5ca8-4c0f-b47b-df974d664f30"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "aa4999a0-ca06-4d4f-bcaf-3093fa361be0",
        "name": "start trigger -> Call Map playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/bfba09c0-5ca8-4c0f-b47b-df974d664f30",
        "sourceStep": "/api/3/workflow_steps/91a452d0-01b3-4023-b7a8-53914414394e"
      }
    ],
    "uuid": "5beda203-0dbf-481f-afdd-a7e07f1f93fd"
  }',
        '{
      "@type": "Workflow",
    "triggerLimit": null,
    "name": "02 Start Schedule(Child)",
    "description": "System playbook for starting schedule",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system, dev, schedule",
    "isActive": true,
    "parameters": [

  ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/ba23abf6-f448-47d9-822e-a0a27c03f188",
    "steps": [
      {
          "@type": "WorkflowStep",
        "name": "Start",
        "arguments": [

      ],
        "status": null,
        "left": "146",
        "top": "0",
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "ba23abf6-f448-47d9-822e-a0a27c03f188"
      },
      {
          "@type": "WorkflowStep",
        "name": "Start periodic playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/start_periodic",
          "arguments": {
              "schedule": "{{vars.loop_resource.cronexpression}}",
            "workflow_iri": "/api/3/workflows/{{vars.loop_resource.uuidofplaybook}}"
          }
        },
        "status": null,
        "left": "20",
        "top": "286",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "e8c07654-37d8-42e3-9943-8ea4a9bb58aa"
      },
      {
          "@type": "WorkflowStep",
        "name": "Get child PB data",
        "arguments": {
          "uuid_of_pb": "{{vars.loop_resource.uuidofplaybook}}",
          "cron_expression": "{{vars.loop_resource.cronexpression}}",
          "loop_resource_id": "{{vars.loop_resource[\'@id\']}}",
          "scheduler_status": "{{vars.loop_resource.schedularStatus[\'@id\']}}"
        },
        "status": null,
        "left": "150",
        "top": "80",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "3309d41f-c45e-47f0-bced-2ab1cca48ab9"
      },
      {
          "@type": "WorkflowStep",
        "name": "Update Schedule Record",
        "arguments": {
          "resource": "{\'schedulestart\':\'{     {       arrow.utcnow().timestamp     }   }\',\'cronJobId\':\'{{vars.result}}\',\'schedularStatus\':\'/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\'}",
          "collection": "{{vars.loop_resource_id}}"
        },
        "status": null,
        "left": "40",
        "top": "388",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "770ef45c-da2b-484d-bf0a-5c54d9ec5b55"
      },
      {
          "@type": "WorkflowStep",
        "name": "Error message",
        "arguments": {
          "script": "/wf/workflow/tasks/panic",
          "arguments": {
              "msg": "\"Currently running schedules cannot be re-started. Please Verify!\""
          }
        },
        "status": null,
        "left": "469",
        "top": "340",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "ed0ad42c-cf9a-4a83-9488-9112d3deb528"
      },
      {
          "@type": "WorkflowStep",
        "name": "Is Scheduler Running",
        "arguments": {
          "conditions": [
            {
                "step_iri": "/api/3/workflow_steps/e8c07654-37d8-42e3-9943-8ea4a9bb58aa",
              "condition": "{{ vars.loop_resource.schedularStatus[\'@id\']  != \'/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\' }}"
            },
            {
                "step_iri": "/api/3/workflow_steps/ed0ad42c-cf9a-4a83-9488-9112d3deb528",
              "condition": "{{ vars.loop_resource.schedularStatus[\'@id\']  == \'/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\' }}"
            }
          ]
        },
        "status": null,
        "left": "129",
        "top": "168",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "033ca95d-655f-4ad3-b80f-e2743ea19042"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "1bcfacfd-f13c-4a15-b0bd-b00c2b40f8c0",
        "name": "Is Scheduler Running -> Start periodic playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/e8c07654-37d8-42e3-9943-8ea4a9bb58aa",
        "sourceStep": "/api/3/workflow_steps/033ca95d-655f-4ad3-b80f-e2743ea19042"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "7dfcb2dc-ee52-4703-9c5a-16dc244db049",
        "name": "Start periodic playbook -> Update Schedule Record",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/770ef45c-da2b-484d-bf0a-5c54d9ec5b55",
        "sourceStep": "/api/3/workflow_steps/e8c07654-37d8-42e3-9943-8ea4a9bb58aa"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "fa268714-13ee-4da2-929c-ecd11e03b8c0",
        "name": "Start -> Get child PB data",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/3309d41f-c45e-47f0-bced-2ab1cca48ab9",
        "sourceStep": "/api/3/workflow_steps/ba23abf6-f448-47d9-822e-a0a27c03f188"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "31a80720-f319-4a6e-8723-b92eae23cf0d",
        "name": "Get child PB data -> Is Scheduler Running",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/033ca95d-655f-4ad3-b80f-e2743ea19042",
        "sourceStep": "/api/3/workflow_steps/3309d41f-c45e-47f0-bced-2ab1cca48ab9"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "daedd86b-407c-4a1c-8b77-7181330dd1ba",
        "name": "Is Scheduler Running -> Error message",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/ed0ad42c-cf9a-4a83-9488-9112d3deb528",
        "sourceStep": "/api/3/workflow_steps/033ca95d-655f-4ad3-b80f-e2743ea19042"
      }
    ],
    "uuid": "6c1a4f1c-2a9b-4d35-889b-c858f9bcc45d"
  }',
        '{
      "@type": "Workflow",
    "triggerLimit": null,
    "name": "07 Set Default Status To Draft",
    "description": "System post create trigger playbook to set default scheduler status to Draft as soon as user creates the record",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system,dev,schedule",
    "isActive": true,
    "parameters": [

  ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/7b8427cd-e269-4ea4-bd83-bd97d95bbedd",
    "steps": [
      {
          "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "schedules"
        },
        "status": null,
        "left": "173",
        "top": "40",
        "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
        "uuid": "7b8427cd-e269-4ea4-bd83-bd97d95bbedd"
      },
      {
          "@type": "WorkflowStep",
        "name": "Update Status To Draft",
        "arguments": {
          "resource": "{\'schedularStatus\' : \'/api/3/picklists/51c7463e-571c-4788-bc09-fbda4d864ad0\'}",
          "collection": "{{vars.request.data[\'@id\']}}"
        },
        "status": null,
        "left": "160",
        "top": "170",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "783318a0-fdcd-43ed-aad0-c2b9d0eee4ee"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "b9ae7f7b-9cf0-430e-abab-e1e8a93359b4",
        "name": "Start -> update",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/783318a0-fdcd-43ed-aad0-c2b9d0eee4ee",
        "sourceStep": "/api/3/workflow_steps/7b8427cd-e269-4ea4-bd83-bd97d95bbedd"
      }
    ],
    "uuid": "a507278b-b8ee-4b0f-9765-845e384dbb2a"
  }',
        '{
      "@type": "Workflow",
    "triggerLimit": null,
    "name": "04 Refresh Schedule (child)",
    "description": "System playbook for updating cron job information for periodic playbooks",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system, dev, schedule",
    "isActive": true,
    "parameters": [

  ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/28b80261-2165-42e5-a2f0-1bac52a21f98",
    "steps": [
      {
          "@type": "WorkflowStep",
        "name": "Start",
        "arguments": [

      ],
        "status": null,
        "left": "180",
        "top": "7",
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "28b80261-2165-42e5-a2f0-1bac52a21f98"
      },
      {
          "@type": "WorkflowStep",
        "name": "GET CRON JOB INFO1",
        "arguments": {
          "script": "/wf/workflow/tasks/api_call",
          "arguments": {
              "url": "{{vars.request.baseUri}}/wf/api/scheduled/{{vars.loop_resource.cronJobId}}/?format=json",
            "body": "",
            "method": "GET",
            "params": "",
            "verify": "False",
            "headers": "",
            "password": "",
            "username": "",
            "auth_config": ""
          }
        },
        "status": null,
        "left": "160",
        "top": "110",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "f8dc39d3-dc60-4993-895d-b43cfdda5d28"
      },
      {
          "@type": "WorkflowStep",
        "name": "Uodate Schedule",
        "arguments": {
          "resource": "{\'totalRunCount\':\"{{vars.totalRunCount}}\",\'workflowName\':\"{{vars.workflowName}}\", \'lastRunAt\':\"{{arrow.get(vars.lastRunAt).timestamp}}\"}",
          "collection": "{{vars.loop_resource[\'@id\']}}"
        },
        "status": null,
        "left": "152",
        "top": "346",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "e4798648-f997-4808-8de7-920cb99d5918"
      },
      {
          "@type": "WorkflowStep",
        "name": "Get Date",
        "arguments": {
          "lastRunAt": "{{vars.result.last_run_at}}",
          "workflowName": "{{vars.result.workflow_name}}",
          "totalRunCount": "{{vars.result.total_run_count}}"
        },
        "status": null,
        "left": "180",
        "top": "226",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "cfbcd4ee-7475-44b3-9829-4a8d82030f14"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "722c35f4-6731-4beb-907e-fda166b95588",
        "name": "GET CRON JOB INFO1 -> Get Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/cfbcd4ee-7475-44b3-9829-4a8d82030f14",
        "sourceStep": "/api/3/workflow_steps/f8dc39d3-dc60-4993-895d-b43cfdda5d28"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "ab6c88d0-15b0-439b-86ad-3c068e0aac32",
        "name": "Get Date -> Uodate Schedule",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/e4798648-f997-4808-8de7-920cb99d5918",
        "sourceStep": "/api/3/workflow_steps/cfbcd4ee-7475-44b3-9829-4a8d82030f14"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "559e7280-fed6-4d26-ae51-4d40e0b7ff27",
        "name": "Start -> GET CRON JOB INFO1",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/f8dc39d3-dc60-4993-895d-b43cfdda5d28",
        "sourceStep": "/api/3/workflow_steps/28b80261-2165-42e5-a2f0-1bac52a21f98"
      }
    ],
    "uuid": "ad09d809-0339-4ef1-819b-3b3ae398003c"
  }',
        '{
      "@type": "Workflow",
    "triggerLimit": null,
    "name": "01 Start Shedule",
    "description": "Starts the schedule",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system,dev,schedule",
    "isActive": true,
    "parameters": [

  ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/678f1cd2-fdf2-4608-adec-ff0fc33fed26",
    "steps": [
      {
          "@type": "WorkflowStep",
        "name": "Call Map playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/map",
          "arguments": {
              "collection": "{{vars.request.data.records}}",
            "workflow_iri": "/api/3/workflows/6c1a4f1c-2a9b-4d35-889b-c858f9bcc45d"
          }
        },
        "status": null,
        "left": "260",
        "top": "160",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "4fd4c80c-dfa0-4817-9679-9a458e01dce8"
      },
      {
          "@type": "WorkflowStep",
        "name": "start trigger",
        "arguments": {
          "route": "d156bc7f-9f0a-4304-a53c-b8566a531906",
          "title": "Start Schedule",
          "resources": [
              "schedules"
          ],
          "inputVariables": [

          ]
        },
        "status": null,
        "left": "260",
        "top": "9",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "678f1cd2-fdf2-4608-adec-ff0fc33fed26"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "8d9f002d-3d73-4a13-9aca-7acf8fad1791",
        "name": "start trigger -> Call Map playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/4fd4c80c-dfa0-4817-9679-9a458e01dce8",
        "sourceStep": "/api/3/workflow_steps/678f1cd2-fdf2-4608-adec-ff0fc33fed26"
      }
    ],
    "uuid": "ebda6780-4eaf-47de-9a68-20a50b1ae8a2"
  }',
        '{
      "@type": "Workflow",
    "triggerLimit": null,
    "name": "06 Stop Schedule (Child)",
    "description": "System playbook to stop running playbook",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system, dev, schedule",
    "isActive": true,
    "parameters": [

  ],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/00924d10-5c78-444d-a378-fb67c523227e",
    "steps": [
      {
          "@type": "WorkflowStep",
        "name": "Stop Periodic Playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/stop_periodic",
          "arguments": {
              "redis_schedule_entry_id": "{{vars.loop_resource.cronJobId}}"
          }
        },
        "status": null,
        "left": "10",
        "top": "240",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "57f2eff6-feb7-4821-aafd-0376224a475f"
      },
      {
          "@type": "WorkflowStep",
        "name": "Do Nothing",
        "arguments": {
          "script": "/wf/workflow/tasks/no_op",
          "arguments": [

          ]
        },
        "status": null,
        "left": "320",
        "top": "240",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "21067ccd-d7a6-48a4-8813-37002dbe3345"
      },
      {
          "@type": "WorkflowStep",
        "name": "Is Scheduler Running",
        "arguments": {
          "conditions": [
            {
                "step_iri": "/api/3/workflow_steps/21067ccd-d7a6-48a4-8813-37002dbe3345",
              "condition": "{{ vars.loop_resource.schedularStatus[\'@id\'] != \'/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\' }}"
            },
            {
                "step_iri": "/api/3/workflow_steps/57f2eff6-feb7-4821-aafd-0376224a475f",
              "condition": "{{ vars.loop_resource.schedularStatus[\'@id\'] == \'/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\' }}"
            }
          ]
        },
        "status": null,
        "left": "174",
        "top": "100",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "a3a9d5d9-2193-4820-9d72-e69b591c06a6"
      },
      {
          "@type": "WorkflowStep",
        "name": "Start",
        "arguments": [

      ],
        "status": null,
        "left": "191",
        "top": "0",
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "00924d10-5c78-444d-a378-fb67c523227e"
      },
      {
          "@type": "WorkflowStep",
        "name": "Update Schedule",
        "arguments": {
          "resource": "{\'schedularStatus\' : \'/api/3/picklists/8eb5d9e6-176f-41ee-92e6-cda1c5dec7fc\'}",
          "collection": "{{vars.loop_resource[\'@id\']}}"
        },
        "status": null,
        "left": "40",
        "top": "360",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "c72b9274-d69f-4b23-a7f8-1fdab0b0ea0e"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "93020dfd-d2a9-41e3-b6a1-a8cbb7d07e8a",
        "name": "Is Scheduler Running -> Stop Periodic Playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/57f2eff6-feb7-4821-aafd-0376224a475f",
        "sourceStep": "/api/3/workflow_steps/a3a9d5d9-2193-4820-9d72-e69b591c06a6"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "34e74918-8af2-4027-aa50-43887814849f",
        "name": "Is Scheduler Running -> Do Nothing",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/21067ccd-d7a6-48a4-8813-37002dbe3345",
        "sourceStep": "/api/3/workflow_steps/a3a9d5d9-2193-4820-9d72-e69b591c06a6"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "63bb8d60-125c-4582-974a-fabd4a2ea25f",
        "name": "Stop Periodic Playbook -> Update Schedule",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/c72b9274-d69f-4b23-a7f8-1fdab0b0ea0e",
        "sourceStep": "/api/3/workflow_steps/57f2eff6-feb7-4821-aafd-0376224a475f"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "6e1f30dd-2570-413e-8ccc-a95dd83063b2",
        "name": "Start -> Is Scheduler Running",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/a3a9d5d9-2193-4820-9d72-e69b591c06a6",
        "sourceStep": "/api/3/workflow_steps/00924d10-5c78-444d-a378-fb67c523227e"
      }
    ],
    "uuid": "f1a3e870-7410-4a9f-bb58-579e24f9ad11"
  }'
    ];


    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workFlowJson = (array)  json_decode($workflow);
        $workflowId = $workFlowJson['uuid'];
        $fetchResults = $this->connection->fetchAll("select * from workflows where uuid = '$workflowId'");
        $this->skipIf(sizeof($fetchResults)>0, "Workflow collection with UUID $workflowId present in system.");
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;

        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());

        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function addPicklist(){


        $fetchResults = $this->connection->fetchAll("select * from picklist_names where uuid='fcefb7d8-2bf3-4505-967f-443ffc396034'");
        $this->skipIf(sizeof($fetchResults)>0, "SchedulerStatus Picklist collection with UUID fcefb7d8-2bf3-4505-967f-443ffc396034 present in system.");

        /** @var ResourceInterface $picklistResource */
        $picklistResource = $this->container->get('resource.picklist');

        $context = $picklistResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;

        $picklistDraftObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonDraft,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistRunningObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonRunning,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistStoppedObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonStopped,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );


        /** @var ResourceInterface $picklistNameResource */
        $picklistNameResource = $this->container->get('resource.picklistnames');

        $contextName = $picklistNameResource->getDenormalizationContext();
        $contextName["ignore_field_authorization"] = true;
        $contextName["ignore_authorization"] = true;

        $picklistNameObject = $this->container->get('serializer')->deserialize(
            $this->picklistNameJson,
            $picklistNameResource->getEntityClass(),
            'json-ld',
            $contextName
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        /** @var ObjectManager $picklistManager */
        $picklistManager = $managerRegistry->getManagerForClass($picklistResource->getEntityClass());

        $picklistManager->persist($picklistDraftObject);
        $picklistManager->persist($picklistStoppedObject);
        $picklistManager->persist($picklistRunningObject);
        $picklistManager->persist($picklistNameObject);
        $picklistManager->flush();
    }

    public function up(Schema $schema)
    {
        $this->addPicklist();
        //Insert System Scheduler Collection
        foreach($this->workflowJson as $workflow ){
            $this->addWorkflow($workflow);
        }
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);

        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }



    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {

        //remove picklist
        /** @var ResourceInterface $picklistResource */
        $picklistResource = $this->container->get('resource.picklist');

        $managerRegistry = $this->container->get('doctrine');
        /** @var ObjectManager $picklistManager */
        $picklistManager = $managerRegistry->getManagerForClass($picklistResource->getEntityClass());

        /** @var Picklist $picklistToDelete */
        $picklistToDelete = $picklistManager->find($picklistResource->getEntityClass(), 'fcefb7d8-2bf3-4505-967f-443ffc396034');
        $picklistManager->remove($picklistToDelete);
        $picklistManager->remove($picklistToDelete->getListName());

        $picklistManager->flush();

        $workflowIds = ['059d1d15-4ba3-4ee2-8426-2431ec4cbf63',
            '5beda203-0dbf-481f-afdd-a7e07f1f93fd',
            '6c1a4f1c-2a9b-4d35-889b-c858f9bcc45d',
            'a507278b-b8ee-4b0f-9765-845e384dbb2a',
            'ad09d809-0339-4ef1-819b-3b3ae398003c',
            'ebda6780-4eaf-47de-9a68-20a50b1ae8a2',
            'f1a3e870-7410-4a9f-bb58-579e24f9ad11'];

        foreach($workflowIds as $workflowId ){
            error_log($workflowId);
            $this->deleteWorkflow($workflowId);
        }
    }
}
