<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180131164300 extends AbstractMigration implements ContainerAwareInterface
{

    /** @var ContainerInterface */
    private $container;

    private $taskCreateNotificationPlaybook = '{
  "@type": "Workflow",
  "triggerLimit": null,
  "name": "Tasks: Create Notification",
  "description": null,
  "collection": "/api/3/workflow_collections/6368061c-c6ea-462b-b33f-75437efb0e3b",
  "tag": "system,dev",
  "isActive": true,
  "parameters": [],
  "synchronous": false,
  "triggerStep": "/api/3/workflow_steps/7ce10c45-0d87-4765-9d22-755e1e4bfabc",
  "steps": [
    {
      "@type": "WorkflowStep",
      "name": "Start",
      "arguments": {
        "resource": "tasks"
      },
      "status": null,
      "left": "313",
      "top": "187",
      "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
      "uuid": "7ce10c45-0d87-4765-9d22-755e1e4bfabc"
    },
    {
      "@type": "WorkflowStep",
      "name": "Check Task Assigned Person",
      "arguments": {
        "arguments": [],
        "workflowReference": "/api/3/workflows/473494e3-92e7-4f68-9d30-a1392a1cdb56"
      },
      "status": null,
      "left": "311",
      "top": "312",
      "stepType": "/api/3/workflow_step_types/74932bdc-b8b6-4d24-88c4-1a4dfbc524f3",
      "uuid": "c52547af-3793-4631-af3e-851f44310abc"
    }
  ],
  "routes": [
    {
      "@type": "WorkflowRoute",
      "uuid": "66e99828-f364-46dc-bda6-026da5830abc",
      "name": "Start -> Check Task Assigned Person",
      "isExecuted": false,
      "targetStep": "/api/3/workflow_steps/c52547af-3793-4631-af3e-851f44310abc",
      "sourceStep": "/api/3/workflow_steps/7ce10c45-0d87-4765-9d22-755e1e4bfabc"
    }
  ],
  "uuid": "3b7818e8-acba-4e3f-bf3e-60729023f9g3"
}';

    private $NotificationJson = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Tasks: Notify if Assigned",
    "description": null,
    "collection": "/api/3/workflow_collections/6368061c-c6ea-462b-b33f-75437efb0e3b",
    "tag": "abstract,system,dev",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/fcabbe4e-a644-4995-81fc-5545cb370e60",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Check Notification Preferences",
        "arguments": {
          "conditions": [
            {
              "step_iri": "/api/3/workflow_steps/a44cecde-c105-486f-92ec-f7e8eeb450f2",
              "condition": "{{ (vars.request.data.assignedToPerson[\'@settings\'] + \'/user/notifications/email\') | fromIRI }}"
            },
            {
              "step_iri": "/api/3/workflow_steps/5fa79dea-1e4a-4fd1-b839-0fad3c33e069",
              "condition": "{{ True }}"
            }
          ]
        },
        "status": null,
        "left": "549",
        "top": "420",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "5f0016c6-0316-47b0-b521-198bcab0c73e"
      },
      {
        "@type": "WorkflowStep",
        "name": "Do Nothing",
        "arguments": {
          "script": "/wf/workflow/tasks/no_op",
          "arguments": []
        },
        "status": null,
        "left": "240",
        "top": "420",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "be5a6af3-bd28-4cba-9315-22a7e4e32ecd"
      },
      {
        "@type": "WorkflowStep",
        "name": "On Task Event",
        "arguments": [],
        "status": null,
        "left": "380",
        "top": "189",
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "fcabbe4e-a644-4995-81fc-5545cb370e60"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if AssignedToPerson is Set",
        "arguments": {
          "conditions": [
            {
              "step_iri": "/api/3/workflow_steps/be5a6af3-bd28-4cba-9315-22a7e4e32ecd",
              "condition": "{{ (vars.request.data.assignedToPerson == None) }}"
            },
            {
              "step_iri": "/api/3/workflow_steps/5f0016c6-0316-47b0-b521-198bcab0c73e",
              "condition": "{{ true }}"
            }
          ]
        },
        "status": null,
        "left": "380",
        "top": "300",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "5a008f40-0ee0-4291-8123-e626cc3b209f"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send Email To Admin Instead",
        "arguments": {
          "to": [
            "no-reply@cybersponse.com"
          ],
          "content": "<p>Administrator,</p>\n<p>The following task has been assigned to {{ vars.request.data.assignedToPerson.firstname }} {{ vars.request.data.assignedToPerson.lastname }}:</p>\n<table style=\"width: 300px; border: 1px solid #dddddd;\">\n<tbody>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Task Name</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.name }}</td>\n</tr>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Priority</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.priority.itemValue }}</td>\n</tr>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Status</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.status.itemValue }}</td>\n</tr>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Type</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.type.itemValue }}</td>\n</tr>\n<tr>\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Description</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.description}}</td>\n</tr>\n</tbody>\n</table>\n<p><br />You can view this task by clicking here:<br />{% set idParts = vars.request.data[\'@id\'].split(\'/\') %}{% if \"approvalhost\" in vars.request.data and vars.request.data.approvalhost != None %} {% set baseUri=\'https://\'+vars.request.data.approvalhost %} {% else %} {% set baseUri = vars.request.baseUri%} {% endif %}{{baseUri+\'/modules/tasks/\'+(idParts|last)}}</p>\n<p>Thanks,<br /> CyberSponse</p>",
          "subject": "CyberSponse: A task has been assigned to you.",
          "from_str": "no-reply@cybersponse.com",
          "content_type": "text/html"
        },
"status": null,
        "left": "700",
        "top": "600",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
        "uuid": "5fa79dea-1e4a-4fd1-b839-0fad3c33e069"
      },
      {
          "@type": "WorkflowStep",
        "name": "Send User Email Step",
        "arguments": {
          "to": [
              "{{ vars.request.data.assignedToPerson.email }}"
          ],
          "content": "<p>Hey {{ vars.request.data.assignedToPerson.firstname }}, the following task has been assigned to you:</p>\n<table style=\"width: 300px; border: 1px solid #dddddd;\">\n<tbody>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Task Name</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.name }}</td>\n</tr>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Priority</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.priority.itemValue }}</td>\n</tr>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Status</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.status.itemValue }}</td>\n</tr>\n<tr style=\"border-bottom: 1px solid #ddd;\">\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Type</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.type.itemValue }}</td>\n</tr>\n<tr>\n<td style=\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\"><strong>Description</strong></td>\n<td style=\"width: 224px;\">{{ vars.request.data.description}}</td>\n</tr>\n</tbody>\n</table>\n<p><br />You can view this task by clicking here:<br />{% set idParts = vars.request.data[\'@id\'].split(\'/\') %}</p>\n<p>{% if \"approvalhost\" in vars.request.data and vars.request.data.approvalhost != None%} {% set baseUri=\'https://\'+vars.request.data.approvalhost %} {% else %} {% set baseUri = vars.request.baseUri%} {% endif %}{{baseUri+\'/modules/tasks/\'+(idParts|last)}}</p>\n<p>Thanks,<br /> CyberSponse</p>",
          "subject": "CyberSponse: A task has been assigned.",
          "from_str": "no-reply@cybersponse.com",
          "content_type": "text/html"
        },
        "status": null,
        "left": "400",
        "top": "600",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
        "uuid": "a44cecde-c105-486f-92ec-f7e8eeb450f2"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "3c33a61e-6647-489d-a739-922506e5a235",
        "name": "Check if AssignedToPerson is Set -> Do Nothing",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/be5a6af3-bd28-4cba-9315-22a7e4e32ecd",
        "sourceStep": "/api/3/workflow_steps/5a008f40-0ee0-4291-8123-e626cc3b209f"
      },
      {"@type": "WorkflowRoute",
        "uuid": "da195b33-36f7-4f25-b54e-84024298d23b",
        "name": "On Task Event -> Check if AssignedToPerson is Set",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/5a008f40-0ee0-4291-8123-e626cc3b209f",
        "sourceStep": "/api/3/workflow_steps/fcabbe4e-a644-4995-81fc-5545cb370e60"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "41518c26-0aea-4f11-8086-88c87b2826f8",
        "name": "Check if AssignedToPerson is Set -> Check Notification Preferences",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/5f0016c6-0316-47b0-b521-198bcab0c73e",
        "sourceStep": "/api/3/workflow_steps/5a008f40-0ee0-4291-8123-e626cc3b209f"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "c4ff2297-6e25-43f4-9251-2433ef96d4c9",
        "name": "Check Notification Preferences -> Send User Email Step",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/a44cecde-c105-486f-92ec-f7e8eeb450f2",
        "sourceStep": "/api/3/workflow_steps/5f0016c6-0316-47b0-b521-198bcab0c73e"
      },
      {
          "@type": "WorkflowRoute",
        "uuid": "9df8be1f-46e6-4156-b087-fecfaf5255a1",
        "name": "Check Notification Preferences -> Send Email To Admin Instead",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/5fa79dea-1e4a-4fd1-b839-0fad3c33e069",
        "sourceStep": "/api/3/workflow_steps/5f0016c6-0316-47b0-b521-198bcab0c73e"
      }
    ],
    "uuid": "473494e3-92e7-4f68-9d30-a1392a1cdb56"
  }';

    private $taskResumeJson = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Task Resume",
    "description": "This is a playbook is triggered for manual task triggers for revoking the approval.",
    "collection": "/api/3/workflow_collections/a9816e15-5e42-4785-a0ee-23fe8ddb19b6",
    "tag": null,
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/04988c73-8fa0-4555-aac5-8f340f7a36d8",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Revoke requesting playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "POST",
            "resource": "{{ vars.result }}",
            "collection": "/api/wf/api/workflows/{{vars.record.workflowid}}/resume/?format=json"
          },
          "step_variables": []
        },
        "status": null,
        "left": "488",
        "top": "140",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "d273bcf0-e6a6-48b6-9e5d-f25580c6a6e3"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "tasks",
          "step_variables": {
            "record": "{{vars.request.data}}"
          },
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "OR",
            "filters": [
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/343f4b67-e929-4205-bf95-ba5b70545fed",
                "_value": {
                  "itemValue": "Completed"
                },
                "operator": "eq"
              },
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/7bf6c03d-8e04-46d0-b392-febd78d72bad",
                "_value": {
                  "display": "Skipped",
                  "itemValue": "Skipped"
                },
                "operator": "eq"
              }
            ]
          }
        },
        "status": null,
        "left": "487",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "04988c73-8fa0-4555-aac5-8f340f7a36d8"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "2c20704e-ab43-4db4-ad09-33cff8762f95",
        "name": "Start -> Revoke requesting playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/d273bcf0-e6a6-48b6-9e5d-f25580c6a6e3",
        "sourceStep": "/api/3/workflow_steps/04988c73-8fa0-4555-aac5-8f340f7a36d8"
      }
    ],
    "uuid": "5fecc103-aa4b-4626-b69d-5e38697d89e3"
  }';


    private $approvalActionViaApiJson = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Approval Action via API",
    "description": "This playbook is triggered when the approval/reject action is triggered via API",
    "collection": "/api/3/workflow_collections/a9816e15-5e42-4785-a0ee-23fe8ddb19b6",
    "tag": null,
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/4cebd785-d1d8-4e32-9c8d-095e06fd239e",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "route": "deferred/approval",
          "step_variables": {
            "record_id": "{{ vars.request.data.record_id }}",
            "approval_status": "{{ True if vars.request.data.approval  else False }}"
          },
          "authentication_methods": [
            "Basic"
          ]
        },
        "status": null,
        "left": "100",
        "top": "40",
        "stepType": "/api/3/workflow_step_types/df26c7a2-4166-4ca5-91e5-548e24c01b5f",
        "uuid": "4cebd785-d1d8-4e32-9c8d-095e06fd239e"
      },
      {
        "@type": "WorkflowStep",
        "name": "Get approval record by ID",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "GET",
            "resource": "",
            "collection": "/api/3/approvals?id$eq={{vars.record_id}}"
          },
          "step_variables": {
            "record": "{{vars.result[\'hydra:member\'][0]}}"
          }
        },
        "status": null,
        "left": "100",
        "top": "153",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "cdcccc3a-dd8d-479b-9138-655c8a7172fa"
      },
      {
        "@type": "WorkflowStep",
        "name": "Revoke requesting playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "POST",
            "resource": "{\"approved\": true, \"reason\": {{vars.reason}}}",
            "collection": "/api/wf/api/workflows/{{vars.record.workflowid}}/resume/?format=json"
          },
          "step_variables": []
        },
        "status": null,
        "left": "100",
        "top": "280",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "ec2627c4-3944-437c-b371-69390faf724b"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "0b31bb23-26c6-471a-a2da-bd093d7a2812",
        "name": "Start -> Get approval record by ID",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/cdcccc3a-dd8d-479b-9138-655c8a7172fa",
        "sourceStep": "/api/3/workflow_steps/4cebd785-d1d8-4e32-9c8d-095e06fd239e"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "ac478854-472f-48dd-ba85-9d692a2491a7",
        "name": "Get approval record by ID -> Revoke requesting playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/ec2627c4-3944-437c-b371-69390faf724b",
        "sourceStep": "/api/3/workflow_steps/cdcccc3a-dd8d-479b-9138-655c8a7172fa"
      }
    ],
    "uuid": "db96ec5e-bc30-4663-a07f-947492f482b6"
  }';


    private $approvalOnCreateJson = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Approval On Create",
    "description": "This playbook is triggered whenever an approval is requested from a playbook.",
    "collection": "/api/3/workflow_collections/a9816e15-5e42-4785-a0ee-23fe8ddb19b6",
    "tag": null,
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/78d6f291-119e-4140-94c2-9a5cec6f8e27",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Check for the type of approval Method",
        "arguments": {
          "conditions": [
            {
              "step_iri": "/api/3/workflow_steps/a3532ac0-b0c7-430a-a406-d8fbcf34c17a",
              "condition": "{{ vars.record.method.itemValue != \'Email\' }}"
            },
            {
              "step_iri": "/api/3/workflow_steps/dfc48c0d-6307-43fc-9170-f3e4124a66ec",
              "condition": "{{ vars.record.method.itemValue == \'Email\' }}"
            }
          ]
        },
        "status": null,
        "left": "400",
        "top": "129",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "732221c7-8073-4591-bd58-caec9f05f16c"
      },
      {
        "@type": "WorkflowStep",
        "name": "Do nothing in case of system",
        "arguments": {
          "script": "/wf/workflow/tasks/no_op",
          "arguments": [],
          "step_variables": []
        },
        "status": null,
        "left": "769",
        "top": "231",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "a3532ac0-b0c7-430a-a406-d8fbcf34c17a"
      },
      {
        "@type": "WorkflowStep",
        "name": "Fetch relations of the record",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "GET",
            "resource": "",
            "collection": "{{ vars.record[\'@id\'] }}?$relationships=true"
          },
          "step_variables": {
            "team_uuid": "{% set parts = vars.result[\'owners\'][0][\'@id\'].split(\'\') %}{{ parts[-1] }}"
          }
        },
        "status": null,
        "left": "400",
        "top": "351",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "503343ca-56a1-4efa-aefe-23a9e95b34a7"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check for assigned to",
        "arguments": {
          "conditions": [
            {
              "step_iri": "/api/3/workflow_steps/f3c82efb-af6f-4daa-b526-6909fbd31e61",
              "condition": "{{ vars.record.assignedTo != None }}"
            },
            {
              "step_iri": "/api/3/workflow_steps/503343ca-56a1-4efa-aefe-23a9e95b34a7",
              "condition": "{{ vars.record.assignedTo == None }}"
            }
          ]
        },
        "status": null,
        "left": "400",
        "top": "240",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "dfc48c0d-6307-43fc-9170-f3e4124a66ec"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "approvals",
          "step_variables": {
            "host": "https://{{ vars.request.headers.host }}",
            "record": "{{ vars.request.data }}",
            "approval_id": "{{vars.request.data[\"@id\"].strip().split(\'/\')[-1]}}"
          },
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": []
          }
        },
        "status": null,
        "left": "400",
        "top": "27",
        "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
        "uuid": "78d6f291-119e-4140-94c2-9a5cec6f8e27"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send an Email to the assigned Team",
        "arguments": {
          "to": [
            "{{ vars.email_join }}"
          ],
          "content": "Greetings,\n\nThis is an auto-generated email for your approval.\n\n{{ vars.record.approvaldescription }}\n\nPlease follow the following link to approve/reject the request.\n\n{{ vars.host }}/approvals/{{vars.record.workflowid}}/{{vars.approval_id}}\n\n\nThanks",
          "subject": "AUTO: Email for approval",
          "from_str": "no-reply@cybersponse.com",
          "content_type": "text/plain"
        },
        "status": null,
        "left": "800",
        "top": "560",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
        "uuid": "c6e45ea2-62c7-48c6-898c-ca84edc29946"
      },
      {
        "@type": "WorkflowStep",
        "name": "Get emails of the team members",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "GET",
            "resource": "",
            "collection": "/api/3/people?teams={{ vars.team_uuid }}"
          },
          "step_variables": {
            "emails": "{{ vars.result[\"hydra:member\"] | json_query(\'[*].email\')}}"
          }
        },
        "status": null,
        "left": "400",
        "top": "460",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "b505879a-3b26-4509-a4b1-cbbaef4c6f3c"
      },
      {
        "@type": "WorkflowStep",
        "name": "emails join",
        "arguments": {
          "email_join": "{{vars.emails | join(\',\')}}"
        },
        "status": null,
        "left": "400",
        "top": "560",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "c9fd401a-0487-41a3-9243-18d87ee65572"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send an Email to Assigned users",
        "arguments": {
          "to": [
            "{{ vars.record.assignedTo.email }}"
          ],
          "content": "Greetings,\n\nThis is an auto-generated email for your approval.\n\n{{ vars.record.approvaldescription }}\n\nPlease follow the following link to approve/reject the request.\n\n{{ vars.host }}/approvals/{{ vars.record.workflowid }}/{{vars.approval_id}}\n\n\nThanks",
          "subject": "AUTO: Email for approval",
          "from_str": "no-reply@cybersponse.com",
          "content_type": "text/plain"
        },
        "status": null,
        "left": "20",
        "top": "360",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928778",
        "uuid": "f3c82efb-af6f-4daa-b526-6909fbd31e61"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "e5347a30-dd51-42fa-ad7a-0ab0632695e4",
        "name": "Start -> Check for the type of approval Method",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/732221c7-8073-4591-bd58-caec9f05f16c",
        "sourceStep": "/api/3/workflow_steps/78d6f291-119e-4140-94c2-9a5cec6f8e27"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "2b5602e7-68a8-46d6-90e0-e127daefd361",
        "name": "Check for the type of approval Method -> Do nothing in case of system",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/a3532ac0-b0c7-430a-a406-d8fbcf34c17a",
        "sourceStep": "/api/3/workflow_steps/732221c7-8073-4591-bd58-caec9f05f16c"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "9e1c01aa-17bd-49da-8281-f3d046d8970c",
        "name": "Fetch relations of the record -> Get emails of the team members",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/b505879a-3b26-4509-a4b1-cbbaef4c6f3c",
        "sourceStep": "/api/3/workflow_steps/503343ca-56a1-4efa-aefe-23a9e95b34a7"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "8bf4d001-461c-4fd8-b650-0f4faf4405a1",
        "name": "Check for the type of approval Method -> Check for assigned to",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/dfc48c0d-6307-43fc-9170-f3e4124a66ec",
        "sourceStep": "/api/3/workflow_steps/732221c7-8073-4591-bd58-caec9f05f16c"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "ad088db9-a3db-46e8-aec0-da3f0b19d8d4",
        "name": "Check for assigned to -> Send an Email to Assigned users",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/f3c82efb-af6f-4daa-b526-6909fbd31e61",
        "sourceStep": "/api/3/workflow_steps/dfc48c0d-6307-43fc-9170-f3e4124a66ec"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "d3ed0d01-20ec-401c-a3a9-9006a94219a8",
        "name": "Check for assigned to -> Fetch relations of the record",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/503343ca-56a1-4efa-aefe-23a9e95b34a7",
        "sourceStep": "/api/3/workflow_steps/dfc48c0d-6307-43fc-9170-f3e4124a66ec"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "a2a7eeb4-7216-4c19-ace3-2a9ddda95eb1",
        "name": "Get emails of the team members -> emails join",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/c9fd401a-0487-41a3-9243-18d87ee65572",
        "sourceStep": "/api/3/workflow_steps/b505879a-3b26-4509-a4b1-cbbaef4c6f3c"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "96a4c0fc-ef1b-4fbb-9bd8-e847bd4e81e5",
        "name": "emails join -> Send an Email to the assigned Team",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/c6e45ea2-62c7-48c6-898c-ca84edc29946",
        "sourceStep": "/api/3/workflow_steps/c9fd401a-0487-41a3-9243-18d87ee65572"
      }
    ],
    "uuid": "dbe2606d-e5fe-4737-96a7-5d5631eaf723"
  }';


    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }


    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }


    protected $picklistJsonEmail= '{
        "listName": "/api/3/picklist_names/d7bdd0ba-d721-4324-bec5-410e23f0f485",
        "@type": "Picklist",
        "orderIndex": 0,
        "itemValue": "Email",
        "uuid": "2a817063-e12a-496d-934d-381d22a95b3b"
    }';

    protected $picklistJsonSystem= '{
        "@type": "Picklist",
        "itemValue": "System",
        "orderIndex": 1,
        "listName": "/api/3/picklist_names/d7bdd0ba-d721-4324-bec5-410e23f0f485",
        "uuid": "7a04788b-5128-4288-a0fc-6e82d18c3b7b"
    }';

    protected $approvalMethodNameJson = '{
        "name": "Approval Methods",
        "uuid": "d7bdd0ba-d721-4324-bec5-410e23f0f485"
    }';


    protected $picklistJsonApproved = '{
        "uuid": "a81e3b2b-8d0a-4ef0-9ef2-b286d8adb75b",
        "@type": "Picklist",
        "orderIndex": 0,
        "itemValue": "Approved",
        "listName": "/api/3/picklist_names/ce294c1f-9318-425f-9a12-2957292f4cbf",
        "color": "#4f9e00"
        }';

    protected $picklistJsonRejected = '{
        "uuid": "5907b468-4805-4724-af60-238559cdecf9",
        "@type": "Picklist",
        "orderIndex": 1,
        "itemValue": "Rejected",
        "listName": "/api/3/picklist_names/ce294c1f-9318-425f-9a12-2957292f4cbf",
        "color": "#ba1a1a"
    }';


    protected $picklistJsonPending = '{
        "uuid": "d26464e0-1df4-46c2-a032-018911ba0c40",
        "@type": "Picklist",
        "orderIndex": 2,
        "itemValue": "Pending",
        "listName": "/api/3/picklist_names/ce294c1f-9318-425f-9a12-2957292f4cbf",
        "color": "#bf9937"
    }';


    protected $approvalStatusNameJson = '{
        "name": "Approval Status",
        "uuid": "ce294c1f-9318-425f-9a12-2957292f4cbf"
    }';


    private function addPicklist(){

        /** @var ResourceInterface $picklistResource */
        $picklistResource = $this->container->get('resource.picklist');

        $context = $picklistResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;

        $picklistApprovedObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonApproved,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistRejectedObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonRejected,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistPendingObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonPending,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistJsonSystemObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonSystem,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistJsonEmailObject = $this->container->get('serializer')->deserialize(
            $this->picklistJsonEmail,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        /** @var ResourceInterface $picklistNameResource */
        $picklistNameResource = $this->container->get('resource.picklistnames');

        $contextName = $picklistNameResource->getDenormalizationContext();
        $contextName["ignore_field_authorization"] = true;
        $contextName["ignore_authorization"] = true;

        $picklistApprovalStatusObject = $this->container->get('serializer')->deserialize(
            $this->approvalStatusNameJson,
            $picklistNameResource->getEntityClass(),
            'json-ld',
            $contextName
        );

        $picklistApprovalMethodObject = $this->container->get('serializer')->deserialize(
            $this->approvalMethodNameJson,
            $picklistNameResource->getEntityClass(),
            'json-ld',
            $contextName
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        /** @var ObjectManager $picklistManager */
        $picklistManager = $managerRegistry->getManagerForClass($picklistResource->getEntityClass());

        $picklistManager->persist($picklistApprovedObject);
        $picklistManager->persist($picklistRejectedObject);
        $picklistManager->persist($picklistPendingObject);

        $picklistManager->persist($picklistJsonEmailObject);
        $picklistManager->persist($picklistJsonSystemObject);

        $picklistManager->persist($picklistApprovalStatusObject);
        $picklistManager->persist($picklistApprovalMethodObject);

        $picklistManager->flush();
    }


    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }


    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->addPicklist();
        $this->addSql("ALTER TABLE tasks ADD COLUMN approvalhost VARCHAR(255)");

        $this->addWorkflow($this->taskResumeJson);
        $this->addWorkflow($this->approvalActionViaApiJson);
        $this->addWorkflow($this->approvalOnCreateJson);

        // Deleting the old notification playbook and adding updated one
        $this->deleteWorkflow('473494e3-92e7-4f68-9d30-a1392a1cdb56');
        $this->deleteWorkflow('473494e3-92e7-4f68-9d30-a1392a1cdb78');
        $this->addWorkflow($this->NotificationJson);

        //Deleting existing Task : Create notification playbook
        $this->deleteWorkflow('3b7818e8-acba-4e3f-bf3e-60729023f9g3');
        $this->deleteWorkflow('3b7818e8-acba-4e3f-bf3e-60729023f9f1');
        $this->addWorkflow($this->taskCreateNotificationPlaybook);
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql("delete from picklists where listName='d7bdd0ba-d721-4324-bec5-410e23f0f485'");
        $this->addSql("delete from picklist_names where uuid='d7bdd0ba-d721-4324-bec5-410e23f0f485'");


        $this->addSql("delete from picklists where listName='ce294c1f-9318-425f-9a12-2957292f4cbf'");
        $this->addSql("delete from picklist_names where uuid='ce294c1f-9318-425f-9a12-2957292f4cbf'");

        $this->addSql("ALTER TABLE tasks DROP COLUMN approvalhost");

        $workflowIds = ['5fecc103-aa4b-4626-b69d-5e38697d89e3',
            'db96ec5e-bc30-4663-a07f-947492f482b6',
            'dbe2606d-e5fe-4737-96a7-5d5631eaf723',
            '473494e3-92e7-4f68-9d30-a1392a1cdb56',
            '473494e3-92e7-4f68-9d30-a1392a1cdb78',
            '3b7818e8-acba-4e3f-bf3e-60729023f9g3'
        ];

        foreach($workflowIds as $workflowIId ){
            error_log($workflowIId);
            $this->deleteWorkflow($workflowIId);
        }
    }
}
