<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180309113437 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $scheduleDeleteNotificationPlaybook = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "08 Delete Schedule",
    "description": "Stops the schedule",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system,dev,schedule",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/1c74964d-f8b6-48c0-b83d-c531653b4860",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Call Map playbook",
        "arguments": {
          "collection": "[{{vars.request.data}}]",
          "workflow_iri": "/api/3/workflows/328b3435-1fb8-45fd-8cdf-46e35c2ab2ef"
        },
        "status": null,
        "left": "227",
        "top": "180",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928728",
        "uuid": "8b723f8f-3012-4f47-8c20-b6e30a5d2611"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "schedules",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "schedularStatus",
                "value": "/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a",
                "_value": {
                  "itemValue": "Running"
                },
                "operator": "eq"
              }
            ]
          }
        },
        "status": null,
        "left": "227",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/a987479e-9c96-46b0-9598-7f0b35e16ad2",
        "uuid": "1c74964d-f8b6-48c0-b83d-c531653b4860"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "3e68133f-7670-4b5f-9a80-b8f127f2df3a",
        "name": "Start -> Call Map playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/8b723f8f-3012-4f47-8c20-b6e30a5d2611",
        "sourceStep": "/api/3/workflow_steps/1c74964d-f8b6-48c0-b83d-c531653b4860"
      }
    ],
    "uuid": "ebfc713a-3ed3-4ccf-a53d-a8e2a369d242"
  }';

    private $scheduleDeleteNotificationChildPlaybook = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "09 Delete Schedule (Child)",
    "description": "System playbook to stop running playbook",
    "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
    "tag": "system, dev, schedule",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/818409d1-8a7e-49a7-b44d-023f76e63676",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": [],
        "status": null,
        "left": "348",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "818409d1-8a7e-49a7-b44d-023f76e63676"
      },
      {
        "@type": "WorkflowStep",
        "name": "Stop Periodic Playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/stop_periodic",
          "arguments": {
            "redis_schedule_entry_id": "{{vars.loop_resource.cronJobId}}"
          },
          "step_variables": []
        },
        "status": null,
        "left": "348",
        "top": "130",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "d116e4d0-47ca-4e72-9402-ab97e364fe9c"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "b0a07894-2f55-468b-a8d1-6740c1f11dd0",
        "name": "Start -> Stop Periodic Playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/d116e4d0-47ca-4e72-9402-ab97e364fe9c",
        "sourceStep": "/api/3/workflow_steps/818409d1-8a7e-49a7-b44d-023f76e63676"
      }
    ],
    "uuid": "328b3435-1fb8-45fd-8cdf-46e35c2ab2ef"
  }';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->addWorkflow($this->scheduleDeleteNotificationPlaybook);
        $this->addWorkflow($this->scheduleDeleteNotificationChildPlaybook);
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {

        $workflowIds = [
            'ebfc713a-3ed3-4ccf-a53d-a8e2a369d242',
            '328b3435-1fb8-45fd-8cdf-46e35c2ab2ef'
        ];

        // this down() migration is auto-generated, please modify it to your needs
        foreach($workflowIds as $workflowIId ){
            error_log($workflowIId);
            $this->deleteWorkflow($workflowIId);
        }

    }
}
