<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180328073029 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $alertSetAssignedDate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Alert > Set Assigned Date",
    "description": "Update Assigned Date when Person is assigned to Alert",
    "collection": "/api/3/workflow_collections/d8c02077-db40-4b58-9520-1220916f6853",
    "tag": "#PostUpdate #Defaults",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/6eb74c17-7ff4-47d8-a030-aeebc6d98e10",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Set Assigned Date",
        "arguments": {
          "resource": {
            "assigneddate": "{{arrow.utcnow().timestamp}}"
          },
          "_showJson": false,
          "collection": "{{vars.request.data[\"@id\"]}}",
          "collectionType": "/api/3/alerts",
          "step_variables": []
        },
        "status": null,
        "left": "411",
        "top": "160",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "9de0e56e-6829-4f88-8073-703d578ceffe"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "alerts",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "assignedTo",
                "value": null,
                "_value": {
                  "display": "",
                  "itemValue": ""
                },
                "operator": "changed"
              },
              {
                "type": "object",
                "field": "assignedTo",
                "value": "false",
                "_value": [],
                "operator": "isnull"
              }
            ]
          }
        },
        "status": null,
        "left": "100",
        "top": "60",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "6eb74c17-7ff4-47d8-a030-aeebc6d98e10"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "91d8a471-3cfe-4b51-bda1-6f408ec5f6a2",
        "name": "Start -> Set Assigned Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/9de0e56e-6829-4f88-8073-703d578ceffe",
        "sourceStep": "/api/3/workflow_steps/6eb74c17-7ff4-47d8-a030-aeebc6d98e10"
      }
    ],
    "uuid": "5a08ce71-88ba-43f1-9644-a72e7da925fc"
  }';

    private $alertSetResolvedDate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Alert > Set Resolved Date",
    "description": "Update Resolved Date when State is marked \"Closed\"",
    "collection": "/api/3/workflow_collections/d8c02077-db40-4b58-9520-1220916f6853",
    "tag": "#PostUpdate #Defaults",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/2323dd92-f79f-4a98-85c7-d3c3b34ffecd",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Update Resolved Date",
        "arguments": {
          "resource": {
            "resolveddate": "{{arrow.utcnow().timestamp}}"
          },
          "_showJson": false,
          "collection": "{{vars.request.data[\"@id\"]}}",
          "collectionType": "/api/3/alerts",
          "step_variables": []
        },
        "status": null,
        "left": "606",
        "top": "320",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "9ce492ef-1007-469d-8003-8ed17c8f15f5"
      },
      {
        "@type": "WorkflowStep",
        "name": "No Operations",
        "arguments": {
          "script": "/wf/workflow/tasks/no_op",
          "arguments": [],
          "step_variables": []
        },
        "status": null,
        "left": "9",
        "top": "320",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "dd24b6ad-dee6-413a-9cd0-635a37522042"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check Status is Closed",
        "arguments": {
          "conditions": [
            {
              "step_iri": "/api/3/workflow_steps/9ce492ef-1007-469d-8003-8ed17c8f15f5",
              "condition": "{{ vars.request.data.status[\"@id\"] == \"/api/3/picklists/fac53e73-8d16-4189-98d5-95fbd1555232\" or vars.request.data.status[\"@id\"] == \"/api/3/picklists/029acf06-928d-41e1-b7d6-bc20fb6c353a\" or vars.request.data.status[\"@id\"] == \"/api/3/picklists/4f76f6be-764b-4d5d-a788-9a7da8f1529f\" }}"
            },
            {
              "step_iri": "/api/3/workflow_steps/dd24b6ad-dee6-413a-9cd0-635a37522042",
              "condition": "{{ vars.request.data.status[\"@id\"] != \"/api/3/picklists/fac53e73-8d16-4189-98d5-95fbd1555232\" or vars.request.data.status[\"@id\"] != \"/api/3/picklists/029acf06-928d-41e1-b7d6-bc20fb6c353a\" or vars.request.data.status[\"@id\"] != \"/api/3/picklists/4f76f6be-764b-4d5d-a788-9a7da8f1529f\" }}"
            }
          ]
        },
        "status": null,
        "left": "300",
        "top": "180",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "e27b3fa2-233a-4a72-957a-5b77b90dd7ee"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "alerts",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "OR",
            "filters": [
              {
                "type": "object",
                "field": "status",
                "value": null,
                "_value": {
                  "display": "",
                  "itemValue": ""
                },
                "operator": "changed"
              }
            ]
          }
        },
        "status": null,
        "left": "300",
        "top": "12",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "2323dd92-f79f-4a98-85c7-d3c3b34ffecd"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "8c455634-5e7d-4054-8fdd-008f00528f3e",
        "name": "Start -> Check Status is Closed",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/e27b3fa2-233a-4a72-957a-5b77b90dd7ee",
        "sourceStep": "/api/3/workflow_steps/2323dd92-f79f-4a98-85c7-d3c3b34ffecd"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "5f0e54ae-4175-4162-ac62-d5d7594425a2",
        "name": "Check Status is Closed -> Update Resolved Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/9ce492ef-1007-469d-8003-8ed17c8f15f5",
        "sourceStep": "/api/3/workflow_steps/e27b3fa2-233a-4a72-957a-5b77b90dd7ee"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "332b83fd-6449-4333-82f0-f8d180850b5b",
        "name": "Check Status is Closed -> No Operations",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/dd24b6ad-dee6-413a-9cd0-635a37522042",
        "sourceStep": "/api/3/workflow_steps/e27b3fa2-233a-4a72-957a-5b77b90dd7ee"
      }
    ],
    "uuid": "70f9227c-cf93-4e00-a032-0539b7b227d8"
  }';

    private $incidentSetAssignedDate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Incident > Set Assigned Date",
    "description": "Update Assigned Date when Lead is assigned to Incident",
    "collection": "/api/3/workflow_collections/d8c02077-db40-4b58-9520-1220916f6853",
    "tag": "#PostUpdate #Defaults",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/e7299d68-d307-4345-bb9a-96216a64e622",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "incidents",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "incidentLead",
                "value": null,
                "_value": {
                  "display": "",
                  "itemValue": ""
                },
                "operator": "changed"
              },
              {
                "type": "object",
                "field": "incidentLead",
                "value": "false",
                "_value": [],
                "operator": "isnull"
              }
            ]
          }
        },
        "status": null,
        "left": "100",
        "top": "67",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "e7299d68-d307-4345-bb9a-96216a64e622"
      },
      {
        "@type": "WorkflowStep",
        "name": "Set Assigned Date",
        "arguments": {
          "resource": {
            "assigneddate": "{{arrow.utcnow().timestamp}}"
          },
          "_showJson": false,
          "collection": "{{vars.request.data[\"@id\"]}}",
          "collectionType": "/api/3/incidents",
          "step_variables": []
        },
        "status": null,
        "left": "411",
        "top": "160",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "853da484-d1be-4c18-8bde-6cacec267408"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "25777476-8dfe-4113-a509-7892401f2523",
        "name": "Start -> Set Assigned Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/853da484-d1be-4c18-8bde-6cacec267408",
        "sourceStep": "/api/3/workflow_steps/e7299d68-d307-4345-bb9a-96216a64e622"
      }
    ],
    "uuid": "18d867e8-58de-43b0-9c21-7777d4817ed4"
  }';

    private $incidentSetResolvedDate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Incident > Set Resolved Date",
    "description": "Update Resolved Date when State is marked \"Resolved\"",
    "collection": "/api/3/workflow_collections/d8c02077-db40-4b58-9520-1220916f6853",
    "tag": "#PostUpdate #Defaults",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/fa462b58-4fda-4c0f-a6da-b71eee284295",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "incidents",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/bb73fd5e-f699-11e7-8c3f-9a214cf093ae",
                "_value": {
                  "itemValue": "Resolved"
                },
                "operator": "changed"
              },
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/bb73fd5e-f699-11e7-8c3f-9a214cf093ae",
                "_value": {
                  "display": "Resolved",
                  "itemValue": "Resolved"
                },
                "operator": "eq"
              }
            ]
          }
        },
        "status": null,
        "left": "47",
        "top": "30",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "fa462b58-4fda-4c0f-a6da-b71eee284295"
      },
      {
        "@type": "WorkflowStep",
        "name": "Update Resolved Date",
        "arguments": {
          "resource": {
            "resolveddate": "{{arrow.utcnow().timestamp}}"
          },
          "_showJson": false,
          "collection": "{{vars.request.data[\"@id\"]}}",
          "collectionType": "/api/3/incidents",
          "step_variables": []
        },
        "status": null,
        "left": "380",
        "top": "120",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "b6b7bfee-1226-4950-b0c7-4ce8790bd3db"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "e24767ed-8256-43dc-b82f-bef4a173aaea",
        "name": "Start -> Update Resolved Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/b6b7bfee-1226-4950-b0c7-4ce8790bd3db",
        "sourceStep": "/api/3/workflow_steps/fa462b58-4fda-4c0f-a6da-b71eee284295"
      }
    ],
    "uuid": "65818c81-5a58-426d-a4eb-cf9c7faf0070"
  }';

    private $incidentSetAssignedDateCreate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Incident >Set Assigned Date Create",
    "description": "Update Assigned Date when Lead is assigned to Incident",
    "collection": "/api/3/workflow_collections/d8c02077-db40-4b58-9520-1220916f6853",
    "tag": "#PostCreate #Defaults",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/4fc93dd0-312c-426d-bdcc-4582e15f8f1f",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Set Assigned Date",
        "arguments": {
          "resource": {
            "assigneddate": "{{arrow.utcnow().timestamp}}"
          },
          "_showJson": false,
          "collection": "{{vars.request.data[\"@id\"]}}",
          "collectionType": "/api/3/incidents",
          "step_variables": []
        },
        "status": null,
        "left": "411",
        "top": "160",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "dbc1972d-5f0d-437a-bb19-808f43213448"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "incidents",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "incidentLead",
                "value": "false",
                "_value": [],
                "operator": "isnull"
              }
            ]
          }
        },
        "status": null,
        "left": "100",
        "top": "67",
        "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
        "uuid": "4fc93dd0-312c-426d-bdcc-4582e15f8f1f"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "71b280f1-74d7-4ba5-87d8-fcbf6129cfe9",
        "name": "Start -> Set Assigned Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/dbc1972d-5f0d-437a-bb19-808f43213448",
        "sourceStep": "/api/3/workflow_steps/4fc93dd0-312c-426d-bdcc-4582e15f8f1f"
      }
    ],
    "uuid": "f298615e-47f2-47e0-b7aa-12bf7c3eff1e"
  }';

    private $alertSetAssignedDateCreate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Alert > Set Assigned Date Create",
    "description": "Update Assigned Date when Person is assigned to Alert",
    "collection": "/api/3/workflow_collections/d8c02077-db40-4b58-9520-1220916f6853",
    "tag": "#PostCreate #Defaults",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/5364a564-a46a-435b-b311-72b39015711d",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Set Assigned Date",
        "arguments": {
          "resource": {
            "assigneddate": "{{arrow.utcnow().timestamp}}"
          },
          "_showJson": false,
          "collection": "{{vars.request.data[\"@id\"]}}",
          "collectionType": "/api/3/alerts",
          "step_variables": []
        },
        "status": null,
        "left": "307",
        "top": "180",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "800ead3f-4f60-4c05-b3aa-1f019129ec35"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "alerts",
          "step_variables": [],
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "assignedTo",
                "value": "false",
                "_value": [],
                "operator": "isnull"
              }
            ]
          }
        },
        "status": null,
        "left": "100",
        "top": "60",
        "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
        "uuid": "5364a564-a46a-435b-b311-72b39015711d"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "0f8cec38-63da-406f-b5a1-380ff3759e9d",
        "name": "Start -> Set Assigned Date",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/800ead3f-4f60-4c05-b3aa-1f019129ec35",
        "sourceStep": "/api/3/workflow_steps/5364a564-a46a-435b-b311-72b39015711d"
      }
    ],
    "uuid": "a1cfb8b3-c0ba-4ba7-8bf9-377251bee2df"
  }';
    
    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->addWorkflow($this->alertSetAssignedDate);
        $this->addWorkflow($this->alertSetResolvedDate);
        $this->addWorkflow($this->incidentSetAssignedDate);
        $this->addWorkflow($this->incidentSetResolvedDate);
        $this->addWorkflow($this->incidentSetAssignedDateCreate);
        $this->addWorkflow($this->alertSetAssignedDateCreate);
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {

        $workflowIds = [
            '5a08ce71-88ba-43f1-9644-a72e7da925fc',
            '70f9227c-cf93-4e00-a032-0539b7b227d8',
            '18d867e8-58de-43b0-9c21-7777d4817ed4',
            '65818c81-5a58-426d-a4eb-cf9c7faf0070',
            'f298615e-47f2-47e0-b7aa-12bf7c3eff1e',
            'a1cfb8b3-c0ba-4ba7-8bf9-377251bee2df'
        ];

        // this down() migration is auto-generated, please modify it to your needs
        foreach($workflowIds as $workflowIId ){
            error_log($workflowIId);
            $this->deleteWorkflow($workflowIId);
        }

    }
}
