<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180515091236 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $taskResume = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Task Resume",
    "description": "This is a playbook is triggered for manual task triggers for revoking the approval.",
    "collection": "/api/3/workflow_collections/a9816e15-5e42-4785-a0ee-23fe8ddb19b6",
    "tag": null,
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/04988c73-8fa0-4555-aac5-8f340f7a36d8",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "tasks",
          "step_variables": {
            "record": "{{vars.request.data}}"
          },
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "OR",
            "filters": [
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/343f4b67-e929-4205-bf95-ba5b70545fed",
                "_value": {
                  "itemValue": "Completed"
                },
                "operator": "eq"
              },
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/7bf6c03d-8e04-46d0-b392-febd78d72bad",
                "_value": {
                  "display": "Skipped",
                  "itemValue": "Skipped"
                },
                "operator": "eq"
              }
            ]
          }
        },
        "status": null,
        "left": "487",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "04988c73-8fa0-4555-aac5-8f340f7a36d8"
      },
      {
        "@type": "WorkflowStep",
        "name": "Revoke requesting playbook",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "POST",
            "resource": "{\"status\": {{ vars.record.status}} }",
            "collection": "/api/wf/api/workflows/{{vars.record.workflowid}}/resume/?format=json"
          },
          "step_variables": []
        },
        "status": null,
        "left": "488",
        "top": "140",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "d273bcf0-e6a6-48b6-9e5d-f25580c6a6e3"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "2c20704e-ab43-4db4-ad09-33cff8762f95",
        "name": "Start -> Revoke requesting playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/d273bcf0-e6a6-48b6-9e5d-f25580c6a6e3",
        "sourceStep": "/api/3/workflow_steps/04988c73-8fa0-4555-aac5-8f340f7a36d8"
      }
    ],
    "uuid": "5fecc103-aa4b-4626-b69d-5e38697d89e3"
  }';

    private $escalate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Escalate",
    "description": "This will create a new incident with the given inputs and will link the alert(s) to the newly created incident.",
    "collection": "/api/3/workflow_collections/6368061c-c6ea-462b-b33f-75437efb0e3b",
    "tag": "system,dev",
    "isActive": true,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/265765c0-0d62-4a4d-9653-9082077afd29",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "route": "ec48ee21-d65d-4615-b1fc-86d8982eec11",
          "title": "Escalate",
          "resources": [
            "alerts"
          ],
          "inputVariables": [
            {
              "name": "incidentName",
              "type": "string",
              "title": "Text Field",
              "usable": true,
              "formType": "text",
              "collection": false,
              "dataSource": {
                "model": "picklists",
                "query": {
                  "sort": [
                    {
                      "field": "orderIndex",
                      "direction": "ASC"
                    }
                  ],
                  "logic": "AND",
                  "filters": [
                    {
                      "field": "listName__name",
                      "value": "AlertStatus",
                      "operator": "eq"
                    }
                  ]
                }
              },
              "searchable": true,
              "templateUrl": "app/components/form/fields/input.html",
              "allowedGridColumn": true
            },
            {
              "name": "severity",
              "type": "picklists",
              "title": "Picklist",
              "usable": true,
              "formType": "picklist",
              "collection": false,
              "dataSource": {
                "model": "picklists",
                "query": {
                  "sort": [
                    {
                      "field": "orderIndex",
                      "direction": "ASC"
                    }
                  ],
                  "logic": "AND",
                  "filters": [
                    {
                      "field": "listName__name",
                      "value": "Severity",
                      "operator": "eq"
                    }
                  ]
                }
              },
              "searchable": false,
              "templateUrl": "app/components/form/fields/typeahead.html",
              "allowedGridColumn": true
            },
            {
              "name": "incidentLead",
              "type": "people",
              "title": "Lookup",
              "usable": true,
              "formType": "lookup",
              "collection": false,
              "dataSource": {
                "model": "people"
              },
              "searchable": false,
              "templateUrl": "app/components/form/fields/typeahead.html",
              "displayTemplate": "{{ firstname }} {{ lastname }}",
              "allowedGridColumn": true
            }
          ]
        },
        "status": null,
        "left": "170",
        "top": "11",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "265765c0-0d62-4a4d-9653-9082077afd29"
      },
      {
        "@type": "WorkflowStep",
        "name": "Insert One Incident_Many_to_One",
        "arguments": {
          "resource": {
            "id": null,
            "name": "{{vars.request.data.incidentName}}",
            "dueby": null,
            "notes": null,
            "phase": {
              "id": 206,
              "@id": "/api/3/picklists/bb7412bc-f699-11e7-8c3f-9a214cf093ae",
              "icon": null,
              "@type": "Picklist",
              "color": null,
              "display": "Preparation",
              "listName": "/api/3/picklist_names/b862eb1f-b385-40ca-baa7-5a1b1f91a651",
              "itemValue": "Preparation",
              "orderIndex": 10
            },
            "tasks": null,
            "alerts": "{{ vars.request.data.records | json_query(\'[*].\"@id\"[]\') }}",
            "assets": null,
            "emails": null,
            "events": null,
            "owners": null,
            "source": null,
            "status": {
              "id": 221,
              "@id": "/api/3/picklists/bb73fe9e-f699-11e7-8c3f-9a214cf093ae",
              "icon": null,
              "@type": "Picklist",
              "color": null,
              "display": "Open",
              "listName": "/api/3/picklist_names/a549e41c-31ca-406d-89ae-eab3de5c06c4",
              "itemValue": "Open",
              "orderIndex": 0
            },
"persons": null,
            "snSysid": null,
            "category": null,
            "comments": null,
            "severity": "{{vars.request.data.severity}}",
            "sourceId": null,
            "companies": null,
            "dwellTime": null,
            "nextsteps": null,
            "createDate": null,
            "createUser": null,
            "indicators": null,
            "modifyDate": null,
            "modifyUser": null,
            "resolution": null,
            "attachments": null,
            "description": "",
            "assigneddate": null,
            "discoveredOn": null,
            "incidentLead": "{{vars.request.data.incidentLead}}",
            "recoveryTime": null,
            "resolveddate": null,
            "dateOfIncident": null,
            "snTicketNumber": null,
            "containmentTime": null,
            "incidentsummary": null,
            "vulnerabilities": null,
            "impactassessments": null,
            "systemAssignedQueue": null,
            "createServicenowTicket": null,
            "servicenowTicketStatus": null
          },
          "_showJson": false,
          "collection": "/api/3/incidents",
          "step_variables": []
        },
        "status": null,
        "left": "170",
        "top": "140",
        "stepType": "/api/3/workflow_step_types/2597053c-e718-44b4-8394-4d40fe26d357",
        "uuid": "fabf8f2c-8196-43f0-8860-08c4ff85f2d0"
      }
    ],
    "routes": [
      {
          "@type": "WorkflowRoute",
        "uuid": "d83731db-8dc7-4949-a897-e492b0861d4a",
        "name": "Start -> Insert One Incident_Many_to_One",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/fabf8f2c-8196-43f0-8860-08c4ff85f2d0",
        "sourceStep": "/api/3/workflow_steps/265765c0-0d62-4a4d-9653-9082077afd29"
      }
    ],
    "uuid": "6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e"
  }';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->deleteWorkflow('5fecc103-aa4b-4626-b69d-5e38697d89e3');
        $this->deleteWorkflow('6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e');
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $this->addWorkflow($this->taskResume);
    }
}
