<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180519124901 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addSql("INSERT INTO workflow_step_types (uuid, collection_uuid, name, displayname, icon, background, index, visible, parent_uuid, arguments, id) values ('0109f35d-090b-4a2b-bd8a-94cbc3508562', 'f3561053-417f-4591-8fa4-ca9da8e1da8b', 'CyopsUtilites', 'CyOPs Utilities','fa fa-plug','#ba0017', '321', true, 'ee73e569-2188-43fe-a7f0-1964ba82a4de', '{\"script\": \"/wf/workflow/tasks/connector\", \"arguments\": {\"connector\": \"cyops_utilities\"}}', '300');");
        $this->addSql("INSERT INTO workflow_step_types (uuid, collection_uuid, name, displayname, icon, background, index, visible, parent_uuid, arguments, id) values ('4c0019b2-055c-44d0-968c-678a0c2d762e', '2f881cbc-210a-11e8-b467-0ed5f89f718b', 'SendMail', 'Send Email','fa fa-envelope-o','#289C82', '511', true,'ee73e569-2188-43fe-a7f0-1964ba82a4de', '{\"script\": \"/wf/workflow/tasks/connector\", \"arguments\": {\"from_str\": \"soc@cybersponse.com\", \"connector\": \"smtp\"}}', '204');");
        $this->addSql("INSERT INTO workflow_step_types (uuid, collection_uuid, parent_uuid, name, displayname, arguments, icon, background, index, visible, id) VALUES('dc61b68b-4967-4e82-b4ed-a1315aa81998', 'c06cd820-a031-433b-9094-220dda64b4e4', 'ee73e569-2188-43fe-a7f0-1964ba82a4de', 'ManualDecision', 'Manual Decision', '{\"script\": \"/wf/workflow/tasks/wait\"}', 'fa fa-code-fork', '#52b200', '250', true, '224');");
        $this->addSql("INSERT INTO workflow_step_types (uuid, collection_uuid, parent_uuid, name, displayname, arguments, icon, background, index, visible, id) VALUES ('9dcc4bf5-b6cf-4a5c-b545-1fac3b9e33e6', 'c04ab14a-669e-4502-92a3-3beef3cf6219', 'ee73e569-2188-43fe-a7f0-1964ba82a4de', 'SetPlaybookResult', 'Set Playbook Result','{\"script\": \"/wf/workflow/tasks/set_result\"}', 'fa fa-pencil-square-o', '#f7ac20', '145', false, '227');");
        $this->addSql("UPDATE workflow_step_type_collection SET visible = 'true' WHERE uuid='16510dba-4f57-4206-9537-d9734733d211';");
        $this->addSql("UPDATE workflow_step_types SET visible = 'true', arguments = '{\"script\": \"/wf/workflow/tasks/set_multiple\"}' WHERE uuid='b104e839-fc31-48b3-8c50-7e9433f33d79';");
        $this->addSql("UPDATE workflow_step_types SET visible = 'true', arguments = '{\"script\": \"/wf/workflow/tasks/insert_data\"}' WHERE uuid='2597053c-e718-44b4-8394-4d40fe26d357';");

        //Update existing table rows of workflow_step_type_collection
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Core', index = '110', visible = true WHERE uuid='c04ab14a-669e-4502-92a3-3beef3cf6219';");
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Evaluate', index = '120', visible = true WHERE uuid='c06cd820-a031-433b-9094-220dda64b4e4';");
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Execute', index = '130', visible = true WHERE uuid='f3561053-417f-4591-8fa4-ca9da8e1da8b';");
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'References', index = '140', visible = true WHERE uuid='f3561053-417f-4591-8fa4-ca9da8e1da8c';");
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Email', index = '150', visible = true WHERE uuid='2f881cbc-210a-11e8-b467-0ed5f89f718b';");
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Files', index = '160', visible = true WHERE uuid='f3561053-417f-4591-8fa4-ca9da8e1da9b';");

        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Triggers', index = '1000', visible = true WHERE uuid='51627f80-3dd5-4260-b86d-cc53a7cece15';");
        $this->addSql("UPDATE workflow_step_type_collection SET name = 'Authentication', index = '100', visible = 'false' WHERE uuid='16510dba-4f57-4206-9537-d9734733d211';");

        //Update existing workflow_step_types
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Create Record', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219', index = '110', visible = 'true' WHERE uuid='2597053c-e718-44b4-8394-4d40fe26d357';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Update Record', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219', index = '120', visible = 'true' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928722';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Find Records', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219', index = '130', visible = 'true' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928770';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Set Variable', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219', index = '140', visible = 'true' WHERE uuid='04d0cf46-b6a8-42c4-8683-60a7eaa69e8f';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Decision', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4', index = '210', visible = 'true' WHERE uuid='12254cf5-5db7-4b1a-8cb1-3af081924b28';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Wait', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4', index = '220', visible = 'true' WHERE uuid='6832e556-b9c7-497a-babe-feda3bd27dbf';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Approval', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4', index = '230', visible = 'true' WHERE uuid='6832e556-b9c7-497a-babe-feda3bd27dcg';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Manual Task', background='#52b200', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4', index = '240', visible = 'true' WHERE uuid='dc6ac63d-c5a5-472f-9eb4-6b18473a98b8';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Connector', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8b', index = '310', visible = 'true' WHERE uuid='0bfed618-0316-11e7-93ae-92361f002671';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Add Database Connector', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8b', index = '320', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928745';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Run Utility Functions', background='#ba0017', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8b', index = '330', visible = 'true' WHERE uuid='ee73e569-2188-43fe-a7f0-1964ba82a4de';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Reference a Playbook', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c', index = '420', visible = 'true' WHERE uuid='74932bdc-b8b6-4d24-88c4-1a4dfbc524f3';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Map Playbook', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c', index = '430', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928728';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Make API Call', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c', index = '440', visible = 'false' WHERE uuid='949779e9-c4c2-4652-9ad2-c1875be6be54';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Send Email', background='#289C82', collection_uuid = '2f881cbc-210a-11e8-b467-0ed5f89f718b', index = '510', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928778';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Fetch Email', background='#289C82', collection_uuid = '2f881cbc-210a-11e8-b467-0ed5f89f718b', index = '520', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928789';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Create File From String', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b', index = '610', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928724';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Download File from URL', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b', index = '620', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928723';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Create Attachment From File', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b', index = '630', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928796';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'No Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '110', visible = 'true' WHERE uuid='b348f017-9a94-471f-87f8-ce88b6a7ad62';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'API Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '120', visible = 'true' WHERE uuid='df26c7a2-4166-4ca5-91e5-548e24c01b5f';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Manual Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '130', visible = 'true' WHERE uuid='f414d039-bb0d-4e59-9c39-a8f1e880b18a';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Pre-Create Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '140', visible = 'false' WHERE uuid='aed55d18-1974-4743-b061-7f5a4292e657';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Pre-Update Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '150', visible = 'false' WHERE uuid='0d375573-1c17-47bb-9790-934cff200ec4';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Pre-Delete Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '160', visible = 'false' WHERE uuid='a987479e-9c96-46b0-9598-7f0b35e16ad2';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Post-Create Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '170', visible = 'true' WHERE uuid='ea155646-3821-4542-9702-b246da430a8d';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Post-Update Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '180', visible = 'true' WHERE uuid='9300bf69-5063-486d-b3a6-47eb9da24872';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Post-Delete Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15', index = '190', visible = 'true' WHERE uuid='ef350fda-1771-477a-8f90-16f68cd7e5cb';");

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Set API Keys', collection_uuid = '16510dba-4f57-4206-9537-d9734733d211', index = '10', visible = 'false' WHERE uuid='b104e839-fc31-48b3-8c50-7e9433f33d79';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Database Query', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c', index = '11', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928799';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'SFTP', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b', index = '12', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928725';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Remote Command', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c', index = '13', visible = 'false' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928726';");
        $this->addSql("UPDATE workflow_step_type_collection SET visible = 'false' WHERE uuid='f3561053-417f-4591-8fa4-ca9da8e1da9b';");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {

        //Update displayname to original
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Run Script', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='ee73e569-2188-43fe-a7f0-1964ba82a4de';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Reference a Playbook', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c' WHERE uuid='74932bdc-b8b6-4d24-88c4-1a4dfbc524f3';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Set Variable', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='04d0cf46-b6a8-42c4-8683-60a7eaa69e8f';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'No Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='b348f017-9a94-471f-87f8-ce88b6a7ad62';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'API Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='df26c7a2-4166-4ca5-91e5-548e24c01b5f';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Action Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='f414d039-bb0d-4e59-9c39-a8f1e880b18a';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Pre-Create Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='aed55d18-1974-4743-b061-7f5a4292e657';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Pre-Update Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='0d375573-1c17-47bb-9790-934cff200ec4';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Pre-Delete Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='a987479e-9c96-46b0-9598-7f0b35e16ad2';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Post-Create Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='ea155646-3821-4542-9702-b246da430a8d';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Post-Update Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='9300bf69-5063-486d-b3a6-47eb9da24872';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Post-Delete Trigger', collection_uuid = '51627f80-3dd5-4260-b86d-cc53a7cece15' WHERE uuid='ef350fda-1771-477a-8f90-16f68cd7e5cb';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Decision', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4' WHERE uuid='12254cf5-5db7-4b1a-8cb1-3af081924b28';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Delay', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4' WHERE uuid='6832e556-b9c7-497a-babe-feda3bd27dbf';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Set API Keys', collection_uuid = '16510dba-4f57-4206-9537-d9734733d211' WHERE uuid='b104e839-fc31-48b3-8c50-7e9433f33d79';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'API Call', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c' WHERE uuid='949779e9-c4c2-4652-9ad2-c1875be6be54';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Connectors', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8b' WHERE uuid='0bfed618-0316-11e7-93ae-92361f002671';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Find Records', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928770';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Fetch Email', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8b' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928789';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Approval', collection_uuid = 'c06cd820-a031-433b-9094-220dda64b4e4' WHERE uuid='6832e556-b9c7-497a-babe-feda3bd27dcg';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Map Playbook', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928728';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Database Query', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928799';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Create File From String', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928724';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'SFTP', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928725';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Download File from URL', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928723';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Update Record', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928722';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Database Connector', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8b' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928745';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Create Attachment From File', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da9b' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928796';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Remote Command', collection_uuid = 'f3561053-417f-4591-8fa4-ca9da8e1da8c' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928726';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Add Manual Task', background='#f7ac20', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='dc6ac63d-c5a5-472f-9eb4-6b18473a98b8';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Create Record', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='2597053c-e718-44b4-8394-4d40fe26d357';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Send Email', collection_uuid = 'c04ab14a-669e-4502-92a3-3beef3cf6219' WHERE uuid='b593663d-7d13-40ce-a3a3-96dece928778';");

        $this->addSql("DELETE FROM workflow_step_types where uuid='0109f35d-090b-4a2b-bd8a-94cbc3508562';");
        $this->addSql("DELETE FROM workflow_step_types where uuid='4c0019b2-055c-44d0-968c-678a0c2d762e';");
        $this->addSql("DELETE FROM workflow_step_types where uuid='dc61b68b-4967-4e82-b4ed-a1315aa81998';");
        $this->addSql("DELETE FROM workflow_step_types where uuid='9dcc4bf5-b6cf-4a5c-b545-1fac3b9e33e6';");
        $this->addSql("UPDATE workflow_step_type_collection SET visible = 'true' WHERE uuid='f3561053-417f-4591-8fa4-ca9da8e1da9b';");
        $this->addSql("UPDATE workflow_step_type_collection SET visible = 'false' WHERE uuid='16510dba-4f57-4206-9537-d9734733d211';");
        $this->addSql("UPDATE workflow_step_types SET visible = 'false', arguments = '{\"script\": \"/wf/workflow/tasks/set_multiple\"}' WHERE uuid='b104e839-fc31-48b3-8c50-7e9433f33d79';");
    }
}
