<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180525054043 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $approvalUpdate = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Approval On Update",
    "description": "This playbook is triggered whenever an approval is requested from a playbook.",
    "collection": "/api/3/workflow_collections/a9816e15-5e42-4785-a0ee-23fe8ddb19b6",
    "tag": "#Update",
    "isActive": true,
    "singleRecordExecution": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/b249e047-2346-4fe5-908c-78b03ec22930",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Fetch relations of the record",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "GET",
            "resource": "",
            "collection": "{{ vars.record[\'@id\'] }}?$relationships=true"
          },
          "step_variables": {
            "team_uuid": "{% set parts = vars.result[\'owners\'][0][\'@id\'].split(\'/\') %}{{ parts[-1] }}"
          }
        },
        "status": null,
        "left": "400",
        "top": "351",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "f2b71bbf-222d-446c-9877-f3a150554bd4"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check for assigned to",
        "arguments": {
          "conditions": [
            {
              "step_iri": "/api/3/workflow_steps/17eec8bd-068f-4dd5-a7f3-efaed7f9efc7",
              "condition": "{{ vars.record.assignedTo != None }}"
            },
            {
              "step_iri": "/api/3/workflow_steps/f2b71bbf-222d-446c-9877-f3a150554bd4",
              "condition": "{{ vars.record.assignedTo == None }}"
            }
          ]
        },
        "status": null,
        "left": "400",
        "top": "240",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "a78bbf05-b408-46d9-a1cc-b326369bb284"
      },
      {
        "@type": "WorkflowStep",
        "name": "Get emails of the team members",
        "arguments": {
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "GET",
            "resource": "",
            "collection": "/api/3/people?teams={{ vars.team_uuid }}"
          },
          "step_variables": {
            "emails": "{{ vars.result[\"hydra:member\"] | json_query(\'[*].email\')}}"
          }
        },
        "status": null,
        "left": "400",
        "top": "460",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "b458e711-bd33-4caf-9f44-ba66ce24e419"
      },
      {
        "@type": "WorkflowStep",
        "name": "emails join",
        "arguments": {
          "email_join": "{{vars.emails | join(\',\')}}"
        },
        "status": null,
        "left": "400",
        "top": "560",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "95cd53ef-40d1-49e4-b8e2-c9b345e1772e"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send an Email to Assigned users",
        "arguments": {
          "name": "SMTP",
          "params": {
            "cc": "",
            "to": "{{vars.record.assignedTo.email}}",
            "bcc": "",
            "from": "no-reply@cybersponse.com",
            "content": "<p>Greetings,</p>  This is an auto-generated email for your approval.  {{ vars.record.approvaldescription }} Please follow the following link to approve/reject the request. <p> {{ vars.host }}/approvals/{{ vars.record.workflowid }}/{{vars.approval_id}}  </p> Thanks",
            "subject": "AUTO: Email for approval",
            "iri_list": "",
            "file_name": "",
            "file_path": ""
          },
          "version": "2.1.0",
          "connector": "smtp",
          "operation": "send_richtext_email",
          "operationTitle": "Send Rich Text Email",
          "step_variables": []
        },
        "status": null,
        "left": "20",
        "top": "360",
        "stepType": "/api/3/workflow_step_types/0bfed618-0316-11e7-93ae-92361f002671",
        "uuid": "17eec8bd-068f-4dd5-a7f3-efaed7f9efc7"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send an Email to the assigned Team",
        "arguments": {
          "name": "SMTP",
          "params": {
            "cc": "",
            "to": "{{vars.email_join}}",
            "bcc": "",
            "from": "no-reply@cybersponse.com",
            "content": "<p>Greetings,</p>  This is an auto-generated email for your approval.  {{ vars.record.approvaldescription }}  Please follow the following link to approve/reject the request. <p> {{ vars.host }}/approvals/{{vars.record.workflowid}}/{{vars.approval_id}} </p>  Thanks",
            "subject": "AUTO: Email for approval",
            "iri_list": "",
            "file_name": "",
            "file_path": ""
          },
          "version": "2.1.0",
          "connector": "smtp",
          "operation": "send_richtext_email",
          "operationTitle": "Send Rich Text Email",
          "step_variables": []
        },
        "status": null,
        "left": "800",
        "top": "560",
        "stepType": "/api/3/workflow_step_types/0bfed618-0316-11e7-93ae-92361f002671",
        "uuid": "42bd61b3-9978-4516-92c3-816a0b35fcd7"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "approvals",
          "step_variables": {
            "host": "https://{{vars.request.data.approvalhost}}",
            "record": "{{ vars.request.data }}",
            "approval_id": "{{vars.request.data[\"@id\"].strip().split(\'/\')[-1]}}"
          },
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "AND",
            "filters": [
              {
                "type": "object",
                "field": "method",
                "value": "/api/3/picklists/2a817063-e12a-496d-934d-381d22a95b3b",
                "_value": {
                  "itemValue": "Email"
                },
                "operator": "eq"
              },
              {
                "type": "object",
                "field": "assignedTo",
                "value": null,
                "_value": {
                  "display": "",
                  "itemValue": ""
                },
                "operator": "changed"
              },
              {
                "type": "object",
                "field": "assignedTo",
                "value": "false",
                "_value": [],
                "operator": "isnull"
              }
            ]
          }
        },
        "status": null,
        "left": "400",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "b249e047-2346-4fe5-908c-78b03ec22930"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "1d048061-3eaf-4ba6-b121-0721d1834d50",
        "name": "Fetch relations of the record -> Get emails of the team members",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/b458e711-bd33-4caf-9f44-ba66ce24e419",
        "sourceStep": "/api/3/workflow_steps/f2b71bbf-222d-446c-9877-f3a150554bd4"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "9518ba07-3d7a-4e9c-bc70-9b12b181f4a0",
        "name": "Check for assigned to -> Fetch relations of the record",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/f2b71bbf-222d-446c-9877-f3a150554bd4",
        "sourceStep": "/api/3/workflow_steps/a78bbf05-b408-46d9-a1cc-b326369bb284"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "f1897096-e97d-4b66-96f8-d8da1a6cf5be",
        "name": "Get emails of the team members -> emails join",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/95cd53ef-40d1-49e4-b8e2-c9b345e1772e",
        "sourceStep": "/api/3/workflow_steps/b458e711-bd33-4caf-9f44-ba66ce24e419"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "4fea87d5-68f5-441a-9e2c-2532d6690707",
        "name": "Check for assigned to -> Send an Email to Assigned users",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/17eec8bd-068f-4dd5-a7f3-efaed7f9efc7",
        "sourceStep": "/api/3/workflow_steps/a78bbf05-b408-46d9-a1cc-b326369bb284"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "622af3c4-c7ec-4cdd-8a77-906e30bd8318",
        "name": "emails join -> Send an Email to the assigned Team",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/42bd61b3-9978-4516-92c3-816a0b35fcd7",
        "sourceStep": "/api/3/workflow_steps/95cd53ef-40d1-49e4-b8e2-c9b345e1772e"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "7dd43716-8160-4a3c-b410-206b4af537b1",
        "name": "Start -> Check for assigned to",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/a78bbf05-b408-46d9-a1cc-b326369bb284",
        "sourceStep": "/api/3/workflow_steps/b249e047-2346-4fe5-908c-78b03ec22930"
      }
    ],
    "uuid": "9a00d4f9-ba1d-4e9c-9737-a16d49818029"
  }';

    private $taskResume = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Task Resume",
    "description": "This is a playbook is triggered for manual task triggers for revoking the approval.",
    "collection": "/api/3/workflow_collections/a9816e15-5e42-4785-a0ee-23fe8ddb19b6",
    "tag": null,
    "isActive": true,
    "singleRecordExecution": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/04988c73-8fa0-4555-aac5-8f340f7a36d8",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "arguments": {
          "resource": "tasks",
          "step_variables": {
            "record": "{{vars.request.data}}"
          },
          "fieldbasedtrigger": {
            "limit": 30,
            "logic": "OR",
            "filters": [
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/343f4b67-e929-4205-bf95-ba5b70545fed",
                "_value": {
                  "itemValue": "Completed"
                },
                "operator": "eq"
              },
              {
                "type": "object",
                "field": "status",
                "value": "/api/3/picklists/7bf6c03d-8e04-46d0-b392-febd78d72bad",
                "_value": {
                  "display": "Skipped",
                  "itemValue": "Skipped"
                },
                "operator": "eq"
              }
            ]
          }
        },
        "status": null,
        "left": "487",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/9300bf69-5063-486d-b3a6-47eb9da24872",
        "uuid": "04988c73-8fa0-4555-aac5-8f340f7a36d8"
      },
      {
        "@type": "WorkflowStep",
        "name": "Revoke requesting playbook",
        "arguments": {
          "when": "{{vars.record.workflowid}}",
          "script": "/wf/workflow/tasks/crudhub_crud",
          "arguments": {
            "method": "POST",
            "resource": "{\"status\": {{ vars.record.status}}, \"task_data\":  {{vars.record}} }",
            "collection": "/api/wf/api/workflows/{{vars.record.workflowid}}/resume/?format=json"
          },
          "step_variables": []
        },
        "status": null,
        "left": "488",
        "top": "140",
        "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
        "uuid": "d273bcf0-e6a6-48b6-9e5d-f25580c6a6e3"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "2c20704e-ab43-4db4-ad09-33cff8762f95",
        "name": "Start -> Revoke requesting playbook",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/d273bcf0-e6a6-48b6-9e5d-f25580c6a6e3",
        "sourceStep": "/api/3/workflow_steps/04988c73-8fa0-4555-aac5-8f340f7a36d8"
      }
    ],
    "uuid": "5fecc103-aa4b-4626-b69d-5e38697d89e3"
  }';

    private $escalate = '{
          "@type": "Workflow",
          "triggerLimit": null,
          "name": "Alert > Escalate To Incident",
          "description": "Creates a new incident with the given inputs and links the alert(s) to the newly created Incident.",
          "collection": "/api/3/workflow_collections/6368061c-c6ea-462b-b33f-75437efb0e3b",
          "tag": "#system",
          "isActive": true,
          "singleRecordExecution": false,
          "parameters": [],
          "synchronous": false,
          "triggerStep": "/api/3/workflow_steps/265765c0-0d62-4a4d-9653-9082077afd29",
          "steps": [
            {
              "@type": "WorkflowStep",
              "name": "Start",
              "description": null,
              "arguments": {
                "route": "ec48ee21-d65d-4615-b1fc-86d8982eec11",
                "title": "Escalate",
                "resources": [
                  "alerts"
                ],
                "inputVariables": [
                  {
                    "name": "incidentName",
                    "type": "string",
                    "title": "Text Field",
                    "usable": true,
                    "formType": "text",
                    "collection": false,
                    "dataSource": {
                      "model": "picklists",
                      "query": {
                        "sort": [
                          {
                            "field": "orderIndex",
                            "direction": "ASC"
                          }
                        ],
                        "logic": "AND",
                        "filters": [
                          {
                            "field": "listName__name",
                            "value": "AlertStatus",
                            "operator": "eq"
                          }
                        ]
                      }
                    },
                    "searchable": true,
                    "templateUrl": "app/components/form/fields/input.html",
                    "allowedGridColumn": true
                  },
                  {
                    "name": "severity",
                    "type": "picklists",
                    "title": "Picklist",
                    "usable": true,
                    "formType": "picklist",
                    "collection": false,
                    "dataSource": {
                      "model": "picklists",
                      "query": {
                        "sort": [
                          {
                            "field": "orderIndex",
                            "direction": "ASC"
                          }
                        ],
                        "logic": "AND",
                        "filters": [
                          {
                            "field": "listName__name",
                            "value": "Severity",
                            "operator": "eq"
                          }
                        ]
                      }
                    },
                    "searchable": false,
                    "templateUrl": "app/components/form/fields/typeahead.html",
                    "allowedGridColumn": true
                  },
                  {
                    "name": "incidentLead",
                    "type": "people",
                    "title": "Lookup",
                    "usable": true,
                    "formType": "lookup",
                    "collection": false,
                    "dataSource": {
                      "model": "people"
                    },
                    "searchable": false,
                    "templateUrl": "app/components/form/fields/typeahead.html",
                    "displayTemplate": "{{ firstname }} {{ lastname }}",
                    "allowedGridColumn": true
                  },
                  {
                    "name": "phase",
                    "type": "picklists",
                    "title": "Picklist",
                    "usable": true,
                    "formType": "picklist",
                    "collection": false,
                    "dataSource": {
                      "model": "picklists",
                      "query": {
                        "sort": [
                          {
                            "field": "orderIndex",
                            "direction": "ASC"
                          }
                        ],
                        "logic": "AND",
                        "filters": [
                          {
                            "field": "listName__name",
                            "value": "IncidentPhase",
                            "operator": "eq"
                          }
                        ]
                      }
                    },
                    "searchable": false,
                    "templateUrl": "app/components/form/fields/typeahead.html",
                    "allowedEncryption": false,
                    "allowedGridColumn": true
                  },
                  {
                    "name": "escalationReason",
                    "type": "string",
                    "formType": "text"
                  }
                ],
                "step_variables": [],
                "singleRecordExecution": false
              },
              "status": null,
              "left": "170",
              "top": "11",
              "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
              "uuid": "265765c0-0d62-4a4d-9653-9082077afd29"
            },
            {
              "@type": "WorkflowStep",
              "name": "Insert One Incident_Many_to_One",
              "description": null,
              "arguments": {
                "resource": {
                  "id": null,
                  "name": "{{vars.request.data.incidentName}}",
                  "dueby": null,
                  "notes": null,
                  "phase": "{{vars.request.data.phase}}",
                  "tasks": null,
                  "alerts": "{{ vars.request.data.records | json_query(\'[*].\"@id\"[]\') }}",
                  "assets": null,
                  "emails": null,
                  "owners": null,
                  "source": null,
                  "status": {
                    "id": 221,
                    "@id": "/api/3/picklists/bb73fe9e-f699-11e7-8c3f-9a214cf093ae",
                    "icon": null,
                    "@type": "Picklist",
                    "color": null,
                    "display": "Open",
                    "listName": "/api/3/picklist_names/a549e41c-31ca-406d-89ae-eab3de5c06c4",
                    "itemValue": "Open",
                    "orderIndex": 0
                  },
"persons": null,
                  "category": null,
                  "comments": null,
                  "filehash": null,
                  "severity": "{{vars.request.data.severity}}",
                  "sourceIP": null,
                  "sourceId": null,
                  "companies": null,
                  "deviceUID": null,
                  "dwellTime": null,
                  "nextsteps": null,
                  "createDate": null,
                  "createUser": null,
                  "indicators": null,
                  "modifyDate": null,
                  "modifyUser": null,
                  "resolution": null,
                  "sourcedata": null,
                  "attachments": null,
                  "description": "",
                  "targetAsset": null,
                  "assigneddate": null,
                  "discoveredOn": null,
                  "incidentLead": "{{vars.request.data.incidentLead}}",
                  "recoveryTime": null,
                  "resolveddate": null,
                  "senderDomain": null,
                  "destinationIP": null,
                  "dateOfIncident": null,
                  "containmentTime": null,
                  "incidentsummary": null,
                  "vulnerabilities": null,
                  "impactassessments": null,
                  "senderEmailAddress": null,
                  "systemAssignedQueue": null,
                  "receipientEmailAddress": null
                },
                "_showJson": false,
                "collection": "/api/3/incidents",
                "step_variables": {
    "incident": "{{ vars.result }}"
                }
              },
              "status": null,
              "left": "170",
              "top": "140",
              "stepType": "/api/3/workflow_step_types/2597053c-e718-44b4-8394-4d40fe26d357",
              "uuid": "fabf8f2c-8196-43f0-8860-08c4ff85f2d0"
            },
            {
                "@type": "WorkflowStep",
              "name": "Insert Comment",
              "description": null,
              "arguments": {
                "message": {
                    "content": "",
                  "records": "{{vars.request.data.records | json_query(\'[*][\"@id\"][]\') }}"
                },
                "resource": {
                    "id": null,
                  "scans": null,
                  "tasks": null,
                  "alerts": "{{vars.request.data.records | json_query(\'[*][\"@id\"][]\') }}",
                  "assets": null,
                  "emails": null,
                  "events": null,
                  "owners": null,
                  "people": null,
                  "content": "<p>This alert has been escalated to Incident id: {{ vars.incident.id }}</p>",
                  "schedule": null,
                  "approvals": null,
                  "companies": null,
                  "incidents": null,
                  "createDate": null,
                  "createUser": null,
                  "indicators": null,
                  "modifyDate": null,
                  "modifyUser": null,
                  "attachments": null,
                  "vulnerabilities": null
                },
                "_showJson": false,
                "collection": "/api/3/comments",
                "step_variables": []
              },
              "status": null,
              "left": "171",
              "top": "434",
              "stepType": "/api/3/workflow_step_types/2597053c-e718-44b4-8394-4d40fe26d357",
              "uuid": "96a6b26b-ba01-4246-90d6-cfdf8bc0c84b"
            },
            {
                "@type": "WorkflowStep",
              "name": "Set Escalate Status on Alert",
              "description": null,
              "arguments": {
                "for_each": {
                    "item": "{{vars.request.data.records}}",
                  "condition": ""
                },
                "resource": {
                    "escalationreason": "<p>{{vars.request.data.escalationReason}}</p>",
                  "escalatedtoincident": {
                        "id": 6807,
                    "@id": "/api/3/picklists/fa12313b-66af-4a2e-864e-a5f19241b734",
                    "icon": null,
                    "@type": "Picklist",
                    "color": "#bf0a0a",
                    "display": "Yes",
                    "listName": "/api/3/picklist_names/e131cc54-9ae4-43c9-b830-af6e331fe024",
                    "itemValue": "Yes",
                    "orderIndex": 0
                  }
                },
                "_showJson": false,
                "operation": "Create New",
                "collection": "{{vars.item[\"@id\"]}}",
                "collectionType": "/api/3/alerts",
                "step_variables": []
              },
              "status": null,
              "left": "170",
              "top": "295",
              "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
              "uuid": "b2c5a013-9602-4896-8d73-940cf2af2c77"
            },
            {
                "@type": "WorkflowStep",
              "name": "Set Playbook Result",
              "description": null,
              "arguments": {
                "@id": "{{vars.steps.Insert_One_Incident_Many_to_One[\'@id\']}}"
              },
              "status": null,
              "left": "172",
              "top": "550",
              "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
              "uuid": "a5050c24-904f-4d45-b61c-499ae1c19b18"
            }
          ],
          "routes": [
            {
                "@type": "WorkflowRoute",
              "uuid": "d83731db-8dc7-4949-a897-e492b0861d4a",
              "name": "Start -> Insert One Incident_Many_to_One",
              "label": null,
              "isExecuted": false,
              "targetStep": "/api/3/workflow_steps/fabf8f2c-8196-43f0-8860-08c4ff85f2d0",
              "sourceStep": "/api/3/workflow_steps/265765c0-0d62-4a4d-9653-9082077afd29"
            },
            {
                "@type": "WorkflowRoute",
              "uuid": "21130c68-76bb-4d11-816e-5a47b55bced4",
              "name": "Insert One Incident_Many_to_One -> Set Escalate Status on Alert",
              "label": null,
              "isExecuted": false,
              "targetStep": "/api/3/workflow_steps/b2c5a013-9602-4896-8d73-940cf2af2c77",
              "sourceStep": "/api/3/workflow_steps/fabf8f2c-8196-43f0-8860-08c4ff85f2d0"
            },
            {
                "@type": "WorkflowRoute",
              "uuid": "17ce2290-e2e3-4a30-b23a-1a0528f76832",
              "name": "Set Escalate Status on Alert -> Insert Comment",
              "label": null,
              "isExecuted": false,
              "targetStep": "/api/3/workflow_steps/96a6b26b-ba01-4246-90d6-cfdf8bc0c84b",
              "sourceStep": "/api/3/workflow_steps/b2c5a013-9602-4896-8d73-940cf2af2c77"
            },
            {
                "@type": "WorkflowRoute",
              "uuid": "fd1661ea-6147-43ac-8acb-493fe465d6a2",
              "name": "Insert Comment -> Set Playbook Result",
              "label": null,
              "isExecuted": false,
              "targetStep": "/api/3/workflow_steps/a5050c24-904f-4d45-b61c-499ae1c19b18",
              "sourceStep": "/api/3/workflow_steps/96a6b26b-ba01-4246-90d6-cfdf8bc0c84b"
            }
          ],
          "uuid": "6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e"
        }';


    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addWorkflow($this->approvalUpdate);
        $this->addWorkflow($this->taskResume);
        $this->addWorkflow($this->escalate);
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $workflowIds = [
            '9a00d4f9-ba1d-4e9c-9737-a16d49818029',
            '5fecc103-aa4b-4626-b69d-5e38697d89e3',
            '6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e'
        ];
        foreach($workflowIds as $workflowIId ){
            error_log($workflowIId);
            $this->deleteWorkflow($workflowIId);
        }
    }
}
