<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20181029144013 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    private $report_by_schedule = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Generate Report from Schedule",
    "description": "Generate report using scheduler in CyOPs",
    "collection": "/api/3/workflow_collections/3af01eb9-0887-415b-b7fd-4d45a9d2760f",
    "tag": "#CyOPs-Utilities",
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/944d9e56-0201-4cf5-9229-586440259b0b",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "description": null,
        "arguments": {
          "step_variables": []
        },
        "status": null,
        "left": "20",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
        "uuid": "944d9e56-0201-4cf5-9229-586440259b0b"
      },
      {
        "@type": "WorkflowStep",
        "name": "Save Response",
        "description": null,
        "arguments": {
          "response": "{{ vars.result.data }}",
          "inputParameters": "{{vars.request.data.records[0].inputParameters}}"
        },
        "status": null,
        "left": "380",
        "top": "211",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "58de668d-7806-4a54-b07e-2e0399a756e4"
      },
      {
        "@type": "WorkflowStep",
        "name": "Generate Report By Scheduler",
        "description": null,
        "arguments": {
          "name": "CyOPs Schedule Report",
          "params": {
            "scheduler_id": "{{vars.input.records[0][\'@id\']}}"
          },
          "version": "1.0.0",
          "connector": "cyops-schedule-report",
          "operation": "schedule_report",
          "operationTitle": "Generate Report By Scheduler",
          "step_variables": []
        },
        "status": null,
        "left": "220",
        "top": "128",
        "stepType": "/api/3/workflow_step_types/0bfed618-0316-11e7-93ae-92361f002671",
        "uuid": "36d90c6c-f636-4ca9-905a-aa30197c89f4"
      },
      {
        "@type": "WorkflowStep",
        "name": "Send Email",
        "description": null,
        "arguments": {
          "when": "{{vars.inputParameters.email}}",
          "config": "88c3d39c-2fa9-4731-b00d-29815008f17c",
          "params": {
            "cc": "{{vars.result.response.createUser.email}}",
            "to": "{{vars.inputParameters.email}}",
            "bcc": "",
            "from": "no-reply@cybersponse.com",
            "content": "This is an automatically generated email. Please do not reply to it.",
            "subject": "CyOPs: {{vars.request.data.records[0].name}}",
            "iri_list": "[\'{{vars.response.file[\'@id\']}}\']",
            "file_name": "{{vars.response.file.name}}",
            "file_path": "",
            "content_type": "text/plain"
          },
          "version": "2.2.0",
          "from_str": "soc@cybersponse.com",
          "connector": "smtp",
          "operation": "send_email",
          "operationTitle": "Send Email",
          "step_variables": []
        },
        "status": null,
        "left": "520",
        "top": "292",
        "stepType": "/api/3/workflow_step_types/4c0019b2-055c-44d0-968c-678a0c2d762e",
        "uuid": "e895980b-64d1-43fb-b809-00589fc15f6f"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "278bf937-39ca-401d-a867-6a950d10c47e",
        "name": "Save Report in CyOPs -> Save Response",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/58de668d-7806-4a54-b07e-2e0399a756e4",
        "sourceStep": "/api/3/workflow_steps/36d90c6c-f636-4ca9-905a-aa30197c89f4"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "3db005c5-e460-48b4-94a7-ffb160164f4a",
        "name": "Start -> Generate Report By Manual Trigger",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/36d90c6c-f636-4ca9-905a-aa30197c89f4",
        "sourceStep": "/api/3/workflow_steps/944d9e56-0201-4cf5-9229-586440259b0b"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "d817c17c-2dca-42c9-b24a-3ebf712dacbc",
        "name": "Save Response -> Send Email",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/e895980b-64d1-43fb-b809-00589fc15f6f",
        "sourceStep": "/api/3/workflow_steps/58de668d-7806-4a54-b07e-2e0399a756e4"
      }
    ],
    "uuid": "f4a7957e-8512-439b-9084-24620271ea43"
  }';

    private $report_by_trigger = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Generate Report By Manual Trigger",
    "description": "Generate report by manual trigger in CyOPs",
    "collection": "/api/3/workflow_collections/3af01eb9-0887-415b-b7fd-4d45a9d2760f",
    "tag": "#CyOPs-Utilities",
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/13a34f0f-e917-479d-b73e-421945e46776",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Save Response",
        "description": null,
        "arguments": {
          "response": "{{ vars.result.data }}"
        },
        "status": null,
        "left": "380",
        "top": "240",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "9868eea0-64bc-402d-943a-cce081e1b3c2"
      },
      {
        "@type": "WorkflowStep",
        "name": "Incidents",
        "description": null,
        "arguments": {
          "route": "7e6b6d01-63b3-485f-9bfe-931c335f2d0f",
          "title": "Generate Incident Summary Report",
          "resources": [
            "incidents"
          ],
          "inputVariables": [],
          "step_variables": {
            "input": {
              "records": "{{vars.request.data.records}}"
            }
          },
          "displayConditions": {
            "alerts": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            },
            "incidents": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            },
            "attachments": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            }
          },
          "executeButtonText": "Execute",
          "noRecordExecution": false,
          "singleRecordExecution": true
        },
        "status": null,
        "left": "20",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "13a34f0f-e917-479d-b73e-421945e46776"
      },
      {
        "@type": "WorkflowStep",
        "name": "Generate Report By Manual Trigger",
        "description": "",
        "arguments": {
          "name": "CyOPs Schedule Report",
          "params": {
            "user_id": "{{vars.currentUser}}",
            "timezone": "{{vars.request.headers.tz}}",
            "report_id": "4aa03e6e-5b6b-465a-a9b2-ab248f97c89a",
            "query_params": "{\"qparam\": {\"incidentID\": {{vars.item.id}} } }"
          },
          "version": "1.0.0",
          "for_each": {
            "item": "{{vars.input.records}}",
            "condition": ""
          },
          "connector": "cyops-schedule-report",
          "operation": "schedule_report_manual",
          "operationTitle": "Generate Report By Manual Trigger",
          "step_variables": []
        },
        "status": null,
        "left": "220",
        "top": "128",
        "stepType": "/api/3/workflow_step_types/0bfed618-0316-11e7-93ae-92361f002671",
        "uuid": "b8021131-7515-4cf3-90bf-b21ddace76e4"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "cbb38f7a-16b3-4ffa-bab0-46a8cd323d22",
        "name": "Alerts -> Save Report in CyOPs",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/b8021131-7515-4cf3-90bf-b21ddace76e4",
        "sourceStep": "/api/3/workflow_steps/13a34f0f-e917-479d-b73e-421945e46776"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "451dedd8-2f3a-411d-be73-70e7e9ede461",
        "name": "Save Report in CyOPs -> Save Response",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/9868eea0-64bc-402d-943a-cce081e1b3c2",
        "sourceStep": "/api/3/workflow_steps/b8021131-7515-4cf3-90bf-b21ddace76e4"
      }
    ],
    "uuid": "1cc7391f-6c01-491f-a1ec-d6b03035d8d5"
  }';

    private $report_immediately = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Export Report",
    "description": null,
    "collection": "/api/3/workflow_collections/3af01eb9-0887-415b-b7fd-4d45a9d2760f",
    "tag": "#CyOPs-Utilities",
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/ab06ef05-70a3-4da7-967c-8ead6e545b33",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "description": null,
        "arguments": {
          "route": "generatePDFReport",
          "step_variables": {
            "input": {
              "params": {
                "api_body": "{{vars.request.data}}"
              }
            }
          },
          "authentication_methods": [
            ""
          ]
        },
        "status": null,
        "left": "20",
        "top": "20",
        "stepType": "/api/3/workflow_step_types/df26c7a2-4166-4ca5-91e5-548e24c01b5f",
        "uuid": "ab06ef05-70a3-4da7-967c-8ead6e545b33"
      },
      {
        "@type": "WorkflowStep",
        "name": "Generate PDF",
        "description": null,
        "arguments": {
          "name": "CyOPs Schedule Report",
          "params": {
            "user_id": "{{vars.currentUser}}",
            "timezone": "{{vars.request.headers.tz}}",
            "report_id": "{{vars.input.params.api_body.reportId}}",
            "query_params": "{{vars.input.params.api_body.reportParams}}"
          },
          "version": "1.0.0",
          "connector": "cyops-schedule-report",
          "operation": "schedule_report_manual",
          "operationTitle": "Generate Incident Summary Report",
          "step_variables": []
        },
        "status": null,
        "left": "340",
        "top": "240",
        "stepType": "/api/3/workflow_step_types/0bfed618-0316-11e7-93ae-92361f002671",
        "uuid": "383fbf78-b0b2-46f3-b8eb-de993cae683e"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "bf73a052-3a0c-435b-8311-79cefe139d74",
        "name": "Start -> Generate PDF",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/383fbf78-b0b2-46f3-b8eb-de993cae683e",
        "sourceStep": "/api/3/workflow_steps/ab06ef05-70a3-4da7-967c-8ead6e545b33"
      }
    ],
    "uuid": "a9fb090d-6469-43c0-be2a-810e7d567714"
  }';


    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addWorkflow($this->report_by_schedule);
        $this->addWorkflow($this->report_by_trigger);
        $this->addWorkflow($this->report_immediately);
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $workflowIds = [
            'f4a7957e-8512-439b-9084-24620271ea43',
            '1cc7391f-6c01-491f-a1ec-d6b03035d8d5',
            'a9fb090d-6469-43c0-be2a-810e7d567714'
        ];
        foreach($workflowIds as $workflowIId ){
            error_log($workflowIId);
            $this->deleteWorkflow($workflowIId);
        }
    }
}
