<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20190103075551 extends AbstractMigration implements ContainerAwareInterface
{

    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');

        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->deleteWorkflow('ebda6780-4eaf-47de-9a68-20a50b1ae8a2');
        $this->deleteWorkflow('6c1a4f1c-2a9b-4d35-889b-c858f9bcc45d');
        $this->deleteWorkflow('059d1d15-4ba3-4ee2-8426-2431ec4cbf63');

        $this->deleteWorkflow('ad09d809-0339-4ef1-819b-3b3ae398003c');
        $this->deleteWorkflow('5beda203-0dbf-481f-afdd-a7e07f1f93fd');
        $this->deleteWorkflow('f1a3e870-7410-4a9f-bb58-579e24f9ad11');

        $this->deleteWorkflow('a507278b-b8ee-4b0f-9765-845e384dbb2a');
        $this->deleteWorkflow('ebfc713a-3ed3-4ccf-a53d-a8e2a369d242');
        $this->deleteWorkflow('328b3435-1fb8-45fd-8cdf-46e35c2ab2ef');

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
