<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20190103084344 extends AbstractMigration implements ContainerAwareInterface
{
    private $container;

    private $start_schedule = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Start Schedule",
      "description": "Playbook for starting schedule",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/f71b7986-85e1-4978-b073-c426f6321125",
      "steps": [{
          "@type": "WorkflowStep",
          "name": "Start periodic playbook",
          "description": null,
          "arguments": {
            "script": "/wf/workflow/tasks/start_periodic",
            "arguments": {
              "schedule": "{{vars.input.records[0].cronexpression}}",
              "workflow_iri": "/api/3/workflows/{{vars.input.records[0].uuidofplaybook}}"
            },
            "step_variables": []
          },
          "status": null,
          "left": "70",
          "top": "300",
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
          "uuid": "e8c07654-37d8-42e3-9943-8ea4a9bb58aa"
        },
        {
          "@type": "WorkflowStep",
          "name": "Configuration",
          "description": null,
          "arguments": {
            "uuid_of_pb": "{{vars.input.records[0].uuidofplaybook}}",
            "cron_expression": "{{vars.input.records[0].cronexpression}}",
            "loop_resource_id": "{{vars.input.records[0][\"@id\"]}}",
            "scheduler_status": "{{vars.input.records[0].schedularStatus[\"@id\"]}}"
          },
          "status": null,
          "left": "380",
          "top": "120",
          "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
          "uuid": "3309d41f-c45e-47f0-bced-2ab1cca48ab9"
        },
        {
          "@type": "WorkflowStep",
          "name": "Error message",
          "description": null,
          "arguments": {
            "script": "/wf/workflow/tasks/panic",
            "arguments": {
              "msg": "\"Currently running schedules cannot be re-started. Please Verify!\""
            }
          },
          "status": null,
          "left": "680",
          "top": "310",
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
          "uuid": "ed0ad42c-cf9a-4a83-9488-9112d3deb528"
        },
        {
          "@type": "WorkflowStep",
          "name": "Is Scheduler Running",
          "description": null,
          "arguments": {
            "conditions": [{
                "option": "No",
                "step_iri": "/api/3/workflow_steps/e8c07654-37d8-42e3-9943-8ea4a9bb58aa",
                "condition": "{{ vars.input.records[0].schedularStatus[\"@id\"]  != \"/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\" }}"
              },
              {
                "option": "Yes",
                "step_iri": "/api/3/workflow_steps/ed0ad42c-cf9a-4a83-9488-9112d3deb528",
                "condition": "{{ vars.input.records[0].schedularStatus[\"@id\"]  == \"/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\" }}"
              }
            ]
          },
          "status": null,
          "left": "380",
          "top": "232",
          "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
          "uuid": "033ca95d-655f-4ad3-b80f-e2743ea19042"
        },
        {
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "route": "f0b6507b-330a-4647-aa54-98691479c9a4",
            "title": "Start Schedule",
            "resources": [
              "schedules"
            ],
            "inputVariables": [],
            "step_variables": {
              "input": {
                "records": "{{vars.request.data.records}}"
              }
            },
            "displayConditions": {
              "schedules": {
                "sort": [],
                "limit": 30,
                "logic": "AND",
                "filters": []
              }
            },
            "executeButtonText": "Execute",
            "noRecordExecution": false,
            "singleRecordExecution": true
          },
          "status": null,
          "left": "380",
          "top": "9",
          "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
          "uuid": "f71b7986-85e1-4978-b073-c426f6321125"
        },
        {
          "@type": "WorkflowStep",
          "name": "Update Schedule Record",
          "description": null,
          "arguments": {
            "resource": {
              "cronJobId": "{{ vars.result }}",
              "schedulestart": "{{ arrow.utcnow().timestamp }}",
              "schedularStatus": {
                "id": 291,
                "@id": "/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a",
                "icon": null,
                "@type": "Picklist",
                "color": "#46a31a",
                "display": "Running",
                "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
                "itemValue": "Running",
                "orderIndex": 1
              }
            },
            "_showJson": false,
            "operation": "Overwrite",
            "collection": "{{vars.input.records[0][\"@id\"]}}",
            "collectionType": "/api/3/schedules",
            "step_variables": []
          },
          "status": null,
          "left": "70",
          "top": "400",
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
          "uuid": "b2141143-840b-4923-88ec-8344ae3a0130"
        }
      ],
      "routes": [{
          "@type": "WorkflowRoute",
          "uuid": "1bcfacfd-f13c-4a15-b0bd-b00c2b40f8c0",
          "name": "Is Scheduler Running -> Start periodic playbook",
          "label": "No",
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/e8c07654-37d8-42e3-9943-8ea4a9bb58aa",
          "sourceStep": "/api/3/workflow_steps/033ca95d-655f-4ad3-b80f-e2743ea19042"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "31a80720-f319-4a6e-8723-b92eae23cf0d",
          "name": "Get child PB data -> Is Scheduler Running",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/033ca95d-655f-4ad3-b80f-e2743ea19042",
          "sourceStep": "/api/3/workflow_steps/3309d41f-c45e-47f0-bced-2ab1cca48ab9"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "daedd86b-407c-4a1c-8b77-7181330dd1ba",
          "name": "Is Scheduler Running -> Error message",
          "label": "Yes",
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/ed0ad42c-cf9a-4a83-9488-9112d3deb528",
          "sourceStep": "/api/3/workflow_steps/033ca95d-655f-4ad3-b80f-e2743ea19042"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "ddc502ae-2465-46a9-84b2-7e25cdb870eb",
          "name": "Start -> Get child PB data",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/3309d41f-c45e-47f0-bced-2ab1cca48ab9",
          "sourceStep": "/api/3/workflow_steps/f71b7986-85e1-4978-b073-c426f6321125"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "a2b7c508-036c-4eeb-8dfa-dea4fde5eeb0",
          "name": "Start periodic playbook -> Update Schedule Record",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/b2141143-840b-4923-88ec-8344ae3a0130",
          "sourceStep": "/api/3/workflow_steps/e8c07654-37d8-42e3-9943-8ea4a9bb58aa"
        }
      ],
      "versions": [],
      "uuid": "ebda6780-4eaf-47de-9a68-20a50b1ae8a2"
    }';

    private $refresh_schedule = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Refresh Schedule",
      "description": "Playbook for updating schedule details",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/07c6a7b8-d9ce-41a4-ac0a-ca4a392083f3",
      "steps": [{
          "@type": "WorkflowStep",
          "name": "Get Cron Job Info",
          "description": null,
          "arguments": {
            "params": {
              "iri": "/api/wf/api/scheduled/{{vars.input.records[0].cronJobId}}/?format=json",
              "body": "{{vars.input.records[0].cronJobId}}",
              "method": "GET"
            },
            "version": "2.1.3",
            "connector": "cyops_utilities",
            "operation": "make_cyops_request",
            "operationTitle": "CyOPs: Make CyOPs API Call",
            "step_variables": {
              "lastRunAt": "{{vars.result.data.last_run_at}}",
              "workflowName": "{{vars.result.data.workflow_name}}",
              "totalRunCount": "{{vars.result.data.total_run_count}}"
            }
          },
          "status": null,
          "left": "520",
          "top": "80",
          "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
          "uuid": "74d3a634-e9ba-41e9-ad25-d10b782f9d5e"
        },
        {
          "@type": "WorkflowStep",
          "name": "Update Schedule Entry",
          "description": null,
          "arguments": {
            "resource": {
              "lastRunAt": "{{arrow.get(vars.lastRunAt).timestamp}}",
              "workflowName": "{{vars.workflowName}}",
              "totalRunCount": "{{vars.totalRunCount}}"
            },
            "_showJson": false,
            "operation": "Overwrite",
            "collection": "{{vars.input.records[0][\"@id\"]}}",
            "collectionType": "/api/3/schedules",
            "step_variables": []
          },
          "status": null,
          "left": "840",
          "top": "140",
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
          "uuid": "b1708c42-a01c-469d-a994-baead6396f9c"
        },
        {
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "route": "b18e46e0-8f49-4cdb-b9b7-b0c69f5a9452",
            "title": "Update Schedule",
            "resources": [
              "schedules"
            ],
            "inputVariables": [],
            "step_variables": {
              "input": {
                "records": "{{vars.request.data.records}}"
              }
            },
            "displayConditions": {
              "schedules": {
                "sort": [],
                "limit": 30,
                "logic": "AND",
                "filters": []
              }
            },
            "executeButtonText": "Execute",
            "noRecordExecution": false,
            "singleRecordExecution": true
          },
          "status": null,
          "left": "180",
          "top": "7",
          "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
          "uuid": "07c6a7b8-d9ce-41a4-ac0a-ca4a392083f3"
        }
      ],
      "routes": [{
          "@type": "WorkflowRoute",
          "uuid": "d765dad5-1651-4803-bcbc-29a8a97d987f",
          "name": "Get Cron Job Info -> Update Schedule Entry",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/b1708c42-a01c-469d-a994-baead6396f9c",
          "sourceStep": "/api/3/workflow_steps/74d3a634-e9ba-41e9-ad25-d10b782f9d5e"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "d30cab07-7d60-4def-9ef1-7f47c06013c8",
          "name": "Start -> Get Cron Job Info",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/74d3a634-e9ba-41e9-ad25-d10b782f9d5e",
          "sourceStep": "/api/3/workflow_steps/07c6a7b8-d9ce-41a4-ac0a-ca4a392083f3"
        }
      ],
      "versions": [],
      "uuid": "059d1d15-4ba3-4ee2-8426-2431ec4cbf63"
    }
    ';

    private $stop_schedule = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Stop Schedule",
      "description": "Playbook for stopping schedule",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/9cfe7e7b-c02c-4a1b-a015-58d0a600dc98",
      "steps": [{
          "@type": "WorkflowStep",
          "name": "Stop Periodic Playbook",
          "description": null,
          "arguments": {
            "when": "{{vars.input.records[0].schedularStatus[\"@id\"] == \"/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\"}}",
            "script": "/wf/workflow/tasks/stop_periodic",
            "arguments": {
              "redis_schedule_entry_id": "{{vars.input.records[0].cronJobId}}"
            },
            "step_variables": []
          },
          "status": null,
          "left": "400",
          "top": "140",
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
          "uuid": "57f2eff6-feb7-4821-aafd-0376224a475f"
        },
        {
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "route": "f7b23933-a825-4d7f-b448-f2768dde6b4f",
            "title": "Stop Schedule",
            "resources": [
              "schedules"
            ],
            "inputVariables": [],
            "step_variables": {
              "input": {
                "records": "{{vars.request.data.records}}"
              }
            },
            "displayConditions": {
              "schedules": {
                "sort": [],
                "limit": 30,
                "logic": "AND",
                "filters": []
              }
            },
            "executeButtonText": "Execute",
            "noRecordExecution": false,
            "singleRecordExecution": true
          },
          "status": null,
          "left": "348",
          "top": "20",
          "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
          "uuid": "9cfe7e7b-c02c-4a1b-a015-58d0a600dc98"
        },
        {
          "@type": "WorkflowStep",
          "name": "Update Schedule Record",
          "description": null,
          "arguments": {
            "resource": {
              "schedularStatus": {
                "id": 290,
                "@id": "/api/3/picklists/8eb5d9e6-176f-41ee-92e6-cda1c5dec7fc",
                "icon": null,
                "@type": "Picklist",
                "color": "#a82f14",
                "display": "Stopped",
                "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
                "itemValue": "Stopped",
                "orderIndex": 2
              }
            },
            "_showJson": false,
            "operation": "Overwrite",
            "collection": "{{vars.input.records[0][\"@id\"]}}",
            "collectionType": "/api/3/schedules",
            "step_variables": []
          },
          "status": null,
          "left": "480",
          "top": "260",
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
          "uuid": "0a776886-0099-4d04-89ba-04a7dedd444c"
        }
      ],
      "routes": [{
          "@type": "WorkflowRoute",
          "uuid": "83ac5f77-5cfc-4380-8ce0-a2d1cfd37bb9",
          "name": "Start -> Stop Periodic Playbook",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/57f2eff6-feb7-4821-aafd-0376224a475f",
          "sourceStep": "/api/3/workflow_steps/9cfe7e7b-c02c-4a1b-a015-58d0a600dc98"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "067a70aa-ec2c-46af-a605-b296a3f125eb",
          "name": "Stop Periodic Playbook -> Update Schedule Record",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/0a776886-0099-4d04-89ba-04a7dedd444c",
          "sourceStep": "/api/3/workflow_steps/57f2eff6-feb7-4821-aafd-0376224a475f"
        }
      ],
      "versions": [],
      "uuid": "5beda203-0dbf-481f-afdd-a7e07f1f93fd"
    }
    ';

    private $scheule_status = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Set Schedule Default Status",
      "description": "Sets default scheduler status to Draft on schedule creation",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/7b8427cd-e269-4ea4-bd83-bd97d95bbedd",
      "steps": [{
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "resource": "schedules"
          },
          "status": null,
          "left": "173",
          "top": "40",
          "stepType": "/api/3/workflow_step_types/ea155646-3821-4542-9702-b246da430a8d",
          "uuid": "7b8427cd-e269-4ea4-bd83-bd97d95bbedd"
        },
        {
          "@type": "WorkflowStep",
          "name": "Update Schedule State to Draft",
          "description": null,
          "arguments": {
            "resource": {
              "schedularStatus": {
                "id": 289,
                "@id": "/api/3/picklists/51c7463e-571c-4788-bc09-fbda4d864ad0",
                "icon": null,
                "@type": "Picklist",
                "color": "#949494",
                "display": "Draft",
                "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
                "itemValue": "Draft",
                "orderIndex": 0
              }
            },
            "_showJson": false,
            "operation": "Overwrite",
            "collection": "{{vars.input.records[0][\"@id\"]}}",
            "collectionType": "/api/3/schedules",
            "step_variables": []
          },
          "status": null,
          "left": "220",
          "top": "160",
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
          "uuid": "f0c72902-bf81-4bee-a910-fcf952ef63be"
        }
      ],
      "routes": [{
        "@type": "WorkflowRoute",
        "uuid": "f6370c4c-7627-4941-b9da-0a31dc5cea1e",
        "name": "Start -> Update Schedule State to Draft",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/f0c72902-bf81-4bee-a910-fcf952ef63be",
        "sourceStep": "/api/3/workflow_steps/7b8427cd-e269-4ea4-bd83-bd97d95bbedd"
      }],
      "versions": [],
      "uuid": "a507278b-b8ee-4b0f-9765-845e384dbb2a"
    }
    ';

    private $delete_schedule = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Delete Schedule",
      "description": "System playbook to stop running playbook",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/600d174b-3cc1-4a43-8ee7-81cf737824b5",
      "steps": [
        {
          "@type": "WorkflowStep",
          "name": "Stop Periodic Playbook",
          "description": null,
          "arguments": {
            "script": "/wf/workflow/tasks/stop_periodic",
            "arguments": {
              "redis_schedule_entry_id": "{{vars.input.records[0].cronJobId}}"
            },
            "step_variables": []
          },
          "status": null,
          "left": "400",
          "top": "100",
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
          "uuid": "d116e4d0-47ca-4e72-9402-ab97e364fe9c"
        },
        {
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "resource": "schedules",
            "resources": [
              "schedules"
            ],
            "step_variables": {
              "input": {
                "records": [
                  "{{vars.request.data}}"
                ]
              }
            },
            "fieldbasedtrigger": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": [
                {
                  "type": "object",
                  "field": "schedularStatus",
                  "value": "/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a",
                  "_value": {
                    "display": "Running",
                    "itemValue": "Running"
                  },
                  "operator": "eq"
                }
              ]
            }
          },
          "status": null,
          "left": "51",
          "top": "20",
          "stepType": "/api/3/workflow_step_types/ef350fda-1771-477a-8f90-16f68cd7e5cb",
          "uuid": "600d174b-3cc1-4a43-8ee7-81cf737824b5"
        }
      ],
      "routes": [
        {
          "@type": "WorkflowRoute",
          "uuid": "b62907c4-02bf-465e-a4df-a80862a586e7",
          "name": "Start -> Stop Periodic Playbook",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/d116e4d0-47ca-4e72-9402-ab97e364fe9c",
          "sourceStep": "/api/3/workflow_steps/600d174b-3cc1-4a43-8ee7-81cf737824b5"
        }
      ],
      "versions": [],
      "uuid": "ebfc713a-3ed3-4ccf-a53d-a8e2a369d242"
    }';

    private $restart_schedule = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Restart Schedule",
      "description": "Playbook for restarting schedule",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/9f961843-974b-4b53-a9a2-0f041b9e615a",
      "steps": [
        {
          "@type": "WorkflowStep",
          "name": "Stop Periodic Playbook",
          "description": null,
          "arguments": {
            "when": "{{vars.input.records[0].schedularStatus[\"@id\"] == \"/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a\"}}",
            "script": "/wf/workflow/tasks/stop_periodic",
            "arguments": {
              "redis_schedule_entry_id": "{{vars.input.records[0].cronJobId}}"
            },
            "step_variables": []
          },
          "status": null,
          "left": "506",
          "top": "133",
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
          "uuid": "edfc500a-1ac4-4386-b60e-a4d713957bdb"
        },
        {
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "route": "114f23d7-6cd9-4d3b-9356-1bc608454079",
            "title": "Restart Schedule",
            "resources": [
              "schedules"
            ],
            "inputVariables": [],
            "step_variables": {
              "input": {
                "records": "{{vars.request.data.records}}"
              }
            },
            "displayConditions": {
              "schedules": {
                "sort": [],
                "limit": 30,
                "logic": "AND",
                "filters": []
              }
            },
            "executeButtonText": "Execute",
            "noRecordExecution": false,
            "singleRecordExecution": true
          },
          "status": null,
          "left": "348",
          "top": "20",
          "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
          "uuid": "9f961843-974b-4b53-a9a2-0f041b9e615a"
        },
        {
          "@type": "WorkflowStep",
          "name": "Start Periodic Playbook",
          "description": null,
          "arguments": {
            "script": "/wf/workflow/tasks/start_periodic",
            "arguments": {
              "schedule": "{{vars.input.records[0].cronexpression}}",
              "workflow_iri": "/api/3/workflows/{{vars.input.records[0].uuidofplaybook}}"
            },
            "step_variables": []
          },
          "status": null,
          "left": "710",
          "top": "248",
          "stepType": "/api/3/workflow_step_types/ee73e569-2188-43fe-a7f0-1964ba82a4de",
          "uuid": "804a785b-8ae4-4dc0-9622-0a90a6e74483"
        },
        {
          "@type": "WorkflowStep",
          "name": "Update Schedule Record",
          "description": null,
          "arguments": {
            "resource": {
              "cronJobId": "{{ vars.result }}",
              "schedulestart": "{{ arrow.utcnow().timestamp }}",
              "schedularStatus": {
                "id": 291,
                "@id": "/api/3/picklists/c7e3ac7c-9556-4fae-9899-0394ce982f0a",
                "icon": null,
                "@type": "Picklist",
                "color": "#46a31a",
                "display": "Running",
                "listName": "/api/3/picklist_names/fcefb7d8-2bf3-4505-967f-443ffc396034",
                "itemValue": "Running",
                "orderIndex": 1
              }
            },
            "_showJson": false,
            "operation": "Overwrite",
            "collection": "{{vars.input.records[0][\"@id\"]}}",
            "collectionType": "/api/3/schedules",
            "step_variables": []
          },
          "status": null,
          "left": "893",
          "top": "360",
          "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
          "uuid": "9e3b04ba-7616-4ee4-b411-2ec4f3efb7da"
        }
      ],
      "routes": [
        {
          "@type": "WorkflowRoute",
          "uuid": "a4bdc024-8678-4e60-b63b-eb4d57ac2006",
          "name": "Start -> Stop Periodic Playbook",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/edfc500a-1ac4-4386-b60e-a4d713957bdb",
          "sourceStep": "/api/3/workflow_steps/9f961843-974b-4b53-a9a2-0f041b9e615a"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "a406f497-e925-4de6-aacd-d684c428a200",
          "name": "Stop Periodic Playbook -> Copy  of Stop Periodic Playbook",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/804a785b-8ae4-4dc0-9622-0a90a6e74483",
          "sourceStep": "/api/3/workflow_steps/edfc500a-1ac4-4386-b60e-a4d713957bdb"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "06d3ae29-36a8-4d5d-a669-7787cb7c34bc",
          "name": "Start Periodic Playbook -> Update Schedule Record",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/9e3b04ba-7616-4ee4-b411-2ec4f3efb7da",
          "sourceStep": "/api/3/workflow_steps/804a785b-8ae4-4dc0-9622-0a90a6e74483"
        }
      ],
      "versions": [],
      "uuid": "6477a44b-26c5-4dd8-9b18-88fd49396a81"
    }';

    private $playbook_exec_history = '
    {
      "@type": "Workflow",
      "triggerLimit": null,
      "name": "Playbook execution history cleanup",
      "description": "Workflow for Scheduling Playbook Execution History Cleanup",
      "collection": "/api/3/workflow_collections/82ea5860-0308-4fd3-90cd-3a4893781ee2",
      "tag": "#system",
      "isActive": true,
      "singleRecordExecution": false,
      "remoteExecutableFlag": false,
      "parameters": [],
      "synchronous": false,
      "triggerStep": "/api/3/workflow_steps/00d37ec1-f828-46a3-8d8d-3bf7d0a8af02",
      "steps": [{
          "@type": "WorkflowStep",
          "name": "Start",
          "description": null,
          "arguments": {
            "step_variables": []
          },
          "status": null,
          "left": "20",
          "top": "20",
          "stepType": "/api/3/workflow_step_types/b348f017-9a94-471f-87f8-ce88b6a7ad62",
          "uuid": "00d37ec1-f828-46a3-8d8d-3bf7d0a8af02"
        },
        {
          "@type": "WorkflowStep",
          "name": "cleanup",
          "description": null,
          "arguments": {
            "params": {
              "iri": "/api/wf/api/workflows/delete/?format=json",
              "body": "{\"days\": {{vars.ttl_config.ttl}} }",
              "method": "DELETE"
            },
            "version": "2.1.1",
            "connector": "cyops_utilities",
            "operation": "make_cyops_request",
            "operationTitle": "CyOPs: Make CyOPs API Call",
            "step_variables": []
          },
          "status": null,
          "left": "20",
          "top": "260",
          "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
          "uuid": "77cbf88d-7e72-438e-a00e-9b7056d095c0"
        },
        {
          "@type": "WorkflowStep",
          "name": "Fetch PB Log TTL Settings",
          "description": null,
          "arguments": {
            "params": {
              "iri": "/api/3/system_settings",
              "body": "",
              "method": "GET"
            },
            "version": "2.1.1",
            "connector": "cyops_utilities",
            "operation": "make_cyops_request",
            "operationTitle": "CyOPs: Make CyOPs API Call",
            "step_variables": {
              "ttl_config": "{{vars.result.data[\"hydra:member\"][0][\"publicValues\"][\"workflow_ttl_config\"]}}"
            }
          },
          "status": null,
          "left": "20",
          "top": "140",
          "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
          "uuid": "4408958d-fc31-4ce8-928b-afebd061a3d5"
        }
      ],
      "routes": [{
          "@type": "WorkflowRoute",
          "uuid": "41cee7b1-d6dc-4cd5-b2cd-6a823dd7890c",
          "name": "Start -> Fetch PB Log TTL Settings",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/4408958d-fc31-4ce8-928b-afebd061a3d5",
          "sourceStep": "/api/3/workflow_steps/00d37ec1-f828-46a3-8d8d-3bf7d0a8af02"
        },
        {
          "@type": "WorkflowRoute",
          "uuid": "653875c4-d571-4ec7-b589-b11e34ad307a",
          "name": "Fetch PB Log TTL Settings -> cleanup",
          "label": null,
          "isExecuted": false,
          "targetStep": "/api/3/workflow_steps/77cbf88d-7e72-438e-a00e-9b7056d095c0",
          "sourceStep": "/api/3/workflow_steps/4408958d-fc31-4ce8-928b-afebd061a3d5"
        }
      ],
      "versions": [],
      "uuid": "26f1077a-c334-43bb-a10a-77b2593a121f"
    }';

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addWorkflow($workflow){
        $workflowResource = $this->container->get('resource.workflow');
        $context = $workflowResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;
        $workflowObject = $this->container->get('serializer')->deserialize(
            $workflow,
            $workflowResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowManager->persist($workflowObject);
        $workflowManager->flush();
    }

    private function deleteWorkflow($workflowId){
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if($workflowToDelete==null or sizeof($workflowToDelete)==0){
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addWorkflow($this->start_schedule);
        $this->addWorkflow($this->refresh_schedule);
        $this->addWorkflow($this->stop_schedule);
        $this->addWorkflow($this->scheule_status);
        $this->addWorkflow($this->delete_schedule);
        $this->addWorkflow($this->restart_schedule);
        $this->addWorkflow($this->playbook_exec_history);

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $workflowIds = [
            'ebda6780-4eaf-47de-9a68-20a50b1ae8a2',
            '059d1d15-4ba3-4ee2-8426-2431ec4cbf63',
            '5beda203-0dbf-481f-afdd-a7e07f1f93fd',
            'a507278b-b8ee-4b0f-9765-845e384dbb2a',
            'ebfc713a-3ed3-4ccf-a53d-a8e2a369d242',
            '6477a44b-26c5-4dd8-9b18-88fd49396a81',
            '26f1077a-c334-43bb-a10a-77b2593a121f'
        ];
        foreach($workflowIds as $workflowIId ){
            error_log($workflowIId);
            $this->deleteWorkflow($workflowIId);
        }
    }
}
