<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20190726075639 extends AbstractMigration implements ContainerAwareInterface
{

    private $container;

    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function deleteWorkflow($workflowId)
    {
        /** @var ResourceInterface $workflowResource */
        $workflowResource = $this->container->get('resource.workflow');
        $managerRegistry = $this->container->get('doctrine');
        $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
        $workflowToDelete = $workflowManager->find($workflowResource->getEntityClass(), $workflowId);
        if ($workflowToDelete == null or sizeof($workflowToDelete) == 0) {
            $workflowManager->flush();
            return;
        }
        $workflowManager->remove($workflowToDelete);
        $workflowManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $workflowId = '5fecc103-aa4b-4626-b69d-5e38697d89e3';
        $this->deleteWorkflow($workflowId);

        $notifyOwnersWorkflowId = 'dbe2606d-e5fe-4737-96a7-5d5631eaf723';
        $this->deleteWorkflow($notifyOwnersWorkflowId);

        $notifyUpdatedOwnersWorkflowId = '9a00d4f9-ba1d-4e9c-9737-a16d49818029';
        $this->deleteWorkflow($notifyUpdatedOwnersWorkflowId);

        $fetchResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'tasks'");
        $tasksUuid = $fetchResults[0]['uuid'];
        $this->addSql("INSERT INTO attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES ('32dbebf7-9c50-49dc-8d8d-085cf9b5c0b6', '" . $tasksUuid ."', 'integer', 'stepid', 0, 27, 'integer', NULL, false, true, false, false, false, false, NULL, NULL, '{\"required\":false,\"minlength\":0,\"maxlength\":-1}', '{\"allow\":false}', NULL, '', '', 'false', true, true, false, false, '{{ stepid }}', '{\"singular\":\"Step ID\"}');");

        $fetchResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'approvals'");
        $approvalsUuid = $fetchResults[0]['uuid'];
        $this->addSql("INSERT INTO attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES ('1417c358-6a7c-478a-b63d-7b7b24bfc94e', '" . $approvalsUuid . "', 'integer', 'stepid', 0, 27, 'integer', NULL, false, true, false, false, false, false, NULL, NULL, '{\"required\":false,\"minlength\":0,\"maxlength\":-1}', '{\"allow\":false}', NULL, '', '', 'false', true, true, false, false, '{{ stepid }}', '{\"singular\":\"Step ID\"}');");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $workflowId = '5fecc103-aa4b-4626-b69d-5e38697d89e3';
        $this->deleteWorkflow($workflowId);
        $this->addSql("DELETE from attribute_metadatas where uuid='1417c358-6a7c-478a-b63d-7b7b24bfc94e'");
        $this->addSql("DELETE from attribute_metadatas where uuid='32dbebf7-9c50-49dc-8d8d-085cf9b5c0b6'");
    }
}
