<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20190816070306 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $fetchTenantResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'tenants'");
        if(count($fetchTenantResults)) {
            $tenantUuid = $fetchTenantResults[0]['uuid'];
            $isDedicated  = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES ('a829531c-07dc-48bd-8d5b-f38283fcc60f', '" . $tenantUuid ."', 'boolean', 'isDedicated', 0, 8, 'checkbox', NULL, true, true, true, false, true, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '0', 'Select this option if the Tenant is not a distributed or remote tenant. Shared tenant, based on their permissions, will share the current CyOPs instance with Master.', 'true', true, false, false, false, '{{ isDedicated }}', '{\"singular\":\"Dedicated Tenant\"}');";
            $this->addSql($isDedicated );
            $this->addSql("delete from attribute_metadatas where name='isLocal' and sattrib='" . $tenantUuid ."'");   
        }
        $this->addSql("ALTER TABLE if exists tenants ADD COLUMN IF NOT EXISTS isDedicated BOOLEAN DEFAULT FALSE");
        $this->addSql("update tenants set isDedicated=true where isLocal=false");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        $fetchTenantResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'tenants'");
        if(count($fetchTenantResults)) {
            $tenantUuid = $fetchTenantResults[0]['uuid'];
            $this->addSql("delete from attribute_metadatas where name='isDedicated' and sattrib='" . $tenantUuid ."'");
        }
        $this->addSql("ALTER TABLE if exists tenants DROP COLUMN IF EXISTS isDedicated");
        $this->addSql("ALTER TABLE if exists tenants ADD COLUMN IF NOT EXISTS isLocal BOOLEAN DEFAULT FALSE");

    }
}
