<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20191011063311 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $fetchCommentResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'comments'");
        if(count($fetchCommentResults)) { 
            $commentUuid = $fetchCommentResults[0]['uuid'];
            $fileMMD  = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('10b22031-cbe4-4a60-a7b5-3e032a3c2a4f', '" . $commentUuid ."', 'string', 'file', 0, 17, 'file', '{\"model\":\"files\"}', false, true, true, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ file }}', '{\"singular\":\"File\"}');";
            $this->addSql($fileMMD );

            $rawCommentData  = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES 
            ('c3cc9011-f64d-4ca4-9ec6-a4f8b87f9cdb', '" . $commentUuid ."', 'string', 'rawCommentData', 0, 18, 'richtext', NULL, false, true, true, false, false, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, NULL, NULL, true, true, true, false, false, '{{ rawCommentData }}', '{\"singular\":\"Raw Comment Data\"}');";
            $this->addSql($rawCommentData );

            $typeCommentData  = "INSERT INTO public.attribute_metadatas (uuid, sattrib, type, name, length, orderindex, formtype, datasource, searchable, peerreplicable, system, encrypted, gridcolumn, collection, inversefield, ownsrelationship, validation, bulkaction, datasourcefilters, defaultvalue, tooltip, visibility, readable, writeable, identifier, \"unique\", displayname, descriptions) VALUES
            ('ea291719-114b-4983-8796-12a0a1759ef3', '" . $commentUuid ."', 'picklists', 'type', 0, 19, 'picklist', '{\"model\":\"picklists\",\"query\":{\"logic\":\"AND\",\"filters\":[{\"field\":\"listName__name\",\"operator\":\"eq\",\"value\":\"Comment Type\"}],\"sort\":[{\"field\":\"orderIndex\",\"direction\":\"ASC\"}]}}', true, true, true, false, true, false, NULL, 'false', '{\"required\":false,\"minlength\":0,\"maxlength\":10485761}', '{\"allow\":false,\"buttonText\":\"\",\"buttonIcon\":\"\",\"buttonClass\":\"btn btn-default btn-sm\"}', NULL, '/api/3/picklists/ff599189-3eeb-4c86-acb0-a7915e85ac3b', NULL, true, true, true, false, false, '{{ type }}', '{\"singular\":\"Type\"}');";
            $this->addSql($typeCommentData );
        }

        $fetchTenantFormResults = $this->connection->fetchAll("SELECT uuid FROM cyops.system_view_template WHERE uuid = 'modules-tenants-form'");
        if (count($fetchTenantFormResults)) {
            $config = '{"rows":[{"columns":[{"widgets":[{"type":"formGroup","config":{"wid":"73d11dfe-95fd-4e2b-ac4d-9023749746b2","rows":[{"columns":[{"fields":[{"name":"name","highlightMode":true,"linky":true,"readOnly":false},{"name":"isDedicated","highlightMode":true,"linky":true,"readOnly":false},{"name":"tenantId","highlightMode":true,"linky":true,"readOnly":false},{"name":"router","highlightMode":true,"linky":true,"readOnly":false},{"name":"password","highlightMode":true,"linky":true,"readOnly":false},{"name":"role","highlightMode":true,"linky":true,"readOnly":false},{"name":"description","highlightMode":true,"linky":true,"readOnly":false}]}]}],"title":""}},{"type":"formGroup","config":{"wid":"dff92514-4ccf-4fc6-aa0d-3047bff1fd5e","rows":[{"columns":[{"fields":[{"name":"active","highlightMode":true,"linky":true,"readOnly":false}]}]}],"title":"Summary"}}],"style":"col-lg-12"}],"wid":"baf7ae25-ebe4-4384-b609-a91a793e9fa3"}],"wid":"8dbeffa3-2baa-44e5-8710-9f05bb0a18be"}';
            $this->addSql("update cyops.system_view_template set config='" . $config . "' where uuid='modules-tenants-form'");
        }

        $fetchPostmanAppliance = $this->connection->fetchAll("SELECT uuid FROM actors WHERE uuid = '4312510d-9b52-4fc4-995a-754f76290fb6'");

        $fetchRoleId = $this->connection->fetchAll("SELECT uuid FROM roles WHERE uuid = 'c5ff8174-b3fa-41c5-b781-2b890b426a80'");

        if (count($fetchPostmanAppliance) && count($fetchRoleId)) {
            $this->addSql("insert into actor_role (actor_uuid, role_uuid) VALUES ('4312510d-9b52-4fc4-995a-754f76290fb6', 'c5ff8174-b3fa-41c5-b781-2b890b426a80')");
        }

        $this->addSql("update module_permissions set canexecute=True where module_uuid='fc948246-0314-11e7-93ae-92361f002671' and canread='t' and cancreate='t' and canupdate='t'");
        
        $this->addSql("ALTER TABLE workflow_step_types ADD COLUMN IF NOT EXISTS description varchar(1024) DEFAULT NULL;");

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
