<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20191112182718 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'postgresql', 'Migration can only be executed safely on \'postgresql\'.');

        $this->addSql("UPDATE workflow_step_types SET displayname = 'Referenced', index = '140',icon= 'icon icon-referenced',description= 'Triggered from another playbook using a \"Reference Playbook\" step or from a schedule.' WHERE name='cybersponse.abstract_trigger';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Custom API Endpoint', index = '150', icon= 'icon icon-custom-api-endpoint',description= 'Triggered from an API request to a custom endpoint.' WHERE name='cybersponse.api_call';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'Manual', index = '110', icon= 'icon icon-manual',description= 'Triggered when users select a record and then select the playbook from the \"Execute\" list.' where name='cybersponse.action';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'On Create', index = '120', icon= 'icon icon-on-create',description= 'Triggered on the creation of records that match the specified criteria.' WHERE name='cybersponse.post_create';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'On Update', index = '130', icon= 'icon icon-on-update',description= 'Triggered on the updation of records that match the specified criteria.' WHERE name='cybersponse.post_update';");
        $this->addSql("UPDATE workflow_step_types SET displayname = 'On Delete', index = '160', icon= 'icon icon-post-delete-trigger', description= 'Triggered on the deletion of records that match the specified criteria.' WHERE name='cybersponse.post_delete';");
        $this->addSql("UPDATE workflow_step_types SET index = '170' WHERE name='cybersponse.pre_create';");
        $this->addSql("UPDATE workflow_step_types SET index = '180' WHERE name='cybersponse.pre_update';");
        $this->addSql("UPDATE workflow_step_types SET index = '190' WHERE name='cybersponse.pre_delete';");

        $this->addSql("UPDATE workflow_step_types SET background = '#ff7600' WHERE name='Connectors';");
        $this->addSql("UPDATE workflow_step_types SET background = '#ff7600' WHERE name='CyopsUtilites';");
        $this->addSql("UPDATE workflow_step_types SET background = '#ff7600' WHERE name='CodeSnippet';");

        $this->addSql("insert into picklist_names (uuid, name, system, id) values ('0841c1eb-a0a3-4abd-b29c-9f68e4d9b14f', 'Comment Type', true, '1');");
        $this->addSql("insert into picklists (uuid, itemvalue, orderindex, id, listname) values ('ff599189-3eeb-4c86-acb0-a7915e85ac3b', 'Comment', 1, 208, '0841c1eb-a0a3-4abd-b29c-9f68e4d9b14f');");
        $this->addSql("insert into picklists (uuid, itemvalue, orderindex, id, listname) values ('1165899b-7091-4291-aafc-487c4309e8ff', 'ActionLog', 2, 209, '0841c1eb-a0a3-4abd-b29c-9f68e4d9b14f');");

        $this->addSql("ALTER TABLE if EXISTS comments ADD COLUMN type VARCHAR (255) NULL;");
        $this->addSql("ALTER TABLE if EXISTS comments ADD CONSTRAINT fk_constraint FOREIGN KEY (type) REFERENCES picklists(uuid);");
        $this->addSql("update comments set type='ff599189-3eeb-4c86-acb0-a7915e85ac3b';");

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
