<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200106131315 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $fetchRouterResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'routers'");

        if (count($fetchRouterResults)) {
            $routerUuid = $fetchRouterResults[0]['uuid'];
            $this->addSql("update attribute_metadatas set tooltip='FQDN for Secure Message Exchange' where name='address' and sattrib='" . $routerUuid ."'");
            $this->addSql("update attribute_metadatas set tooltip='Secure Message Exchange Name' where name='name' and sattrib='" . $routerUuid ."'");
        }

        $fetchTenantResults = $this->connection->fetchAll("SELECT uuid FROM staging_model_metadatas WHERE type = 'tenants'");

        if (count($fetchTenantResults)) {
            $tenantUuid = $fetchTenantResults[0]['uuid'];
            $this->addSql("update attribute_metadatas set gridcolumn=false where name='tenantId' and sattrib='" . $tenantUuid ."'");
            $this->addSql("update attribute_metadatas set descriptions='{\"singular\": \"Secure Message Exchange\"}' where name='router' and sattrib='" . $tenantUuid ."'");

            $this->addSql("update attribute_metadatas set tooltip='Select this option if the tenant is a distributed or remote tenant.' where name='isDedicated' and sattrib='" . $tenantUuid ."'");
        }
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
