<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Schema\Schema;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200128101259 extends AbstractMigration implements ContainerAwareInterface
{
  private $container;

  public function setContainer(ContainerInterface $container = null)
  {
    $this->container = $container;
  }

  private function addWorkflowCollection($workflow)
  {
    $workflowResource = $this->container->get('resource.workflowcollection');
    $context = $workflowResource->getDenormalizationContext();
    $context["ignore_field_authorization"] = true;
    $context["ignore_authorization"] = true;
    $workflowObject = $this->container->get('serializer')->deserialize(
      $workflow,
      $workflowResource->getEntityClass(),
      'json-ld',
      $context
    );
    /** @var ManagerRegistry $objectManager */
    $managerRegistry = $this->container->get('doctrine');
    $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
    $workflowManager->persist($workflowObject);
    $workflowManager->flush();
  }

  private $utilitiesCollection = '{
    "uuid": "3de088fc-6f2c-4b01-a024-8cadc37c2bcd",
    "@type": "WorkflowCollection",
    "name": "Utilities Playbooks",
    "description": "Contains system Utilities Playbooks.",
    "visible": false
  }';
  /**
   * @param Schema $schema
   */
  public function up(Schema $schema)
  {
    // this up() migration is auto-generated
    $this->addWorkflowCollection($this->utilitiesCollection);
    $this->addSql("insert into tags (uuid) values ('link') on conflict do nothing");
    $this->addSql("insert into tags (uuid) values ('similarity') on conflict do nothing");
    $this->addSql("insert into tags (uuid) values ('incidents') on conflict do nothing");
    $this->addSql("insert into tags (uuid) values ('emails') on conflict do nothing");
    $this->addSql("insert into tags (uuid) values ('alerts') on conflict do nothing");
    $this->addSql("insert into tags (uuid) values ('indicators') on conflict do nothing");
  }

  /**
   * @param Schema $schema
   */
  public function down(Schema $schema)
  {
    // this down() migration is auto-generated, please modify it to your needs

  }
}
