<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Application\Migrations;

use Doctrine\Common\Persistence\ManagerRegistry;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200128125121 extends AbstractMigration implements ContainerAwareInterface
{
    private $container;

  public function setContainer(ContainerInterface $container = null)
  {
    $this->container = $container;
  }

  private function addWorkflow($workflow)
  {
    $workflowResource = $this->container->get('resource.workflow');
    $context = $workflowResource->getDenormalizationContext();
    $context["ignore_field_authorization"] = true;
    $context["ignore_authorization"] = true;
    $workflowObject = $this->container->get('serializer')->deserialize(
      $workflow,
      $workflowResource->getEntityClass(),
      'json-ld',
      $context
    );
    /** @var ManagerRegistry $objectManager */
    $managerRegistry = $this->container->get('doctrine');
    $workflowManager = $managerRegistry->getManagerForClass($workflowResource->getEntityClass());
    $workflowManager->persist($workflowObject);
    $workflowManager->flush();
  }

  private $utilitiesIncidents = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Link Similar Incidents",
    "aliasName": null,
    "description": "Links all selected similar incidents with the parent incident",
    "collection": "/api/3/workflow_collections/3de088fc-6f2c-4b01-a024-8cadc37c2bcd",
    "tag": null,
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/4e328657-16ee-4721-872e-0e5265987d41",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Raise Error",
        "description": null,
        "arguments": {
          "params": {
            "msg": "This playbook is meant for using with Recommendation engine and expects similar records as one of the inputs."
          },
          "version": "3.0.0",
          "connector": "cyops_utilities",
          "operation": "raise_exception",
          "operationTitle": "Utils: Raise Exception",
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "393",
        "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
        "uuid": "eedf155a-d56a-4ca6-a263-4e0dac87847d"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "description": null,
        "arguments": {
          "route": "664526a0-84df-4c23-870d-e74761257cd5",
          "title": "Link Similar Incidents",
          "resources": ["incidents"],
          "inputVariables": [],
          "step_variables": {
            "input": {
              "records": "{{vars.input.records}}"
            }
          },
          "displayConditions": {
            "alerts": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            },
            "incidents": {
              "sort": [],
              "limit": 30,
              "logic": "OR",
              "filters": [
                {
                  "type": "primitive",
                  "field": "id",
                  "value": 0,
                  "operator": "eq",
                  "_operator": "eq"
                }
              ]
            },
            "indicators": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            }
          },
          "executeButtonText": "Execute",
          "noRecordExecution": false,
          "singleRecordExecution": false
        },
        "status": null,
        "left": "40",
        "top": "40",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "4e328657-16ee-4721-872e-0e5265987d41"
      },
      {
        "@type": "WorkflowStep",
        "name": "Config",
        "description": null,
        "arguments": {
          "parentIncidents": "{{vars.request.data.__parentRecordId}}",
          "selectedSimilarIncidents": "{{vars.request.data.records}}"
        },
        "status": null,
        "left": "189",
        "top": "146",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "541239b8-4b21-49db-9351-faa9ec76d904"
      },
      {
        "@type": "WorkflowStep",
        "name": "Link Similar Incidents To Parent",
        "description": null,
        "arguments": {
          "message": {
            "tags": [],
            "type": "/api/3/picklists/ff599189-3eeb-4c86-acb0-a7915e85ac3b",
            "content": "<p>Linked<strong> {{vars.selectedSimilarIncidents|length}}</strong>&nbsp;similar incident(s) to this&nbsp;incident successfully.&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>",
            "records": "{{vars.parentIncidents}}"
          },
          "resource": {
            "incidents": "{{vars.selectedSimilarIncidents}}"
          },
          "_showJson": false,
          "operation": "Overwrite",
          "collection": "{{vars.parentIncidents}}",
          "collectionType": "/api/3/alerts",
          "fieldOperation": {
            "recordTags": "Overwrite"
          },
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "149",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "c6eca8ce-f108-49b3-9a65-35d0167e3868"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if triggered from similarity section",
        "description": null,
        "arguments": {
          "conditions": [
            {
              "option": "No",
              "step_iri": "/api/3/workflow_steps/eedf155a-d56a-4ca6-a263-4e0dac87847d",
              "condition": "{{ vars.parentIncidents|length == 0 }}"
            },
            {
              "option": "Yes",
              "default": true,
              "step_iri": "/api/3/workflow_steps/c6eca8ce-f108-49b3-9a65-35d0167e3868"
            }
          ]
        },
        "status": null,
        "left": "340",
        "top": "260",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "77818303-a4b1-4db9-b5c6-f681014e7338"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "fc5dc547-9d26-4e31-b309-9fec7d392463",
        "name": "Start -> Config",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/541239b8-4b21-49db-9351-faa9ec76d904",
        "sourceStep": "/api/3/workflow_steps/4e328657-16ee-4721-872e-0e5265987d41"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "936287c5-982b-496a-83f9-376edd2cff6a",
        "name": "Config -> Check if triggered from similarity section",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/77818303-a4b1-4db9-b5c6-f681014e7338",
        "sourceStep": "/api/3/workflow_steps/541239b8-4b21-49db-9351-faa9ec76d904"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "21e1c695-2ef5-4e68-a933-6a29b8bbaa9d",
        "name": "Check if triggered from similarity section -> Link Similar Alerts To Parent",
        "label": "Yes",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/c6eca8ce-f108-49b3-9a65-35d0167e3868",
        "sourceStep": "/api/3/workflow_steps/77818303-a4b1-4db9-b5c6-f681014e7338"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "0a945ab1-0449-46ae-9bc7-6ff15e606370",
        "name": "Check if triggered from similarity section -> Error",
        "label": "No",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/eedf155a-d56a-4ca6-a263-4e0dac87847d",
        "sourceStep": "/api/3/workflow_steps/77818303-a4b1-4db9-b5c6-f681014e7338"
      }
    ],
    "versions": null,
    "lastModifyDate": 1580196537,
    "uuid": "34aa984d-9bf9-447f-9172-d63aa3c36197",
    "recordTags": [
      "/api/3/tags/link",
      "/api/3/tags/similarity",
      "/api/3/tags/incidents"
    ],
    "isPrivate": false,
    "owners": []
  }';

  private $utilitiesEmails = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Link Similar Emails",
    "aliasName": null,
    "description": "Links all selected similar emails with the parent email",
    "collection": "/api/3/workflow_collections/3de088fc-6f2c-4b01-a024-8cadc37c2bcd",
    "tag": null,
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/0065a6db-2c77-4eed-a363-fe8745107949",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Raise Error",
        "description": null,
        "arguments": {
          "params": {
            "msg": "This playbook is meant for using with Recommendation engine and expects similar records as one of the inputs."
          },
          "version": "3.0.0",
          "connector": "cyops_utilities",
          "operation": "raise_exception",
          "operationTitle": "Utils: Raise Exception",
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "393",
        "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
        "uuid": "2ea579b5-20b6-41f3-ba83-ebfb4f6dcda0"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "description": null,
        "arguments": {
          "route": "16f047c5-ea12-4bf9-b1a5-dfa5e3b4832d",
          "title": "Link Similar Emails",
          "resources": ["emails"],
          "inputVariables": [],
          "step_variables": {
            "input": {
              "records": "{{vars.input.records}}"
            }
          },
          "displayConditions": {
            "alerts": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            },
            "emails": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": [
                {
                  "type": "primitive",
                  "field": "id",
                  "value": 0,
                  "operator": "eq",
                  "_operator": "eq"
                }
              ]
            },
            "incidents": {
              "sort": [],
              "limit": 30,
              "logic": "OR",
              "filters": [
                {
                  "type": "primitive",
                  "field": "id",
                  "value": 0,
                  "operator": "eq",
                  "_operator": "eq"
                }
              ]
            },
            "indicators": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            }
          },
          "executeButtonText": "Execute",
          "noRecordExecution": false,
          "singleRecordExecution": false
        },
        "status": null,
        "left": "40",
        "top": "40",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "0065a6db-2c77-4eed-a363-fe8745107949"
      },
      {
        "@type": "WorkflowStep",
        "name": "Config",
        "description": null,
        "arguments": {
          "parentEmail": "{{vars.request.data.__parentRecordId}}",
          "selectedSimilarEmails": "{{vars.request.data.records}}"
        },
        "status": null,
        "left": "189",
        "top": "146",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "f62accf3-8925-471b-9dbb-8f2740bd7a9c"
      },
      {
        "@type": "WorkflowStep",
        "name": "Link Similar Emails To Parent",
        "description": null,
        "arguments": {
          "message": {
            "tags": [],
            "type": "/api/3/picklists/ff599189-3eeb-4c86-acb0-a7915e85ac3b",
            "content": "<p>Linked<strong> {{vars.selectedSimilarEmails|length}}</strong>&nbsp;similar email(s) to this&nbsp;email successfully.&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>",
            "records": "{{vars.parentEmail}}"
          },
          "resource": {
            "emails": "{{vars.selectedSimilarEmails}}"
          },
          "_showJson": false,
          "operation": "Overwrite",
          "collection": "{{vars.parentEmail}}",
          "collectionType": "/api/3/emails",
          "fieldOperation": {
            "recordTags": "Overwrite"
          },
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "149",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "85711379-6c9c-42d3-9600-4ae128309c26"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if triggered from similarity section",
        "description": null,
        "arguments": {
          "conditions": [
            {
              "option": "No",
              "step_iri": "/api/3/workflow_steps/2ea579b5-20b6-41f3-ba83-ebfb4f6dcda0",
              "condition": "{{ vars.parentEmail|length == 0 }}"
            },
            {
              "option": "Yes",
              "default": true,
              "step_iri": "/api/3/workflow_steps/85711379-6c9c-42d3-9600-4ae128309c26"
            }
          ]
        },
        "status": null,
        "left": "340",
        "top": "260",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "b14f171f-1735-4cb5-9757-8866192f8f5f"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "fd18da47-da57-47f5-9c27-5d1c872000aa",
        "name": "Start -> Config",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/f62accf3-8925-471b-9dbb-8f2740bd7a9c",
        "sourceStep": "/api/3/workflow_steps/0065a6db-2c77-4eed-a363-fe8745107949"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "a93a6ae3-6c93-40ff-9f97-4093187ae860",
        "name": "Config -> Check if triggered from similarity section",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/b14f171f-1735-4cb5-9757-8866192f8f5f",
        "sourceStep": "/api/3/workflow_steps/f62accf3-8925-471b-9dbb-8f2740bd7a9c"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "e9d17407-91c0-472f-a17c-c9185023129f",
        "name": "Check if triggered from similarity section -> Link Similar Alerts To Parent",
        "label": "Yes",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/85711379-6c9c-42d3-9600-4ae128309c26",
        "sourceStep": "/api/3/workflow_steps/b14f171f-1735-4cb5-9757-8866192f8f5f"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "5a5b832a-0c38-46b3-a1c5-b949b5ee5ca1",
        "name": "Check if triggered from similarity section -> Error",
        "label": "No",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/2ea579b5-20b6-41f3-ba83-ebfb4f6dcda0",
        "sourceStep": "/api/3/workflow_steps/b14f171f-1735-4cb5-9757-8866192f8f5f"
      }
    ],
    "versions": null,
    "lastModifyDate": 1580196385,
    "uuid": "1451cfe2-61c0-4ac6-a194-c874c93ddb56",
    "recordTags": [
      "/api/3/tags/link",
      "/api/3/tags/similarity",
      "/api/3/tags/emails"
    ],
    "isPrivate": false,
    "owners": []
  }';
  private $utilitiesAlerts = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Link Similar Alerts",
    "aliasName": null,
    "description": "Links all selected similar alerts with the parent alert",
    "collection": "/api/3/workflow_collections/3de088fc-6f2c-4b01-a024-8cadc37c2bcd",
    "tag": null,
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/5780f46e-0a46-4cd7-8acf-fd5c9e656f44",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Config",
        "description": null,
        "arguments": {
          "parentAlert": "{{vars.request.data.__parentRecordId}}",
          "selectedSimilarAlerts": "{{vars.request.data.records}}"
        },
        "status": null,
        "left": "189",
        "top": "146",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "53166784-45bb-4826-97d6-8589512d4107"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if triggered from similarity section",
        "description": null,
        "arguments": {
          "conditions": [
            {
              "option": "No",
              "step_iri": "/api/3/workflow_steps/00add72a-219d-4e6d-b5a3-8b9c62dbab40",
              "condition": "{{ vars.parentAlert|length == 0 }}"
            },
            {
              "option": "Yes",
              "default": true,
              "step_iri": "/api/3/workflow_steps/677d1d3d-cb31-4cdc-8f8c-7d89b8c56089"
            }
          ]
        },
        "status": null,
        "left": "340",
        "top": "260",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "08624a04-2c1d-4b1b-8462-e87d63c925d7"
      },
      {
        "@type": "WorkflowStep",
        "name": "Raise Error",
        "description": null,
        "arguments": {
          "params": {
            "msg": "This playbook is meant for using with Recommendation engine and expects similar records as one of the inputs."
          },
          "version": "3.0.0",
          "connector": "cyops_utilities",
          "operation": "raise_exception",
          "operationTitle": "Utils: Raise Exception",
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "393",
        "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
        "uuid": "00add72a-219d-4e6d-b5a3-8b9c62dbab40"
      },
      {
        "@type": "WorkflowStep",
        "name": "Link Similar Alerts To Parent",
        "description": null,
        "arguments": {
          "message": {
            "tags": [],
            "type": "/api/3/picklists/ff599189-3eeb-4c86-acb0-a7915e85ac3b",
            "content": "<p>Linked<strong> {{vars.selectedSimilarAlerts|length}}</strong> similar alert(s) to this alert successfully.&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>",
            "records": "{{vars.parentAlert}}"
          },
          "resource": {
            "alerts": "{{vars.selectedSimilarAlerts}}"
          },
          "_showJson": false,
          "operation": "Overwrite",
          "collection": "{{vars.parentAlert}}",
          "collectionType": "/api/3/alerts",
          "fieldOperation": {
            "recordTags": "Overwrite"
          },
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "149",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "677d1d3d-cb31-4cdc-8f8c-7d89b8c56089"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "description": null,
        "arguments": {
          "route": "00f52398-081d-4358-991a-24adeb57be00",
          "title": "Link Similar Alerts",
          "resources": ["alerts"],
          "inputVariables": [],
          "step_variables": {
            "input": {
              "records": "{{vars.input.records}}"
            }
          },
          "displayConditions": {
            "alerts": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": [
                {
                  "type": "primitive",
                  "field": "id",
                  "value": 0,
                  "operator": "eq",
                  "_operator": "eq"
                }
              ]
            }
          },
          "executeButtonText": "Execute",
          "noRecordExecution": false,
          "singleRecordExecution": false
        },
        "status": null,
        "left": "40",
        "top": "40",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "5780f46e-0a46-4cd7-8acf-fd5c9e656f44"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "fef55023-9465-44a9-86d0-d0e9f87ac93c",
        "name": "Start -> Config",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/53166784-45bb-4826-97d6-8589512d4107",
        "sourceStep": "/api/3/workflow_steps/5780f46e-0a46-4cd7-8acf-fd5c9e656f44"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "8daae793-c2c6-48ce-8a81-b4983ca0be48",
        "name": "Config -> Check if triggered from similarity section",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/08624a04-2c1d-4b1b-8462-e87d63c925d7",
        "sourceStep": "/api/3/workflow_steps/53166784-45bb-4826-97d6-8589512d4107"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "c3fa4ab2-e71b-4d78-a23b-b50e9be2bc3b",
        "name": "Check if triggered from similarity section -> Link Similar Alerts To Parent",
        "label": "Yes",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/677d1d3d-cb31-4cdc-8f8c-7d89b8c56089",
        "sourceStep": "/api/3/workflow_steps/08624a04-2c1d-4b1b-8462-e87d63c925d7"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "61848405-a46e-496c-beeb-4bd6407a609a",
        "name": "Check if triggered from similarity section -> Error",
        "label": "No",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/00add72a-219d-4e6d-b5a3-8b9c62dbab40",
        "sourceStep": "/api/3/workflow_steps/08624a04-2c1d-4b1b-8462-e87d63c925d7"
      }
    ],
    "versions": null,
    "lastModifyDate": 1580196023,
    "uuid": "20f32ef0-5ca1-4293-b961-2cfea235d4bc",
    "recordTags": [
      "/api/3/tags/alerts",
      "/api/3/tags/link",
      "/api/3/tags/similarity"
    ],
    "isPrivate": false,
    "owners": []
  }';
  private $utilitiesIndicators = '{
    "@type": "Workflow",
    "triggerLimit": null,
    "name": "Link Similar Indicators",
    "aliasName": null,
    "description": "Links all selected similar indicators with the parent indicator",
    "collection": "/api/3/workflow_collections/3de088fc-6f2c-4b01-a024-8cadc37c2bcd",
    "tag": null,
    "isActive": true,
    "singleRecordExecution": false,
    "remoteExecutableFlag": false,
    "parameters": [],
    "synchronous": false,
    "triggerStep": "/api/3/workflow_steps/86cbe1a3-9d3e-4d6b-ad68-d9df3a34a9a9",
    "steps": [
      {
        "@type": "WorkflowStep",
        "name": "Raise Error",
        "description": null,
        "arguments": {
          "params": {
            "msg": "This playbook is meant for using with Recommendation engine and expects similar records as one of the inputs."
          },
          "version": "3.0.0",
          "connector": "cyops_utilities",
          "operation": "raise_exception",
          "operationTitle": "Utils: Raise Exception",
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "393",
        "stepType": "/api/3/workflow_step_types/0109f35d-090b-4a2b-bd8a-94cbc3508562",
        "uuid": "ff4700d8-728f-4143-81a8-4f9b428a54f9"
      },
      {
        "@type": "WorkflowStep",
        "name": "Config",
        "description": null,
        "arguments": {
          "parentIndicator": "{{vars.request.data.__parentRecordId}}",
          "selectedSimilarIndicators": "{{vars.request.data.records}}"
        },
        "status": null,
        "left": "189",
        "top": "146",
        "stepType": "/api/3/workflow_step_types/04d0cf46-b6a8-42c4-8683-60a7eaa69e8f",
        "uuid": "282d65a7-b036-4832-925b-c05c0bf589e8"
      },
      {
        "@type": "WorkflowStep",
        "name": "Link Similar Indicators To Parent",
        "description": null,
        "arguments": {
          "message": {
            "tags": [],
            "type": "/api/3/picklists/ff599189-3eeb-4c86-acb0-a7915e85ac3b",
            "content": "<p>Linked<strong> {{vars.selectedSimilarIndicators|length}}</strong>&nbsp;similar indicator(s) to this&nbsp;indicator successfully.&nbsp;</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>",
            "records": "{{vars.parentIndicator}}"
          },
          "resource": {
            "indicators": "{{vars.selectedSimilarIndicators}}"
          },
          "_showJson": false,
          "operation": "Overwrite",
          "collection": "{{vars.parentIndicator}}",
          "collectionType": "/api/3/alerts",
          "fieldOperation": {
            "recordTags": "Overwrite"
          },
          "step_variables": []
        },
        "status": null,
        "left": "660",
        "top": "149",
        "stepType": "/api/3/workflow_step_types/b593663d-7d13-40ce-a3a3-96dece928722",
        "uuid": "8c4f7572-c472-4bf8-9734-f28179b85245"
      },
      {
        "@type": "WorkflowStep",
        "name": "Check if triggered from similarity section",
        "description": null,
        "arguments": {
          "conditions": [
            {
              "option": "No",
              "step_iri": "/api/3/workflow_steps/ff4700d8-728f-4143-81a8-4f9b428a54f9",
              "condition": "{{ vars.parentIndicator|length == 0 }}"
            },
            {
              "option": "Yes",
              "default": true,
              "step_iri": "/api/3/workflow_steps/8c4f7572-c472-4bf8-9734-f28179b85245"
            }
          ]
        },
        "status": null,
        "left": "340",
        "top": "260",
        "stepType": "/api/3/workflow_step_types/12254cf5-5db7-4b1a-8cb1-3af081924b28",
        "uuid": "d2bc0fad-f3a8-4efe-89a1-31fa4d643a22"
      },
      {
        "@type": "WorkflowStep",
        "name": "Start",
        "description": null,
        "arguments": {
          "route": "be01eaa9-5c48-4e2e-b19a-a9fe3b106ccd",
          "title": "Link Similar Indicators",
          "resources": ["indicators"],
          "inputVariables": [],
          "step_variables": {
            "input": {
              "records": "{{vars.input.records}}"
            }
          },
          "displayConditions": {
            "alerts": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": []
            },
            "indicators": {
              "sort": [],
              "limit": 30,
              "logic": "AND",
              "filters": [
                {
                  "type": "primitive",
                  "field": "id",
                  "value": 0,
                  "operator": "eq",
                  "_operator": "eq"
                }
              ]
            }
          },
          "executeButtonText": "Execute",
          "noRecordExecution": false,
          "singleRecordExecution": false
        },
        "status": null,
        "left": "40",
        "top": "40",
        "stepType": "/api/3/workflow_step_types/f414d039-bb0d-4e59-9c39-a8f1e880b18a",
        "uuid": "86cbe1a3-9d3e-4d6b-ad68-d9df3a34a9a9"
      }
    ],
    "routes": [
      {
        "@type": "WorkflowRoute",
        "uuid": "b6fd61b9-8cb7-4f86-9b0a-b9527e83966b",
        "name": "Start -> Config",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/282d65a7-b036-4832-925b-c05c0bf589e8",
        "sourceStep": "/api/3/workflow_steps/86cbe1a3-9d3e-4d6b-ad68-d9df3a34a9a9"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "6684030a-74b6-425b-9fa1-caa11a6efff7",
        "name": "Config -> Check if triggered from similarity section",
        "label": null,
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/d2bc0fad-f3a8-4efe-89a1-31fa4d643a22",
        "sourceStep": "/api/3/workflow_steps/282d65a7-b036-4832-925b-c05c0bf589e8"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "84018e94-0bbf-4de5-8021-55b1133d1ade",
        "name": "Check if triggered from similarity section -> Link Similar Alerts To Parent",
        "label": "Yes",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/8c4f7572-c472-4bf8-9734-f28179b85245",
        "sourceStep": "/api/3/workflow_steps/d2bc0fad-f3a8-4efe-89a1-31fa4d643a22"
      },
      {
        "@type": "WorkflowRoute",
        "uuid": "7f030eaf-272a-4765-ba06-84d7e94cf3c7",
        "name": "Check if triggered from similarity section -> Error",
        "label": "No",
        "isExecuted": false,
        "targetStep": "/api/3/workflow_steps/ff4700d8-728f-4143-81a8-4f9b428a54f9",
        "sourceStep": "/api/3/workflow_steps/d2bc0fad-f3a8-4efe-89a1-31fa4d643a22"
      }
    ],
    "versions": null,
    "lastModifyDate": 1580196054,
    "uuid": "975d484e-8dbf-4f0c-8a1f-8de7d870f487",
    "recordTags": [
      "/api/3/tags/link",
      "/api/3/tags/similarity",
      "/api/3/tags/indicators"
    ],
    "isPrivate": false,
    "owners": []
  }';
  /**
   * @param Schema $schema
   */
  public function up(Schema $schema)
  {
    // this up() migration is auto-generated
    $this->addWorkflow($this->utilitiesAlerts);
    $this->addWorkflow($this->utilitiesEmails);
    $this->addWorkflow($this->utilitiesIncidents);
    $this->addWorkflow($this->utilitiesIndicators);

  }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
