<?php

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200320050844 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addSql("CREATE TABLE if not exists public.agents (
            uuid character varying(150) NOT NULL,
            configuration_health character varying(150) DEFAULT NULL::character varying,
            agent_type character varying(150) DEFAULT NULL::character varying,
            router character varying(150) DEFAULT NULL::character varying,
            configstatus character varying(150) DEFAULT NULL::character varying,
            createuser character varying(150) DEFAULT NULL::character varying,
            modifyuser character varying(150) DEFAULT NULL::character varying,
            name text,
            agentid character varying(80) DEFAULT NULL::character varying,
            username text,
            password text,
            vhost text,
            active boolean,
            ssl boolean,
            islocal boolean,
            description text,
            role text,
            healthchecklastsync timestamp(0) without time zone DEFAULT NULL::timestamp without time zone,
            createdate timestamp(0) without time zone DEFAULT NULL::timestamp without time zone,
            modifydate timestamp(0) without time zone DEFAULT NULL::timestamp without time zone,
            id integer NOT NULL
        )");

        $this->addSql("alter table routers add column configstatus text null;");
        $this->addSql("alter table routers add column configmessage text null");

        $this->addSql("ALTER TABLE public.agents OWNER TO cyberpgsql;");

        $this->addSql("CREATE SEQUENCE public.agents_id_seq
            AS integer
            START WITH 1
            INCREMENT BY 1
            NO MINVALUE
            NO MAXVALUE
            CACHE 1;");

        $this->addSql("ALTER TABLE public.agents_id_seq OWNER TO cyberpgsql;");

        $this->addSql("ALTER SEQUENCE public.agents_id_seq OWNED BY public.agents.id;");

        $this->addSql("ALTER TABLE ONLY public.agents
        ADD CONSTRAINT agents_pkey PRIMARY KEY (uuid);");

        $this->addSql("ALTER TABLE ONLY public.agents
        ADD CONSTRAINT fk_9596ab6e887e6918 FOREIGN KEY (modifyuser) REFERENCES public.actors(uuid) ON DELETE SET NULL;");
        $this->addSql("ALTER TABLE ONLY public.agents
        ADD CONSTRAINT fk_9596ab6edf736b67 FOREIGN KEY (createuser) REFERENCES public.actors(uuid) ON DELETE SET NULL;");

        $this->addSql("ALTER TABLE ONLY public.agents
        ADD CONSTRAINT fk_9596ab6e45d2f225 FOREIGN KEY (router) REFERENCES public.routers(uuid) ON DELETE SET NULL;");

        $this->addSql("CREATE TABLE if not exists public.agent_team (
            agent_uuid character varying(150) NOT NULL,
            team_uuid character varying(150) NOT NULL
        );");

        $this->addSql("ALTER TABLE public.agent_team OWNER TO cyberpgsql;");

        $this->addSql("ALTER TABLE ONLY public.agent_team
        ADD CONSTRAINT agent_team_pkey PRIMARY KEY (agent_uuid, team_uuid);");

        $this->addSql("ALTER TABLE ONLY public.agent_team
        ADD CONSTRAINT fk_697b1cfc9ea4dd FOREIGN KEY (team_uuid) REFERENCES public.teams(uuid) ON DELETE CASCADE;");

        $this->addSql("INSERT INTO public.staging_model_metadatas (uuid, type, parenttype, tablename, ownable, trackable, taggable, peerreplicable, defaultsort, uniqueconstraint, indexable, writable, displayname, descriptions) VALUES ('266e4fbb-2bcd-47dd-9ba6-400b88d49a92', 'agents', NULL, 'agents', true, true, false, false, '[]', '[{\"agents_unique\":{\"columns\":[\"agentId\"]}}]', true, true, '{{ name }}', '{\"singular\":\"Agent\",\"plural\":\"Agents\"}');");
        
        $this->addSql("update staging_model_metadatas set taggable=false where type='routers';");
        
        $this->addSql("update staging_model_metadatas set taggable=false where type='tenants';");
        
        $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('114d88e4-ceaa-4b9f-842b-cca8db90f418', 'Agent Type', true, 29);");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('5de19a34-1d8b-4423-91fc-4c243a5b62fd', 'FSR Node', 0, NULL, NULL, 219, '114d88e4-ceaa-4b9f-842b-cca8db90f418');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('502cb999-d0fe-466f-9d99-1f3300513e14', 'FSR Agent', 1, NULL, NULL, 220, '114d88e4-ceaa-4b9f-842b-cca8db90f418');");

        $this->addSql("INSERT INTO public.picklist_names (uuid, name, system, id) VALUES ('663eb9f2-d362-4640-a2f1-f5432c6d3c4e', 'Configuration Health', true, 36);
        ");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('fb340c77-c2c6-471d-8081-77c9302b4bfb', 'Configuration In Progress', 0, '#FEB80C', NULL, 254, '663eb9f2-d362-4640-a2f1-f5432c6d3c4e');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('b5566a53-7af5-48f6-9dbd-5bf5fc9f432b', 'Awaiting Remote Node Connection', 1, '#FEB80C', NULL, 255, '663eb9f2-d362-4640-a2f1-f5432c6d3c4e');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('ab6a1713-9280-4619-9fbd-7694edad2159', 'Remote Node Connected', 2, '#1AAC37', NULL, 256, '663eb9f2-d362-4640-a2f1-f5432c6d3c4e');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('4b7645c0-cafa-45dd-ad57-44882ce57f21', 'Configuration Failed', 4, '#D22F18', NULL, 258, '663eb9f2-d362-4640-a2f1-f5432c6d3c4e');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('945621cd-f169-44b8-bc28-807a6f17d00a', 'Message Exchange Unreachable', 5, '#D22F18', NULL, 259, '663eb9f2-d362-4640-a2f1-f5432c6d3c4e');");

        $this->addSql("INSERT INTO public.picklists (uuid, itemvalue, orderindex, color, icon, id, listname) VALUES ('135030fa-1b0b-453d-9fed-df9be5d4397f', 'Remote Node Unreachable', 6, '#D22F18', NULL, 260, '663eb9f2-d362-4640-a2f1-f5432c6d3c4e');");
        
        $this->addSql("CREATE TABLE public.tenant_agent (
            tenant_uuid character varying(150) NOT NULL,
            agent_uuid character varying(150) NOT NULL
        );");

        $this->addSql("ALTER TABLE public.tenant_agent OWNER TO cyberpgsql;");

        $this->addSql("ALTER TABLE ONLY public.tenant_agent
        ADD CONSTRAINT tenant_agent_pkey PRIMARY KEY (tenant_uuid, agent_uuid);");

        $this->addSql("ALTER TABLE ONLY public.tenant_agent
        ADD CONSTRAINT fk_391b70a97ce4ea45 FOREIGN KEY (agent_uuid) REFERENCES public.agents(uuid) ON DELETE CASCADE;");

        $this->addSql("ALTER TABLE ONLY public.tenant_agent
        ADD CONSTRAINT fk_391b70a99b100a75 FOREIGN KEY (tenant_uuid) REFERENCES public.tenants(uuid) ON DELETE CASCADE;");
        
        $this->addSql("CREATE INDEX idx_391b70a97ce4ea45 ON public.tenant_agent USING btree (agent_uuid);");

        $this->addSql("CREATE INDEX idx_391b70a99b100a75 ON public.tenant_agent USING btree (tenant_uuid);");
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
