<?php

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Ramsey\Uuid\Uuid;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200322082027 extends AbstractMigration
{
    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $fetchDedicatedTenants = $this->connection->fetchAll("SELECT * FROM tenants WHERE role != 'self' and isDedicated=true");

        if (count($fetchDedicatedTenants)) {
            foreach ($fetchDedicatedTenants as $fetchDedicatedTenant) {
                
                $agentUuid = Uuid::uuid4()->toString();

                $active = $fetchDedicatedTenant['active'] ? 'true': 'false';
                $ssl = $fetchDedicatedTenant['ssl'] ? 'true' : 'false';
                $actorUuid = $fetchDedicatedTenant['createuser'];
                if (!$actorUuid) {
                    $actorsUuid = $this->connection->fetchAll("select uuid from actors where  record_type='person' order by uuid limit 1;");
                    if (count($actorsUuid)) {
                    $actorUuid = $actorsUuid[0]['uuid'];
                    }
                }

                $insertSql = "INSERT INTO AGENTS (uuid, router, agent_type, configstatus, createuser, modifyuser, \"password\", vhost, active, \"ssl\", islocal, \"name\", agentid, username, \"role\", createdate, modifydate, id) values ('" . $agentUuid ."','" . $fetchDedicatedTenant['router'] ."','" . '5de19a34-1d8b-4423-91fc-4c243a5b62fd' ."','" . $fetchDedicatedTenant['configstatus'] ."','" . $actorUuid ."','" . $actorUuid ."','" . $fetchDedicatedTenant['password'] . "','" . $fetchDedicatedTenant['vhost'] .  "','" . $active .  "','" . $ssl .  "', false ,'" . $fetchDedicatedTenant['name']."_Agent" .  "','" . $fetchDedicatedTenant['tenantid'] .  "','" . $fetchDedicatedTenant['username'] .  "','" . $fetchDedicatedTenant['role'] .  "','" . $fetchDedicatedTenant['createdate'] .  "','" . $fetchDedicatedTenant['modifydate'] .  "','" . $fetchDedicatedTenant['id'] . "');";
                $this->addSql($insertSql);
                
                // Linking Newly Created Agent with Tenant
                $insertTenantAgentSql = "INSERT INTO tenant_agent (tenant_uuid, agent_uuid) VALUES ('" . $fetchDedicatedTenant['uuid'] . "','" . $agentUuid . "' );";
                $this->addSql($insertTenantAgentSql);

                $fetchTenantTeams = $this->connection->fetchAll("select * from tenant_team where tenant_uuid='" . $fetchDedicatedTenant['uuid'] . "';");

                if (count($fetchTenantTeams)) {
                    foreach ($fetchTenantTeams as $fetchTenantTeam) {
                        $insertSql = "INSERT INTO AGENT_TEAM (agent_uuid, team_uuid) values ('" . $agentUuid . "', '" . $fetchTenantTeam['team_uuid'] . "');";
                        $this->addSql($insertSql);
                    }
                }
                
                
            }
                $totalExistingTenant = count($fetchDedicatedTenants) + 1;
                $this->addSql("SELECT setval('agents_id_seq'," . $totalExistingTenant . ", FALSE);");
        }
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
