<?php

namespace Application\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200428082137 extends AbstractMigration
{
    // Create SNS related role on upgrade
    // Tenant: Read + Create + Update
    // Agent: Read + Create + Update
    // Router: Read + Create + Update
    // Connector: Read, Write

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addSql("insert into roles (uuid, name, description) values ('3006d2f2-2f3a-4ae8-a36c-03ae75bf17fb', 'FortiSOAR Agent', 'Agent appliances will be auto-assigned this role. Defaults to access to files and attachments')");

        $this->addSql("insert into roles (uuid, name, description) values ('67a6ead4-d11f-44a5-b940-a0b7f95079e0', 'FortiSOAR SNS', 'Set of permissions required for administering Secure Message Exchanges, Tenants and Agents in a distributed deployment')");
        

        // Permission Related to FSR Agent
        $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('9e06c85a-c1e1-4eaa-8bc8-7d7788e0658a', '9df920ef-d564-4591-9283-76882ca38b9c', false, false, true, false, false);");

        $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('528abb96-1d5a-438b-8231-81243ef51d6e', 'e1049b52-3ecb-4109-b18e-581599d1af6b', false, false, true, false, false);");

        $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('ff9e9488-e0e4-4765-8cf7-8758331a688a', '793c3660-0752-4545-9daf-e1c795347149', false, false, true, false, false);");

        $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('ab0f4aea-a8f3-4037-8a0b-17a2dbbebc36', 'e024fc94-22ae-4b08-b37f-2f6d612e8f01', false, false, true, true, false);");

        $fetchTenantModuleResults = $this->connection->fetchAll("SELECT uuid FROM modules WHERE type = 'tenants'");
        if (count($fetchTenantModuleResults)) {
            $tenantModuleUuid = $fetchTenantModuleResults[0]['uuid'];
            $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('b8bcdb4a-b463-432c-928e-b4e6df803526', '" . $tenantModuleUuid . "', false, false, true, false, false);");
        }

        // Permission related to FSR SNS

        $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('29ad9441-da45-4d94-86cf-464ba0ad2a1b', 'e024fc94-22ae-4b08-b37f-2f6d612e8f01', true, false, true, true, false);");

        $fetchRouterModuleResults = $this->connection->fetchAll("SELECT uuid FROM modules WHERE type = 'routers'");
        if (count($fetchRouterModuleResults)) {
            $routerModuleUuid = $fetchRouterModuleResults[0]['uuid'];
            $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('cf5df94e-5845-4db4-8aeb-8747b5f1c359', '" . $routerModuleUuid . "', true, false, true, true, false);");
        }

        $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('a16a9c99-bcc1-4421-a588-3f39574692fe', 'fc948246-0314-11e7-93ae-92361f002671', true, false, true, true, false);");

        $fetchTenantModuleResults = $this->connection->fetchAll("SELECT uuid FROM modules WHERE type = 'tenants'");
        if (count($fetchTenantModuleResults)) {
            $tenantModuleUuid = $fetchTenantModuleResults[0]['uuid'];
            $this->addSql("insert into module_permissions (uuid, module_uuid, cancreate, canexecute, canread, canupdate, candelete) values ('ad3dd623-b085-41fb-95fc-ab46d22b7a99', '" . $tenantModuleUuid . "', true, false, true, true, false);");
        }


        // Role Permission Related to FSR Agent
        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('3006d2f2-2f3a-4ae8-a36c-03ae75bf17fb', '9e06c85a-c1e1-4eaa-8bc8-7d7788e0658a')");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('3006d2f2-2f3a-4ae8-a36c-03ae75bf17fb', '528abb96-1d5a-438b-8231-81243ef51d6e');");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('3006d2f2-2f3a-4ae8-a36c-03ae75bf17fb', 'ff9e9488-e0e4-4765-8cf7-8758331a688a');");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('3006d2f2-2f3a-4ae8-a36c-03ae75bf17fb', 'ab0f4aea-a8f3-4037-8a0b-17a2dbbebc36');");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('3006d2f2-2f3a-4ae8-a36c-03ae75bf17fb', 'b8bcdb4a-b463-432c-928e-b4e6df803526');");

        // Role Permission related to FSR SNS

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('67a6ead4-d11f-44a5-b940-a0b7f95079e0', '29ad9441-da45-4d94-86cf-464ba0ad2a1b')");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('67a6ead4-d11f-44a5-b940-a0b7f95079e0', 'cf5df94e-5845-4db4-8aeb-8747b5f1c359')");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('67a6ead4-d11f-44a5-b940-a0b7f95079e0', 'a16a9c99-bcc1-4421-a588-3f39574692fe')");

        $this->addSql("insert into role_modulepermission (role_uuid, modulepermission_uuid) values ('67a6ead4-d11f-44a5-b940-a0b7f95079e0', 'ad3dd623-b085-41fb-95fc-ab46d22b7a99')");

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs

    }
}
