<?php

namespace Application\Migrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\DBAL\Migrations\AbstractMigration;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20200731085033 extends AbstractMigration implements ContainerAwareInterface
{
    /** @var ContainerInterface */
    private $container;

    protected $picklistItemLow = '
        {
            "itemValue": "Low",
            "orderIndex": 0,
            "color": null,
            "icon": null,
            "listName": "/api/3/picklist_names/e104ef72-11b4-4d0c-be0e-e1cf3b87b5f2",
            "uuid": "df314249-88c8-4778-ab55-8aeafbe932cb"
        }';
    protected $picklistItemMedium='
        {
            "itemValue": "Medium",
            "orderIndex": 1,
            "color": null,
            "icon": null,
            "listName": "/api/3/picklist_names/e104ef72-11b4-4d0c-be0e-e1cf3b87b5f2",
            "uuid": "2b563c61-ae2c-41c0-a85a-c9709585e3f2"
        }';
    protected $picklistItemHigh='
        {
            "itemValue": "High",
            "orderIndex": 2,
            "color": null,
            "icon": null,
            "listName": "/api/3/picklist_names/e104ef72-11b4-4d0c-be0e-e1cf3b87b5f2",
            "uuid": "9e8d41e4-8ada-4a2c-bd02-07f62c6d0a00"
        }';


    protected $picklistPriority = '{
        "@type": "PicklistNames",
        "name": "WorkflowPriority",
        "system": true,
        "uuid": "e104ef72-11b4-4d0c-be0e-e1cf3b87b5f2"
      }';
      
    public function setContainer(ContainerInterface $container = null)
    {
        $this->container = $container;
    }

    private function addPicklist()
    {

        /** @var ResourceInterface $picklistResource */
        $picklistResource = $this->container->get('resource.picklist');

        $context = $picklistResource->getDenormalizationContext();
        $context["ignore_field_authorization"] = true;
        $context["ignore_authorization"] = true;

        $picklistLowObject = $this->container->get('serializer')->deserialize(
            $this->picklistItemLow,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistMediumObject = $this->container->get('serializer')->deserialize(
            $this->picklistItemMedium,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );

        $picklistHighObject = $this->container->get('serializer')->deserialize(
            $this->picklistItemHigh,
            $picklistResource->getEntityClass(),
            'json-ld',
            $context
        );
        /** @var ResourceInterface $picklistNameResource */
        $picklistNameResource = $this->container->get('resource.picklistnames');

        $contextName = $picklistNameResource->getDenormalizationContext();
        $contextName["ignore_field_authorization"] = true;
        $contextName["ignore_authorization"] = true;

        $picklistPriorityObject = $this->container->get('serializer')->deserialize(
            $this->picklistPriority,
            $picklistNameResource->getEntityClass(),
            'json-ld',
            $contextName
        );

        /** @var ManagerRegistry $objectManager */
        $managerRegistry = $this->container->get('doctrine');

        $picklistNameManager = $managerRegistry->getManagerForClass($picklistNameResource->getEntityClass());
        $picklistNameManager->persist($picklistPriorityObject);
        $picklistNameManager->flush();

        /** @var ObjectManager $picklistManager */
        $picklistManager = $managerRegistry->getManagerForClass($picklistResource->getEntityClass());
        $picklistManager->persist($picklistLowObject);
        $picklistManager->persist($picklistMediumObject);
        $picklistManager->persist($picklistHighObject);
        // $picklistManager->persist($picklistPriorityObject);
        $picklistManager->flush();
    }

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        $this->addPicklist();
    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
    }
}
