/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

--
-- Data for Name: workflow_steps; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_steps (uuid, steptype_uuid, name, arguments, status, left_position, top_position, id) FROM stdin;
265765c0-0d62-4a4d-9653-9082077afd29	f414d039-bb0d-4e59-9c39-a8f1e880b18a	Start	{"route": "ec48ee21-d65d-4615-b1fc-86d8982eec11", "title": "Escalate", "resources": ["alerts"], "inputVariables": [{"name": "incidentName", "type": "string", "title": "Text Field", "usable": true, "formType": "text", "collection": false, "dataSource": {"model": "picklists", "query": {"sort": [{"field": "orderIndex", "direction": "ASC"}], "logic": "AND", "filters": [{"field": "listName__name", "value": "AlertStatus", "operator": "eq"}]}}, "searchable": true, "templateUrl": "app/components/form/fields/input.html", "allowedGridColumn": true}, {"name": "severity", "type": "picklists", "title": "Picklist", "usable": true, "formType": "picklist", "collection": false, "dataSource": {"model": "picklists", "query": {"sort": [{"field": "orderIndex", "direction": "ASC"}], "logic": "AND", "filters": [{"field": "listName__name", "value": "Severity", "operator": "eq"}]}}, "searchable": false, "templateUrl": "app/components/form/fields/typeahead.html", "allowedGridColumn": true}, {"name": "incidentLead", "type": "people", "title": "Lookup", "usable": true, "formType": "lookup", "collection": false, "dataSource": {"model": "people"}, "searchable": false, "templateUrl": "app/components/form/fields/typeahead.html", "displayTemplate": "{{ firstname }} {{ lastname }}", "allowedGridColumn": true}]}	\N	170	11	1470
21f167cc-dc8b-4a73-97d5-cef79542a14a	b593663d-7d13-40ce-a3a3-96dece928722	link Alerts to new Incident	{"resource": "{\\"alerts\\" : {{vars.request.data.records}}, \\"severity\\":{{vars.request.data.severity}}, \\"incidentLead\\":{{vars.request.data.incidentLead}}}", "collection": "{{vars.result['@id']}}"}	\N	180	280	1471
fabf8f2c-8196-43f0-8860-08c4ff85f2d0	2597053c-e718-44b4-8394-4d40fe26d357	Insert One Incident_Many_to_One	{"resource": {"id": null, "name": "{{vars.request.data.incidentName}}", "phase": {"id": 206, "@id": "/api/3/picklists/c1bf084d-bc48-4a8a-8d85-627a8269f9f5", "icon": null, "@type": "Picklist", "color": null, "display": "Preparation", "listName": "/api/3/picklist_names/b862eb1f-b385-40ca-baa7-5a1b1f91a651", "itemValue": "Preparation", "orderIndex": 10}, "source": null, "status": {"id": 221, "@id": "/api/3/picklists/cfc78b79-522f-455c-a052-a16b162d54eb", "icon": null, "@type": "Picklist", "color": null, "display": "Open", "listName": "/api/3/picklist_names/a549e41c-31ca-406d-89ae-eab3de5c06c4", "itemValue": "Open", "orderIndex": 0}, "category": null, "closedOn": null, "severity": {"id": 195, "@id": "/api/3/picklists/b3c20a3a-ecfd-4adc-a225-0205968e6793", "icon": null, "@type": "Picklist", "color": "#D2AC1A", "display": "Medium", "listName": "/api/3/picklist_names/4e80cba3-032f-48b4-ac03-17e3ec247aac", "itemValue": "Medium", "orderIndex": 2}, "dwellTime": null, "confidence": null, "createDate": null, "createUser": null, "modifyDate": null, "modifyUser": null, "resolution": null, "description": "", "originPoint": null, "confirmation": null, "discoveredOn": null, "incidentLead": null, "recoveryTime": null, "dateOfIncident": null, "containmentTime": null, "systemAssignedQueue": null}, "_showJson": false, "collection": "/api/3/incidents"}	\N	180	128	1472
\.


--
-- Data for Name: workflow_routes; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_routes (uuid, targetstep_uuid, sourcestep_uuid, name, isexecuted) FROM stdin;
d83731db-8dc7-4949-a897-e492b0861d4a	fabf8f2c-8196-43f0-8860-08c4ff85f2d0	265765c0-0d62-4a4d-9653-9082077afd29	Start -> Insert One Incident_Many_to_One	f
f908b8a5-83a9-4ea4-b4df-38c196779ed1	21f167cc-dc8b-4a73-97d5-cef79542a14a	fabf8f2c-8196-43f0-8860-08c4ff85f2d0	Insert One Incident_Many_to_One -> link Alerts to new Incident	f
\.


--
-- Data for Name: workflows; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflows (uuid, triggerstep_uuid, collection, triggerlimit, name, tag, description, isactive, parameters, synchronous, id) FROM stdin;
6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e	265765c0-0d62-4a4d-9653-9082077afd29	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Escalate 	system,dev	This will create a new incident with the given inputs and will link the alert(s) to the newly created incident.	t	[]	f	1469
\.


--
-- Data for Name: workflow_workflowroute; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_workflowroute (workflow_uuid, workflowroute_uuid) FROM stdin;
6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e	d83731db-8dc7-4949-a897-e492b0861d4a
6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e	f908b8a5-83a9-4ea4-b4df-38c196779ed1
\.


--
-- Data for Name: workflow_workflowstep; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_workflowstep (workflow_uuid, workflowstep_uuid) FROM stdin;
6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e	265765c0-0d62-4a4d-9653-9082077afd29
6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e	21f167cc-dc8b-4a73-97d5-cef79542a14a
6e4c8e24-8786-4eaf-9b7f-723d44a2cc6e	fabf8f2c-8196-43f0-8860-08c4ff85f2d0
\.


--
-- PostgreSQL database dump complete
--

