/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

--
-- Data for Name: workflow_steps; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--
ALTER TABLE workflows drop column if exists description;
ALTER TABLE workflows ADD description varchar(255) DEFAULT NULL;

COPY workflow_steps (uuid, steptype_uuid, name, arguments, status, left_position, top_position, id) FROM stdin;
461d5188-d54c-47e2-a6fd-4f002b152abc	9300bf69-5063-486d-b3a6-47eb9da24872	On Task Update	{"resource": "tasks"}	\N	440	200	2219
d193ce0c-aa90-4054-bd8c-962f80b01abc	ee73e569-2188-43fe-a7f0-1964ba82a4de	Do Nothing	{"script": "/wf/workflow/tasks/no_op", "arguments": []}	\N	560	360	2220
8c4af03b-8234-40cc-a2b7-03ca64759abc	74932bdc-b8b6-4d24-88c4-1a4dfbc524f3	Try Email Assigned Person	{"arguments": [], "workflowReference": "/api/3/workflows/473494e3-92e7-4f68-9d30-a1392a1cdb78"}	\N	320	360	2221
2e718b7f-2192-45f8-a6a7-920ede3e7454	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check if Assigned To Person Changed	{"conditions": [{"step_iri": "/api/3/workflow_steps/8c4af03b-8234-40cc-a2b7-03ca64759abc", "condition": "{{ (vars.request.data.assignedToPerson['@id'] != vars.previous.data.assignedToPerson['@id']) }}"}, {"step_iri": "/api/3/workflow_steps/d193ce0c-aa90-4054-bd8c-962f80b01abc", "condition": "{{ true }}"}]}	\N	440	280	2222
5f0016c6-0316-47b0-b521-198bcab0c73e	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check Notification Preferences	{"conditions": [{"step_iri": "/api/3/workflow_steps/a44cecde-c105-486f-92ec-f7e8eeb450f2", "condition": "{{ (vars.request.data.assignedToPerson['@settings'] + '/user/notifications/email') | fromIRI }}"}, {"step_iri": "/api/3/workflow_steps/5fa79dea-1e4a-4fd1-b839-0fad3c33e069", "condition": "{{ True }}"}]}	\N	549	420	2223
be5a6af3-bd28-4cba-9315-22a7e4e32abc	ee73e569-2188-43fe-a7f0-1964ba82a4de	Do Nothing	{"script": "/wf/workflow/tasks/no_op", "arguments": []}	\N	240	420	2224
fcabbe4e-a644-4995-81fc-5545cb370abc	b348f017-9a94-471f-87f8-ce88b6a7ad62	On Task Event	[]	\N	380	189	2225
5a008f40-0ee0-4291-8123-e626cc3b2abc	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check if AssignedToPerson is Set	{"conditions": [{"step_iri": "/api/3/workflow_steps/be5a6af3-bd28-4cba-9315-22a7e4e32abc", "condition": "{{ (vars.request.data.assignedToPerson == None) }}"}, {"step_iri": "/api/3/workflow_steps/5f0016c6-0316-47b0-b521-198bcab0c73e", "condition": "{{ true }}"}]}	\N	380	300	2226
5fa79dea-1e4a-4fd1-b839-0fad3c33e069	b593663d-7d13-40ce-a3a3-96dece928778	Send Email To Admin Instead	{"to": ["no-reply@cybersponse.com"], "content": "<p>Administrator,</p>\\n<p>The following task has been assigned to {{ vars.request.data.assignedToPerson.firstname }} {{ vars.request.data.assignedToPerson.lastname }}:</p>\\n<table style=\\"width: 300px; border: 1px solid #dddddd;\\">\\n<tbody>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Task Name</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.name }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Priority</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.priority.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Status</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.status.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Type</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.type.itemValue }}</td>\\n</tr>\\n<tr>\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Description</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.description}}</td>\\n</tr>\\n</tbody>\\n</table>\\n<p><br />You can view this task by clicking here:<br />{% set idParts = vars.request.data['@id'].split('/') %}<br /><a href=\\"{{ vars.request.baseUri + '/modules/tasks/' + (idParts | last) }}\\">{{ vars.request.baseUri + '/modules/tasks/' + (idParts | last) }}</a></p>\\n<p>Thanks,<br /> CyberSponse</p>", "subject": "CyberSponse: A task has been assigned to you.", "from_str": "no-reply@cybersponse.com", "content_type": "text/html"}	\N	700	600	2227
a44cecde-c105-486f-92ec-f7e8eeb450f2	b593663d-7d13-40ce-a3a3-96dece928778	Send User Email Step	{"to": ["{{ vars.request.data.assignedToPerson.email }}"], "content": "<p>Hey {{ vars.request.data.assignedToPerson.firstname }}, the following task has been assigned to you:</p>\\n<table style=\\"width: 300px; border: 1px solid #dddddd;\\">\\n<tbody>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Task Name</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.name }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Priority</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.priority.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Status</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.status.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Type</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.type.itemValue }}</td>\\n</tr>\\n<tr>\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #dddddd; width: 75px;\\"><strong>Description</strong></td>\\n<td style=\\"width: 224px;\\">{{ vars.request.data.description}}</td>\\n</tr>\\n</tbody>\\n</table>\\n<p><br />You can view this task by clicking here:<br />{% set idParts = vars.request.data['@id'].split('/') %}<br /><a href=\\"{{ vars.request.baseUri + '/modules/tasks/' + (idParts | last) }}\\">{{ vars.request.baseUri + '/modules/tasks/' + (idParts | last) }}</a></p>\\n<p>Thanks,<br /> CyberSponse</p>", "subject": "CyberSponse: A task has been assigned.", "from_str": "no-reply@cybersponse.com", "content_type": "text/html"}	\N	400	600	2228
7ce10c45-0d87-4765-9d22-755e1e4bfabc	ea155646-3821-4542-9702-b246da430a8d	Start	{"resource": "tasks"}	\N	313	187	2229
c52547af-3793-4631-af3e-851f44310abc	74932bdc-b8b6-4d24-88c4-1a4dfbc524f3	Check Task Assigned Person	{"arguments": [], "workflowReference": "/api/3/workflows/473494e3-92e7-4f68-9d30-a1392a1cdb78"}	\N	311	312	2230
a813fdde-af48-474d-a5c9-057bc78682c6	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check if AssignedToPerson is Set	{"conditions": [{"step_iri": "/api/3/workflow_steps/4c7ee97b-6979-4fa6-a800-5f34be0e032e", "condition": "{{ (vars.request.data.assignedTo == None) }}"}, {"step_iri": "/api/3/workflow_steps/3f3c8f64-5374-41a2-b8d8-6a607d35b94c", "condition": "{{ true }}"}]}	\N	380	300	2231
4c7ee97b-6979-4fa6-a800-5f34be0e032e	ee73e569-2188-43fe-a7f0-1964ba82a4de	Do Nothing	{"script": "/wf/workflow/tasks/no_op", "arguments": []}	\N	240	420	2232
7ba0dfbb-2e23-4c25-ae66-c53431c55abc	b348f017-9a94-471f-87f8-ce88b6a7ad62	On Alert Event	[]	\N	380	189	2233
3f3c8f64-5374-41a2-b8d8-6a607d35b94c	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check Notification Preferences	{"conditions": [{"step_iri": "/api/3/workflow_steps/d5508c5d-0006-4d0f-9077-426da8993f69", "condition": "{{ (vars.request.data.assignedTo['@settings'] + '/user/notifications/email') | fromIRI }}"}, {"step_iri": "/api/3/workflow_steps/ac600d91-4385-42c5-a713-edc3d9d4a122", "condition": "{{ True }}"}]}	\N	549	420	2234
ac600d91-4385-42c5-a713-edc3d9d4a122	b593663d-7d13-40ce-a3a3-96dece928778	Send Email To Admin Instead	{"to": ["no-reply@cybersponse.com"], "content": "<p>Administrator,</p>\\n<p>The following alert has been assigned to {{ vars.request.data.assignedTo.firstname }} {{ vars.request.data.assignedTo.lastname }}:</p>\\n<table style=\\"width: 300px; border: 1px solid #dddddd;\\">\\n<tbody>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Alert Name</strong></td>\\n<td>{{ vars.request.data.name }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Severity</strong></td>\\n<td>{{ vars.request.data.severity.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Status</strong></td>\\n<td>{{ vars.request.data.status.itemValue }}</td>\\n</tr>\\n<tr>\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Description</strong></td>\\n<td>{{ vars.request.data.description}}</td>\\n</tr>\\n</tbody>\\n</table>\\n<p><br />You can view this alert by clicking here:<br />{% set idParts = vars.request.data['@id'].split('/') %}<br /><a href=\\"{{ vars.request.baseUri + '/modules/alerts/' + (idParts | last) }}\\">{{ vars.request.baseUri + '/modules/alerts/' + (idParts | last) }}</a></p>\\n<p>Thanks,<br /> CyberSponse</p>", "subject": "CyberSponse: An alert has been assigned to you.", "from_str": "no-reply@cybersponse.com", "content_type": "text/html"}	\N	700	600	2235
d5508c5d-0006-4d0f-9077-426da8993f69	b593663d-7d13-40ce-a3a3-96dece928778	Send User Email Step	{"to": ["{{ vars.request.data.assignedTo.email }}"], "content": "<p>Hey {{ vars.request.data.assignedTo.firstname }}, the following alert has been assigned to you:</p>\\n<table style=\\"width: 300px; border: 1px solid #dddddd;\\">\\n<tbody>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Alert Name</strong></td>\\n<td>{{ vars.request.data.name }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Severity</strong></td>\\n<td>{{ vars.request.data.severity.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Status</strong></td>\\n<td>{{ vars.request.data.status.itemValue }}</td>\\n</tr>\\n<tr>\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Description</strong></td>\\n<td>{{ vars.request.data.description}}</td>\\n</tr>\\n</tbody>\\n</table>\\n<p><br />You can view this alert by clicking here:<br />{% set idParts = vars.request.data['@id'].split('/') %}<br /><a href=\\"{{ vars.request.baseUri + '/modules/alerts/' + (idParts | last) }}\\">{{ vars.request.baseUri + '/modules/alerts/' + (idParts | last) }}</a></p>\\n<p>Thanks,<br /> CyberSponse</p>", "subject": "CyberSponse: An alert has been assigned.", "from_str": "no-reply@cybersponse.com", "content_type": "text/html"}	\N	400	600	2236
54268fa0-e0b2-419f-9e4b-e10cf5c55e74	ea155646-3821-4542-9702-b246da430a8d	Start	{"resource": "alerts"}	\N	313	187	2237
867ae2a9-70f2-4e0b-8ee4-7a6a23d02b52	74932bdc-b8b6-4d24-88c4-1a4dfbc524f3	Check Alert Assigned Person	{"arguments": [], "workflowReference": "/api/3/workflows/aea46442-58d2-45c3-90ff-1fa5d10527ed"}	\N	311	312	2238
3c5f0238-6992-4e1f-8b88-d0812e6bfac6	ee73e569-2188-43fe-a7f0-1964ba82a4de	Do Nothing	{"script": "/wf/workflow/tasks/no_op", "arguments": []}	\N	560	360	2239
74e987f9-e17e-4ac1-9d05-009500968dd4	74932bdc-b8b6-4d24-88c4-1a4dfbc524f3	Try Email Assigned Person	{"arguments": [], "workflowReference": "/api/3/workflows/aea46442-58d2-45c3-90ff-1fa5d10527ed"}	\N	320	360	2240
1ed7ab08-8313-4910-a17d-db9bd2574471	9300bf69-5063-486d-b3a6-47eb9da24872	On Alert Update	{"resource": "alerts"}	\N	440	200	2241
9cb9b909-f4d1-4f35-9c30-c47ebc6458e3	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check if Assigned To Person Changed	{"conditions": [{"step_iri": "/api/3/workflow_steps/74e987f9-e17e-4ac1-9d05-009500968dd4", "condition": "{{ (vars.request.data.assignedTo['@id'] != vars.previous.data.assignedTo['@id']) }}"}, {"step_iri": "/api/3/workflow_steps/3c5f0238-6992-4e1f-8b88-d0812e6bfac6", "condition": "{{ true }}"}]}	\N	440	280	2242
f779e254-c5c1-4c8b-9452-7de980c7aea1	ee73e569-2188-43fe-a7f0-1964ba82a4de	Do Nothing	{"script": "/wf/workflow/tasks/no_op", "arguments": []}	\N	560	360	2243
035a8aba-b7b2-407d-904f-cd4990a2b216	74932bdc-b8b6-4d24-88c4-1a4dfbc524f3	Try Email Assigned Person	{"arguments": [], "workflowReference": "/api/3/workflows/c988380d-038b-4321-99d5-b62e3e00946e"}	\N	320	360	2244
7dc41a92-30aa-42a3-9227-d44957514573	9300bf69-5063-486d-b3a6-47eb9da24872	On Incident Update	{"resource": "incidents"}	\N	440	200	2245
669b769b-9def-456f-9406-76f212b8027a	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check if Assigned To Person Changed	{"conditions": [{"step_iri": "/api/3/workflow_steps/035a8aba-b7b2-407d-904f-cd4990a2b216", "condition": "{{ (vars.request.data.incidentLead['@id'] != vars.previous.data.incidentLead['@id']) }}"}, {"step_iri": "/api/3/workflow_steps/f779e254-c5c1-4c8b-9452-7de980c7aea1", "condition": "{{ true }}"}]}	\N	440	280	2246
709e9a09-0ac6-4b97-acbb-ccd9982f573e	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check if incidentLead is Set	{"conditions": [{"step_iri": "/api/3/workflow_steps/4ba2e5ba-0220-4482-8e43-c8e0231a878c", "condition": "{{ (vars.request.data.incidentLead == None) }}"}, {"step_iri": "/api/3/workflow_steps/bfda91e0-9876-4c0c-80a0-3f08af1839b9", "condition": "{{ true }}"}]}	\N	380	300	2247
4ba2e5ba-0220-4482-8e43-c8e0231a878c	ee73e569-2188-43fe-a7f0-1964ba82a4de	Do Nothing	{"script": "/wf/workflow/tasks/no_op", "arguments": []}	\N	240	420	2248
a36f13ba-a0bf-4759-b02c-d407c5360d48	b348f017-9a94-471f-87f8-ce88b6a7ad62	On Incident Event	[]	\N	380	189	2249
bfda91e0-9876-4c0c-80a0-3f08af1839b9	12254cf5-5db7-4b1a-8cb1-3af081924b28	Check Notification Preferences	{"conditions": [{"step_iri": "/api/3/workflow_steps/ebba511e-a30c-454f-962c-7f6789d02ed7", "condition": "{{ (vars.request.data.incidentLead['@settings'] + '/user/notifications/email') | fromIRI }}"}, {"step_iri": "/api/3/workflow_steps/8b9d0c7d-6b63-42fd-8d75-bda95f03863f", "condition": "{{ True }}"}]}	\N	549	420	2250
8b9d0c7d-6b63-42fd-8d75-bda95f03863f	b593663d-7d13-40ce-a3a3-96dece928778	Send Email To Admin Instead	{"to": ["no-reply@cybersponse.com"], "content": "<p>Administrator,</p>\\n<p>The following incident has been assigned to {{ vars.request.data.incidentLead.firstname }} {{ vars.request.data.incidentLead.lastname }}:</p>\\n<table style=\\"width: 300px; border: 1px solid #dddddd;\\">\\n<tbody>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Incident Name</strong></td>\\n<td>{{ vars.request.data.name }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Severity</strong></td>\\n<td>{{ vars.request.data.severity.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Status</strong></td>\\n<td>{{ vars.request.data.status.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Phase</strong></td>\\n<td>{{ vars.request.data.phase.itemValue }}</td>\\n</tr>\\n<tr>\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Description</strong></td>\\n<td>{{ vars.request.data.description}}</td>\\n</tr>\\n</tbody>\\n</table>\\n<p><br />You can view this alert by clicking here:<br />{% set idParts = vars.request.data['@id'].split('/') %}<br /><a href=\\"{{ vars.request.baseUri + '/modules/incidents/' + (idParts | last) }}\\">{{ vars.request.baseUri + '/modules/incidents/' + (idParts | last) }}</a></p>\\n<p>Thanks,<br /> CyberSponse</p>", "subject": "CyberSponse: An incident has been assigned.", "from_str": "no-reply@cybersponse.com", "content_type": "text/html"}	\N	700	600	2251
ebba511e-a30c-454f-962c-7f6789d02ed7	b593663d-7d13-40ce-a3a3-96dece928778	Send User Email Step	{"to": ["{{ vars.request.data.incidentLead.email }}"], "content": "<p>Hey {{ vars.request.data.incidentLead.firstname }}, the following incident has been assigned to you:</p>\\n<table style=\\"width: 300px; border: 1px solid #dddddd;\\">\\n<tbody>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Incident Name</strong></td>\\n<td>{{ vars.request.data.name }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Severity</strong></td>\\n<td>{{ vars.request.data.severity.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Status</strong></td>\\n<td>{{ vars.request.data.status.itemValue }}</td>\\n</tr>\\n<tr style=\\"border-bottom: 1px solid #ddd;\\">\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Phase</strong></td>\\n<td>{{ vars.request.data.phase.itemValue }}</td>\\n</tr>\\n<tr>\\n<td style=\\"text-align: right; padding: 5px; border-right: 1px solid #ddd;\\"><strong>Description</strong></td>\\n<td>{{ vars.request.data.description}}</td>\\n</tr>\\n</tbody>\\n</table>\\n<p><br />You can view this incident by clicking here:<br />{% set idParts = vars.request.data['@id'].split('/') %}<br /><a href=\\"{{ vars.request.baseUri + '/modules/incidents/' + (idParts | last) }}\\">{{ vars.request.baseUri + '/modules/incidents/' + (idParts | last) }}</a></p>\\n<p>Thanks,<br /> CyberSponse</p>", "subject": "CyberSponse: An incident has been assigned to you.", "from_str": "no-reply@cybersponse.com", "content_type": "text/html"}	\N	400	600	2252
07a8f6ee-f427-4e5a-a647-bb7e145fe6a0	ea155646-3821-4542-9702-b246da430a8d	Start	{"resource": "incidents"}	\N	313	187	2253
345f8345-1c30-4e94-b914-61b164201846	74932bdc-b8b6-4d24-88c4-1a4dfbc524f3	Check Incident Assigned Person	{"arguments": [], "workflowReference": "/api/3/workflows/c988380d-038b-4321-99d5-b62e3e00946e"}	\N	311	312	2254
\.


--
-- Data for Name: workflow_routes; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_routes (uuid, targetstep_uuid, sourcestep_uuid, name, isexecuted) FROM stdin;
797fb065-1b2e-44eb-9beb-26cf5013dabc	2e718b7f-2192-45f8-a6a7-920ede3e7454	461d5188-d54c-47e2-a6fd-4f002b152abc	On Task Update -> Check if "Assigned To Person" Changed	f
e6b581d5-77a6-410b-859f-693e42145075	8c4af03b-8234-40cc-a2b7-03ca64759abc	2e718b7f-2192-45f8-a6a7-920ede3e7454	Check if "Assigned To Person" Changed -> Check Task Assigned Person	f
f588f818-a144-4c98-99d1-5e013b151619	d193ce0c-aa90-4054-bd8c-962f80b01abc	2e718b7f-2192-45f8-a6a7-920ede3e7454	Check if "Assigned To Person" Changed -> Do Nothing	f
3c33a61e-6647-489d-a739-922506e5a456	be5a6af3-bd28-4cba-9315-22a7e4e32abc	5a008f40-0ee0-4291-8123-e626cc3b2abc	Check if AssignedToPerson is Set -> Do Nothing	f
da195b33-36f7-4f25-b54e-84024298d23c	5a008f40-0ee0-4291-8123-e626cc3b2abc	fcabbe4e-a644-4995-81fc-5545cb370abc	On Task Event -> Check if AssignedToPerson is Set	f
41518c26-0aea-4f11-8086-88c87b2826f8	5f0016c6-0316-47b0-b521-198bcab0c73e	5a008f40-0ee0-4291-8123-e626cc3b2abc	Check if AssignedToPerson is Set -> Check Notification Preferences	f
c4ff2297-6e25-43f4-9251-2433ef96d4c9	a44cecde-c105-486f-92ec-f7e8eeb450f2	5f0016c6-0316-47b0-b521-198bcab0c73e	Check Notification Preferences -> Send User Email Step	f
9df8be1f-46e6-4156-b087-fecfaf5255a1	5fa79dea-1e4a-4fd1-b839-0fad3c33e069	5f0016c6-0316-47b0-b521-198bcab0c73e	Check Notification Preferences -> Send Email To Admin Instead	f
66e99828-f364-46dc-bda6-026da5830abc	c52547af-3793-4631-af3e-851f44310abc	7ce10c45-0d87-4765-9d22-755e1e4bfabc	Start -> Check Task Assigned Person	f
7480da87-5a75-41f1-98fe-befb5cacffb8	4c7ee97b-6979-4fa6-a800-5f34be0e032e	a813fdde-af48-474d-a5c9-057bc78682c6	Check if AssignedToPerson is Set -> Do Nothing	f
37621596-913d-40a3-a251-3080f62392df	a813fdde-af48-474d-a5c9-057bc78682c6	7ba0dfbb-2e23-4c25-ae66-c53431c55abc	On Task Event -> Check if AssignedToPerson is Set	f
e107866e-3590-4d9c-85d2-e60a6e58c826	3f3c8f64-5374-41a2-b8d8-6a607d35b94c	a813fdde-af48-474d-a5c9-057bc78682c6	Check if AssignedToPerson is Set -> Check Notification Preferences	f
94c3102a-4112-4762-87e0-a04b9c5100fe	d5508c5d-0006-4d0f-9077-426da8993f69	3f3c8f64-5374-41a2-b8d8-6a607d35b94c	Check Notification Preferences -> Send User Email Step	f
6f4313f5-478e-4cdd-a155-ca2d645cb891	ac600d91-4385-42c5-a713-edc3d9d4a122	3f3c8f64-5374-41a2-b8d8-6a607d35b94c	Check Notification Preferences -> Send Email To Admin Instead	f
690b4916-5841-426c-8526-2d157d3967e3	867ae2a9-70f2-4e0b-8ee4-7a6a23d02b52	54268fa0-e0b2-419f-9e4b-e10cf5c55e74	Start -> Check Task Assigned Person	f
726c5ab0-0406-486e-8d48-013289febd0c	9cb9b909-f4d1-4f35-9c30-c47ebc6458e3	1ed7ab08-8313-4910-a17d-db9bd2574471	On Task Update -> Check if "Assigned To Person" Changed	f
84b6869a-5b32-4532-aaa7-a9ca8c3a89dd	74e987f9-e17e-4ac1-9d05-009500968dd4	9cb9b909-f4d1-4f35-9c30-c47ebc6458e3	Check if "Assigned To Person" Changed -> Check Task Assigned Person	f
e2329a81-cb68-4240-bde6-d9e201ffe521	3c5f0238-6992-4e1f-8b88-d0812e6bfac6	9cb9b909-f4d1-4f35-9c30-c47ebc6458e3	Check if "Assigned To Person" Changed -> Do Nothing	f
2e2c3e82-b8fe-49ab-9129-058ff431c7f1	669b769b-9def-456f-9406-76f212b8027a	7dc41a92-30aa-42a3-9227-d44957514573	On Task Update -> Check if "Assigned To Person" Changed	f
44e7f5c2-de5c-4860-b5a8-72e1783871bd	035a8aba-b7b2-407d-904f-cd4990a2b216	669b769b-9def-456f-9406-76f212b8027a	Check if "Assigned To Person" Changed -> Check Task Assigned Person	f
d2ea4c74-ae9e-4a4e-a966-d42169c9ae19	f779e254-c5c1-4c8b-9452-7de980c7aea1	669b769b-9def-456f-9406-76f212b8027a	Check if "Assigned To Person" Changed -> Do Nothing	f
a3adf95d-354a-4e26-bd85-c76547c9645b	4ba2e5ba-0220-4482-8e43-c8e0231a878c	709e9a09-0ac6-4b97-acbb-ccd9982f573e	Check if AssignedToPerson is Set -> Do Nothing	f
b7a2da5d-6b20-46cd-9cc7-62c8efd2a433	709e9a09-0ac6-4b97-acbb-ccd9982f573e	a36f13ba-a0bf-4759-b02c-d407c5360d48	On Task Event -> Check if AssignedToPerson is Set	f
c0049ac9-d92f-449f-88a7-7ff5b947ba9a	bfda91e0-9876-4c0c-80a0-3f08af1839b9	709e9a09-0ac6-4b97-acbb-ccd9982f573e	Check if AssignedToPerson is Set -> Check Notification Preferences	f
f684f15c-127b-4f38-bdd7-2cb0cf655b52	ebba511e-a30c-454f-962c-7f6789d02ed7	bfda91e0-9876-4c0c-80a0-3f08af1839b9	Check Notification Preferences -> Send User Email Step	f
8e5b625c-dd20-4e74-9ef7-67313bc3318a	8b9d0c7d-6b63-42fd-8d75-bda95f03863f	bfda91e0-9876-4c0c-80a0-3f08af1839b9	Check Notification Preferences -> Send Email To Admin Instead	f
1886e999-54e9-4fef-8ee0-1e481610d969	345f8345-1c30-4e94-b914-61b164201846	07a8f6ee-f427-4e5a-a647-bb7e145fe6a0	Start -> Check Task Assigned Person	f
\.


--
-- Data for Name: workflows; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflows (uuid, triggerstep_uuid, collection, triggerlimit, name, tag, description, isactive, parameters, synchronous, id) FROM stdin;
a65f4563-0635-438f-a570-58e329a3ae6g	461d5188-d54c-47e2-a6fd-4f002b152abc	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Tasks: Update Notification	system,dev	\N	t	[]	f	2210
473494e3-92e7-4f68-9d30-a1392a1cdb78	fcabbe4e-a644-4995-81fc-5545cb370abc	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Tasks: Notify if Assigned	abstract,system,dev	\N	t	[]	f	2211
3b7818e8-acba-4e3f-bf3e-60729023f9g3	7ce10c45-0d87-4765-9d22-755e1e4bfabc	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Tasks: Create Notification	system,dev	\N	t	[]	f	2212
aea46442-58d2-45c3-90ff-1fa5d10527ed	7ba0dfbb-2e23-4c25-ae66-c53431c55abc	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Alerts: Notify if Assigned	abstract,system,dev	\N	t	[]	f	2213
8cb60642-38f7-4a40-b0dc-5ba314211b8d	54268fa0-e0b2-419f-9e4b-e10cf5c55e74	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Alerts: Create Notification	system,dev	\N	t	[]	f	2214
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	1ed7ab08-8313-4910-a17d-db9bd2574471	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Alerts: Update Notification	system,dev	\N	t	[]	f	2215
b5c58a34-8205-416a-b3ae-ba554cf30aa6	7dc41a92-30aa-42a3-9227-d44957514573	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Incidents: Update Notification	system,dev	\N	t	[]	f	2216
c988380d-038b-4321-99d5-b62e3e00946e	a36f13ba-a0bf-4759-b02c-d407c5360d48	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Incidents: Notify if Assigned	abstract,system,dev	\N	t	[]	f	2217
d2e2aa77-4887-4ce7-b473-f6c888d948ab	07a8f6ee-f427-4e5a-a647-bb7e145fe6a0	6368061c-c6ea-462b-b33f-75437efb0e3b	\N	Incidents: Create Notification	system,dev	\N	t	[]	f	2218
\.


--
-- Data for Name: workflow_workflowroute; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_workflowroute (workflow_uuid, workflowroute_uuid) FROM stdin;
a65f4563-0635-438f-a570-58e329a3ae6g	797fb065-1b2e-44eb-9beb-26cf5013dabc
a65f4563-0635-438f-a570-58e329a3ae6g	e6b581d5-77a6-410b-859f-693e42145075
a65f4563-0635-438f-a570-58e329a3ae6g	f588f818-a144-4c98-99d1-5e013b151619
473494e3-92e7-4f68-9d30-a1392a1cdb78	3c33a61e-6647-489d-a739-922506e5a456
473494e3-92e7-4f68-9d30-a1392a1cdb78	da195b33-36f7-4f25-b54e-84024298d23c
473494e3-92e7-4f68-9d30-a1392a1cdb78	41518c26-0aea-4f11-8086-88c87b2826f8
473494e3-92e7-4f68-9d30-a1392a1cdb78	c4ff2297-6e25-43f4-9251-2433ef96d4c9
473494e3-92e7-4f68-9d30-a1392a1cdb78	9df8be1f-46e6-4156-b087-fecfaf5255a1
3b7818e8-acba-4e3f-bf3e-60729023f9g3	66e99828-f364-46dc-bda6-026da5830abc
aea46442-58d2-45c3-90ff-1fa5d10527ed	7480da87-5a75-41f1-98fe-befb5cacffb8
aea46442-58d2-45c3-90ff-1fa5d10527ed	37621596-913d-40a3-a251-3080f62392df
aea46442-58d2-45c3-90ff-1fa5d10527ed	e107866e-3590-4d9c-85d2-e60a6e58c826
aea46442-58d2-45c3-90ff-1fa5d10527ed	94c3102a-4112-4762-87e0-a04b9c5100fe
aea46442-58d2-45c3-90ff-1fa5d10527ed	6f4313f5-478e-4cdd-a155-ca2d645cb891
8cb60642-38f7-4a40-b0dc-5ba314211b8d	690b4916-5841-426c-8526-2d157d3967e3
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	726c5ab0-0406-486e-8d48-013289febd0c
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	84b6869a-5b32-4532-aaa7-a9ca8c3a89dd
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	e2329a81-cb68-4240-bde6-d9e201ffe521
b5c58a34-8205-416a-b3ae-ba554cf30aa6	2e2c3e82-b8fe-49ab-9129-058ff431c7f1
b5c58a34-8205-416a-b3ae-ba554cf30aa6	44e7f5c2-de5c-4860-b5a8-72e1783871bd
b5c58a34-8205-416a-b3ae-ba554cf30aa6	d2ea4c74-ae9e-4a4e-a966-d42169c9ae19
c988380d-038b-4321-99d5-b62e3e00946e	a3adf95d-354a-4e26-bd85-c76547c9645b
c988380d-038b-4321-99d5-b62e3e00946e	b7a2da5d-6b20-46cd-9cc7-62c8efd2a433
c988380d-038b-4321-99d5-b62e3e00946e	c0049ac9-d92f-449f-88a7-7ff5b947ba9a
c988380d-038b-4321-99d5-b62e3e00946e	f684f15c-127b-4f38-bdd7-2cb0cf655b52
c988380d-038b-4321-99d5-b62e3e00946e	8e5b625c-dd20-4e74-9ef7-67313bc3318a
d2e2aa77-4887-4ce7-b473-f6c888d948ab	1886e999-54e9-4fef-8ee0-1e481610d969
\.


--
-- Data for Name: workflow_workflowstep; Type: TABLE DATA; Schema: public; Owner: cyberpgsql
--

COPY workflow_workflowstep (workflow_uuid, workflowstep_uuid) FROM stdin;
a65f4563-0635-438f-a570-58e329a3ae6g	461d5188-d54c-47e2-a6fd-4f002b152abc
a65f4563-0635-438f-a570-58e329a3ae6g	d193ce0c-aa90-4054-bd8c-962f80b01abc
a65f4563-0635-438f-a570-58e329a3ae6g	8c4af03b-8234-40cc-a2b7-03ca64759abc
a65f4563-0635-438f-a570-58e329a3ae6g	2e718b7f-2192-45f8-a6a7-920ede3e7454
473494e3-92e7-4f68-9d30-a1392a1cdb78	5f0016c6-0316-47b0-b521-198bcab0c73e
473494e3-92e7-4f68-9d30-a1392a1cdb78	be5a6af3-bd28-4cba-9315-22a7e4e32abc
473494e3-92e7-4f68-9d30-a1392a1cdb78	fcabbe4e-a644-4995-81fc-5545cb370abc
473494e3-92e7-4f68-9d30-a1392a1cdb78	5a008f40-0ee0-4291-8123-e626cc3b2abc
473494e3-92e7-4f68-9d30-a1392a1cdb78	5fa79dea-1e4a-4fd1-b839-0fad3c33e069
473494e3-92e7-4f68-9d30-a1392a1cdb78	a44cecde-c105-486f-92ec-f7e8eeb450f2
3b7818e8-acba-4e3f-bf3e-60729023f9g3	7ce10c45-0d87-4765-9d22-755e1e4bfabc
3b7818e8-acba-4e3f-bf3e-60729023f9g3	c52547af-3793-4631-af3e-851f44310abc
aea46442-58d2-45c3-90ff-1fa5d10527ed	a813fdde-af48-474d-a5c9-057bc78682c6
aea46442-58d2-45c3-90ff-1fa5d10527ed	4c7ee97b-6979-4fa6-a800-5f34be0e032e
aea46442-58d2-45c3-90ff-1fa5d10527ed	7ba0dfbb-2e23-4c25-ae66-c53431c55abc
aea46442-58d2-45c3-90ff-1fa5d10527ed	3f3c8f64-5374-41a2-b8d8-6a607d35b94c
aea46442-58d2-45c3-90ff-1fa5d10527ed	ac600d91-4385-42c5-a713-edc3d9d4a122
aea46442-58d2-45c3-90ff-1fa5d10527ed	d5508c5d-0006-4d0f-9077-426da8993f69
8cb60642-38f7-4a40-b0dc-5ba314211b8d	54268fa0-e0b2-419f-9e4b-e10cf5c55e74
8cb60642-38f7-4a40-b0dc-5ba314211b8d	867ae2a9-70f2-4e0b-8ee4-7a6a23d02b52
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	3c5f0238-6992-4e1f-8b88-d0812e6bfac6
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	74e987f9-e17e-4ac1-9d05-009500968dd4
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	1ed7ab08-8313-4910-a17d-db9bd2574471
d1edda8a-3c2f-4b5c-a178-ca9a096ab336	9cb9b909-f4d1-4f35-9c30-c47ebc6458e3
b5c58a34-8205-416a-b3ae-ba554cf30aa6	f779e254-c5c1-4c8b-9452-7de980c7aea1
b5c58a34-8205-416a-b3ae-ba554cf30aa6	035a8aba-b7b2-407d-904f-cd4990a2b216
b5c58a34-8205-416a-b3ae-ba554cf30aa6	7dc41a92-30aa-42a3-9227-d44957514573
b5c58a34-8205-416a-b3ae-ba554cf30aa6	669b769b-9def-456f-9406-76f212b8027a
c988380d-038b-4321-99d5-b62e3e00946e	709e9a09-0ac6-4b97-acbb-ccd9982f573e
c988380d-038b-4321-99d5-b62e3e00946e	4ba2e5ba-0220-4482-8e43-c8e0231a878c
c988380d-038b-4321-99d5-b62e3e00946e	a36f13ba-a0bf-4759-b02c-d407c5360d48
c988380d-038b-4321-99d5-b62e3e00946e	bfda91e0-9876-4c0c-80a0-3f08af1839b9
c988380d-038b-4321-99d5-b62e3e00946e	8b9d0c7d-6b63-42fd-8d75-bda95f03863f
c988380d-038b-4321-99d5-b62e3e00946e	ebba511e-a30c-454f-962c-7f6789d02ed7
d2e2aa77-4887-4ce7-b473-f6c888d948ab	07a8f6ee-f427-4e5a-a647-bb7e145fe6a0
d2e2aa77-4887-4ce7-b473-f6c888d948ab	345f8345-1c30-4e94-b914-61b164201846
\.


--
-- PostgreSQL database dump complete
--

