Migrations
----------

Migrations basically get systems to the fixture baseline. Whatever is in the fixtures, there should be a migration to get a current system's data to that baseline.

#### Creating a Migration

Migrations against entities in the system should use the ORM migrations. Ones that target documents in the system should use ODM migrations. See below:

##### ORM
Run the following command in the crud-hub directory to generate a migration template: 
``` sh
app/console doctrine:migrations:generate
```

The migration template will contain stubs for the up and down methods. Every migration should implement both an up and a down, where possible.

Run the following command to migrate up:
``` sh
app/console doctrine:migrations:migrate
```

To migrate to a specific version (such as when testing your down):
``` sh
app/console doctrine:migrations:migrate 1234567890
```

You can pass the `--no-interaction` flag to the migrate command to skip the confirmation prompt. 

Once your migration is complete, go to the file: `app/Fixtures/ORM/migration/Migrations/migrations.yml` and add your migration to that.

##### ODM
Run the following command in the crud-hub directory: 
``` sh
app/console mongodb:migrations:generate
```

Then, go to the file: `app/Fixtures/ODM/migration/Migrations/migrations.yml` and add your migration to that.

Perform a backup if you want:
``` sh
mongodump --db venom
```

Restore a backup before running the migration if you want:
``` sh
mongorestore dump/venom/ --drop
```

Run the following command to migrate up
``` sh
app/console mongodb:migrations:migrate
```

Run the following command to migrate to a specific version
``` sh
app/console mongodb:migrations:migrate 1234567890
```
