<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\ActorsBundle\Entity;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\ORM\Mapping\UniqueConstraint;
use Cybersponse\FilesBundle\Entity\AbstractFile;
/**
 * @ORM\Table(name="avatar", uniqueConstraints={@UniqueConstraint(name="uploadUser_unique", columns={"uploaduser"})})
 * @ORM\Entity
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Cybersponse\ActorsBundle\Repository\AvatarRepository")
 * @ORM\InheritanceType("SINGLE_TABLE")
 * @ORM\DiscriminatorColumn(name="record_type", type="string", length=20)
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="avatars")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="application")
 *
 */
class Avatar extends AbstractFile
{
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`name`", type="string",length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Searchable\Searchable()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Name")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\BulkAction\BulkAction(allow=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="text")
     */
    protected $name;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`mimeType`", type="string",length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Searchable\Searchable()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Mime Type")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\BulkAction\BulkAction(allow=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="text")
     */
    protected $mimeType;
    /**
     * @var integer Height in pixels
     *
     * @Doctrine\ORM\Mapping\Column(name="`size`", type="integer",length=100000, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Size")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\BulkAction\BulkAction(allow=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="integer")
     */
    protected $size;
    /**
     * @var integer Height in pixels
     *
     * @Doctrine\ORM\Mapping\Column(name="`height`", type="integer",length=250, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Height")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\BulkAction\BulkAction(allow=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="integer")
     */
    protected $height;
    /**
     * @var integer Width in pixels
     *
     * @Doctrine\ORM\Mapping\Column(name="`width`", type="integer",length=250, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Width")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\BulkAction\BulkAction(allow=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="integer")
     */
    protected $width;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`uploaduser`", type="string", length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Upload User")
     * @Symfony\Component\Validator\Constraints\NotBlank()
     * @Symfony\Component\Validator\Constraints\NotNull()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="text")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Visibility\Visibility(visibility=false)
     */
    protected $uploadUser;
    /**
     * Set owner
     * @param string $uploadUser
     * @return self
     */
    public function setUploadUser($uploadUser)
    {
        $this->uploadUser = $uploadUser;
        return $this;
    }
    /**
     * Get owner
     *
     * @return string $owner
     */
    public function getUploadUser()
    {
        return $this->uploadUser;
    }
    /**
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * @param string $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * @return int
     */
    public function getHeight()
    {
        return $this->height;
    }
    /**
     * @param int $height
     */
    public function setHeight($height)
    {
        $this->height = $height;
    }
    /**
     * @return int
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * @param int $width
     */
    public function setWidth($width)
    {
        $this->width = $width;
    }
}
