<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\ActorsBundle\Provider;
use Cybersponse\ActorsBundle\Entity\Avatar;
use Cybersponse\ActorsBundle\Entity\Actor;
use Cybersponse\ActorsBundle\Repository\AvatarRepository;
use Cybersponse\CoreBundle\Provider\ActorDataProvider;
use Doctrine\ORM\EntityManager;
use Dunglas\ApiBundle\Api\IriConverterInterface;
use Symfony\Component\Security\Core\Authentication\Token\TokenInterface;
/**
 * Data provider for the Avatar document.
 *
 */
class AvatarProvider extends ActorDataProvider
{
    /** @var EntityManager */
    protected $avatarManager;
    /** @var IriConverterInterface */
    protected $iriConverter;
    /**
     * @inheritdoc
     * @return Avatar
     */
    public function getDataForActor(Actor $actor)
    {
        $userId = $this->iriConverter->getIriFromItem($actor);
        /** @var AvatarRepository $avatarRepository */
        $avatarRepository = $this->avatarManager->getRepository(Avatar::class);
        $avatar = $avatarRepository->getUserAvatar($userId);
        return $avatar;
    }
    /**
     * @inheritdoc
     * @return Avatar
     */
    public function getDataForToken(TokenInterface $token)
    {
        return parent::getDataForToken($token);
    }
    /**
     * @inheritdoc
     * @return Avatar
     */
    public function getDataForCurrentUser()
    {
        return parent::getDataForCurrentUser();
    }
    /**
     * @param EntityManager $avatarManager
     */
    public function setAvatarManager($avatarManager)
    {
        $this->avatarManager = $avatarManager;
    }
    /**
     * @param IriConverterInterface $iriConverter
     */
    public function setIriConverter($iriConverter)
    {
        $this->iriConverter = $iriConverter;
    }
}
