<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ActorsBundle\Tests\Functional\ActorImplementation\CurrentActor;


use Cybersponse\TestBundle\Functional\ApiTestCase;

class ReadCurrentActorTest extends ApiTestCase
{
    protected function setUp()
    {
        parent::setUp();
        $this->requestVerb = 'GET';
        $this->requestUri = '/api/3/actors/current';
    }

    public function test_ShouldReturn200()
    {
        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $this->assertEquals(200, $response->getStatusCode());
    }

    public function test_ShouldReturnIriInId()
    {
        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $this->assertEquals($deserializedContent['@id'], '/api/3/mock_actors/608c6815-9300-44c8-9d7d-28dc97ded44e');
    }

    public function test_ShouldReturnSettings()
    {
        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $this->assertArrayHasKey('@settings', $deserializedContent);
    }

    public function test_ShouldReturnPermissions()
    {
        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $this->assertArrayHasKey('@permissions', $deserializedContent);
    }

    public function test_GivenRelationshipsTrue_ShouldReturnTeams()
    {
        $this->requestParameters = ['$relationships' => true];

        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $this->assertArrayHasKey('teams', $deserializedContent);
    }

    public function test_GivenRelationshipsTrue_ShouldReturnRoles()
    {
        $this->requestParameters = ['$relationships' => true];

        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $this->assertArrayHasKey('roles', $deserializedContent);
    }
}
