<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ActorsBundle\Tests\Functional\ActorImplementation\CurrentActor\SecurityPermissions;


use Cybersponse\TestBundle\Functional\ApiTestCase;

class WithoutSecurityUpdatePermissionTest extends ApiTestCase
{
    protected function setUp()
    {
        parent::setUp();
        $this->requestVerb = 'PUT';
        $this->requestUri = '/api/3/actors/current';
        $this->actor = $this->fixtures['ORM']['default']['mockActorApplicationUser'];
    }

    public function test_WhenRolesAreRemoved_ShouldReturn403()
    {
        $this->setJsonRequestContent([
            'requiredField' => 'asdf',
            'roles' => []
        ]);

        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $this->assertEquals(403, $response->getStatusCode());
    }

    public function test_WhenRolesAreAdded_ShouldReturn403()
    {
        $this->setJsonRequestContent([
            'requiredField' => 'asdf',
            'roles' => ['/api/3/roles/bce2bbcc-2d36-432e-8fb7-487d25c89235']
        ]);

        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $this->assertEquals(403, $response->getStatusCode());
    }

    public function test_WhenTeamsAreRemoved_ShouldReturn403()
    {
        $this->setJsonRequestContent([
            'requiredField' => 'asdf',
            'teams' => []
        ]);

        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $this->assertEquals(403, $response->getStatusCode());
    }

    public function test_WhenTeamsAreAdded_ShouldReturn403()
    {
        $this->setJsonRequestContent([
            'requiredField' => 'asdf',
            'teams' => ['/api/3/teams/131eb49b-7e6f-4313-a02b-a83c1ca0dde6']
        ]);

        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $this->assertEquals(403, $response->getStatusCode());
    }
}
