<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ActorsBundle\Tests\Functional\AvatarController;


use Cybersponse\ActorsBundle\Document\Avatar;
use Cybersponse\FilesBundle\Tests\Functional\FilesControllerTestCase;
use Symfony\Component\HttpFoundation\Response;

class AvatarListTest extends FilesControllerTestCase
{
    protected function setUp()
    {
        $this->modelType = 'avatars';
        $this->moduleType = 'application';
        $this->requestVerb = 'POST';
        $this->className = Avatar::class;
        $this->classShortName = 'Avatar';
        parent::setUp();
        $this->requestUri = '/api/3/avatars/current';

        $this->allowRead = true;
        $this->allowCreate = true;

        // Upload initial avatar for listing
        $this->executeSystemUnderTest();

        $this->requestUri = '/api/3/avatars';
        $this->requestVerb = 'GET';
    }

    /**
     * Tests api_avatars_cget
     * GET /api/3/avatars
     */
    public function test_GetAvatarList_GivenReadPermissions_ShouldReturn200()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_OK, $response->getStatusCode());
    }

    /**
     * Tests api_avatars_cget
     * GET /api/3/avatars
     */
    public function test_GetAvatarList_GivenOneAvatarUploaded_ShouldReturnOneItem()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $normalizedResponse = json_decode($response->getContent(), true);

        $this->assertCount(1, $normalizedResponse['hydra:member']);
    }
}
