<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ActorsBundle\Tests\Functional\AvatarController;


use Cybersponse\ActorsBundle\Document\Avatar;
use Cybersponse\FilesBundle\Tests\Functional\FilesControllerTestCase;
use Symfony\Component\HttpFoundation\Response;

class DownloadTest extends FilesControllerTestCase
{
    protected function setUp()
    {
        $this->modelType = 'avatars';
        $this->moduleType = 'application';
        $this->className = Avatar::class;
        $this->classShortName = 'Avatar';
        $this->requestVerb = 'POST';
        parent::setUp();
        $this->requestUri = '/api/3/avatars/current';
        $this->allowCreate = true;
        $this->allowRead = true;

        $this->executeSystemUnderTest();

        $response = $this->getResponse();
        $this->requestUri = $response->headers->get('Location');

        $this->requestVerb = 'GET';
    }

    /**
     * Tests api_avatars_cget
     * GET /api/3/avatars
     */
    public function test_GetAvatar_GivenReadPermissions_ShouldReturnAvatar()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_OK, $response->getStatusCode());
    }

    public function test_GetAvatar_GivenReadPermissions_ShouldReturnUploadedContent()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $content = $response->getContent();

        $this->assertEquals($this->fileContents, $content);
    }
}