<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ActorsBundle\Tests\Functional\AvatarController;


use Cybersponse\ActorsBundle\Document\Avatar;
use Cybersponse\FilesBundle\Tests\Functional\FilesControllerTestCase;
use Symfony\Component\HttpFoundation\Response;

class UploadCurrentAvatarTest extends FilesControllerTestCase
{
    protected function setUp()
    {
        $this->modelType = 'avatars';
        $this->moduleType = 'application';
        $this->className = Avatar::class;
        $this->classShortName = 'Avatar';
        $this->requestVerb = 'POST';
        $this->allowCreate = true;
        parent::setUp();
        $this->requestUri = '/api/3/avatars/current';
    }

    /**
     * Tests cybersponse_actors_avatar_download_current
     * POST /api/3/avatars/current
     */
    public function test_PostCurrentAvatar_GivenCreatePermissions_ShouldUploadAvatar()
    {
        $this->requestVerb = 'POST';
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_CREATED, $response->getStatusCode());
    }
}
