<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\AuthenticationBundle\Jwt;


use Lexik\Bundle\JWTAuthenticationBundle\Encoder\JWTEncoder;
use Symfony\Component\DependencyInjection\ContainerInterface;

class CorrectJwtEncoder extends JWTEncoder
{

    /** @var ContainerInterface */
    protected $container;

    /**
     * {@inheritdoc}
     */
    public function decode($token)
    {
        try {
            $jws = CorrectSimpleJWS::load($token);
        } catch (\InvalidArgumentException $e) {
            return false;
        }

        if ($jws instanceof CorrectSimpleJWS && !$jws->isValid($this->getPublicKey(), parent::ALGORYTHM)) {
            return false;
        }

        if ($this->isLogout($token)) {
            return false;
        }

        return $jws->getPayload();
    }

    /**
     *
     */
    protected function getPublicKey()
    {
        while (!empty($errorStr = openssl_error_string())) {
        }
        $pkey = $this->keyLoader->loadKey("public");
        while (!empty($errorStr = openssl_error_string())) {
        }
        return $pkey;
    }

    /**
     * @param ContainerInterface $container
     */
    public function setContainer($container)
    {
        $this->container = $container;
    }

    /**
     * @param string $jwtKey
     * @return bool
     */
    private function isLogout($jwtKey)
    {
        if ($this->container == null) {
            return false;
        }
        $jwtLogoutProvider = $this->container->get('cybersponse.proxy.das_jwt_logout_key_provider');
        return $jwtLogoutProvider->isJwtLogoutKey("Bearer " . $jwtKey);
    }
}
