<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\AuthorizationBundle\Controller;


use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;

class PermissionsController extends Controller
{
    public function listAction()
    {
        $permissionsProvider = $this->container->get('cybersponse.authorization.permissions.permissions_dictionary_provider');
        $permissionsDictionary = $permissionsProvider->getDataForCurrentUser();

        return JsonResponse::create($permissionsDictionary);
    }

    /**
     * @param string $moduleName
     * @param string $action
     * @return JsonResponse
     */
    public function getAction($module, $action)
    {
        $authorizationChecker = $this->container->get('security.authorization_checker');
        if (!$authorizationChecker->isGranted($this->buildPermission($module, $action))) {
            return JsonResponse::create(false);
        }
        return JsonResponse::create(true);
    }

    /**
     * @param string $moduleName
     * @param string $action
     * @return string
     */
    private function buildPermission($moduleName, $action)
    {
        return sprintf('perm:%s.%s', $moduleName, $action);
    }
}