<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\AuthorizationBundle\Entity;

use Cybersponse\CoreBundle\Entity\BaseEntity;
use Doctrine\ORM\Mapping as ORM;

/**
 * FieldPermission
 *
 * @Doctrine\ORM\Mapping\Table(name="field_permissions")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="field_permissions")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="security")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\DisplayName\DisplayName(displayName="{{ field }} {{ {true: '+', false: '-'}[canRead] }}R/{{ {true: '+', false: '-'}[canWrite] }}W")
 */
class FieldPermission extends BaseEntity
{
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="field", type="string", nullable=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="text")
     */
    protected $field;

    /**
     * @var boolean
     *
     * @Doctrine\ORM\Mapping\Column(name="canRead", type="boolean", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="checkbox")
     */
    protected $canRead;

    /**
     * @var boolean
     *
     * @Doctrine\ORM\Mapping\Column(name="canWrite", type="boolean", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="checkbox")
     */
    protected $canWrite;


    /**
     * Set field
     *
     * @param string $field
     * @return FieldPermission
     */
    public function setField($field)
    {
        $this->field = $field;

        return $this;
    }

    /**
     * Get field
     *
     * @return string
     */
    public function getField()
    {
        return $this->field;
    }

    /**
     * Set canRead
     *
     * @param boolean $canRead
     * @return FieldPermission
     */
    public function setCanRead($canRead)
    {
        $this->canRead = $canRead;

        return $this;
    }

    /**
     * Get canRead
     *
     * @return boolean
     */
    public function getCanRead()
    {
        return $this->canRead;
    }

    /**
     * Set canWrite
     *
     * @param boolean $canWrite
     * @return FieldPermission
     */
    public function setCanWrite($canWrite)
    {
        $this->canWrite = $canWrite;

        return $this;
    }

    /**
     * Get canWrite
     *
     * @return boolean
     */
    public function getCanWrite()
    {
        return $this->canWrite;
    }
}
