<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\AuthorizationBundle\Serialization;


use Cybersponse\AuthorizationBundle\Entity\Team;
use Cybersponse\CoreBundle\Serializer\EfficientItemNormalizer;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\Serializer\Serializer;

class TeamNormalizer extends EfficientItemNormalizer
{
    const FORMAT_JSON_LD = 'json-ld';

    /** @var Serializer */
    protected $serializer;

    /** @var ResourceInterface */
    protected $teamResource;

    /**
     * {@inheritdoc}
     */
    public function supportsNormalization($data, $format = null)
    {
        return self::FORMAT_JSON_LD === $format && $data instanceof Team;
    }

    /**
     * {@inheritdoc}
     */
    public function normalize($object, $format = null, array $context = [])
    {
        $context['ignore_depth'] = false;

        $normalizationContext = $this->teamResource->getNormalizationContext();

        return parent::normalize(
            $object,
            $format,
            $context + $normalizationContext
        );
    }

    /**
     * @param ResourceInterface $teamResource
     */
    public function setTeamResource($teamResource)
    {
        $this->teamResource = $teamResource;
    }
}
