<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\AuthorizationBundle\Traits;

use Cybersponse\AuthorizationBundle\Entity\Tag;
use Doctrine\Common\Collections\Collection;

trait Taggable
{
    /**
     * @var RecordTag[]|Collection
     *
     * @Doctrine\ORM\Mapping\ManyToMany(targetEntity="Cybersponse\AuthorizationBundle\Entity\Tag", cascade={"persist"})
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Tags")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="tags")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="tags")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Tooltip\Tooltip(tooltip="Special characters # ? , ' '' and / are not allowed in tag.")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $recordTags;

    /**
     * Add Label
     *
     * @param recordTag $recordTag
     * @return self
     */
    public function addRecordTag($recordTag)
    {
        if (is_array($this->recordTags) && empty($this->recordTags)) {
            unset($this->recordTags);
            $this->recordTags = [];
        }
        if (!empty($this->recordTags)) {
            if (!in_array($recordTag, $this->recordTags)) {
                $this->recordTags[] = $recordTag;
            }
        } else {
            $this->recordTags[] = $recordTag;
        }
        return $this;
    }

    /**
     * Remove recordTag
     *
     * @param recordTag $recordTag
     */
    public function removeRecordTag($recordTag)
    {
        if (is_array($this->recordTags) && ($key = array_search($recordTag, $this->recordTags)) !== false) {
            unset($this->recordTags[$key]);
            return;
        }
        $this->recordTags->removeElement($recordTag);
    }

    /**
     * Get recordTags
     *
     * @return RecordTag[]
     */
    public function getRecordTags()
    {
        return $this->recordTags;
    }
}
