<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\AuthorizationBundle\Voters;


use Symfony\Component\Security\Core\Authentication\Token\TokenInterface;
use Symfony\Component\Security\Core\Authorization\Voter\VoterInterface;

class UserManagementVoter implements VoterInterface
{
    /**
     * Ownership has
     * @inheritdoc
     */
    public function supportsAttribute($attribute)
    {
        return true;
    }

    /**
     * @inheritdoc
     */
    public function supportsClass($class)
    {
        return true;
    }

    /**
     * @inheritdoc
     */
    public function vote(TokenInterface $token, $object, array $attributes)
    {
        if (!array_key_exists('given_uuid', $attributes)) {
            return VoterInterface::ACCESS_ABSTAIN;
        }

        if (is_null($token)) {
            return VoterInterface::ACCESS_DENIED;
        }

        return $token->getUsername() == $attributes['given_uuid'] ? VoterInterface::ACCESS_GRANTED : VoterInterface::ACCESS_DENIED;
    }
}
