<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Api\Bulk;


class BulkApiResults
{
    const PERSISTED_COLLECTION_NAME = 'persisted';
    const FAILED_COLLECTION_NAME = 'failed';

    /** @var BulkManagerError[] */
    protected $failed = [];

    /** @var array */
    protected $persisted = [];

    /**
     * @return BulkManagerError[]
     */
    public function getFailed()
    {
        return $this->failed;
    }

    /**
     * @param BulkManagerError $failed
     */
    public function addFailed($failed)
    {
        $this->failed[] = $failed;
    }

    /**
     * @return array
     */
    public function getPersisted()
    {
        return $this->persisted;
    }

    /**
     * @param array $persisted
     */
    public function addPersisted($persisted)
    {
        $this->persisted += $persisted;
    }
}
