<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Controller;


use Cybersponse\CoreBundle\Service\ContextBuilder;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

class ContextController extends AuthorizationResourceController
{
    /**
     * Get the context for given entity name
     *
     * @return Response
     */
    public function entityContextAction($entityName)
    {
        /** @var ContextBuilder $contextBuilder */
        $contextBuilder = $this->get('cybersponse.core.service.context_builder');

        $context = $contextBuilder->getContext($entityName);

        if (is_null($context)) {
            throw new NotFoundHttpException();
        }

        return JsonResponse::create($context);
    }

    /**
     * Gets all the contexts
     *
     * @return Response
     */
    public function contextAction()
    {
        /** @var ContextBuilder $contextBuilder */
        $contextBuilder = $this->get('cybersponse.core.service.context_builder');

        return JsonResponse::create($contextBuilder->getContexts());
    }
}
