<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Controller;


use Cybersponse\CoreBundle\Service\ApiDocumentationBuilder;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

class HydraController extends Controller
{
    /**
     * Namespace of types specific to the current API.
     *
     * @return Response
     */
    public function entityDocAction($entityName)
    {
        /** @var ApiDocumentationBuilder $apiDocumentationBuilder */
        $apiDocumentationBuilder = $this->get('cybersponse.core.hydra.documentation_builder');

        $doc = $apiDocumentationBuilder->getApiDocumentationForEntity($entityName);

        if (is_null($doc)) {
            throw new NotFoundHttpException();
        }

        return JsonResponse::create($doc);
    }

    /**
     * Namespace of types specific to the current API.
     *
     * @return Response
     */
    public function docAction()
    {
        /** @var ApiDocumentationBuilder $apiDocumentationBuilder */
        $apiDocumentationBuilder = $this->get('cybersponse.core.hydra.documentation_builder');

        return JsonResponse::create($apiDocumentationBuilder->getApiDocumentation());
    }
}
