<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle;

use Cybersponse\CoreBundle\DependencyInjection\DunglasApiMetadataCompilerPass;
use Cybersponse\CoreBundle\DependencyInjection\DunglasAuthorizationCompilerPass;
use Cybersponse\CoreBundle\DependencyInjection\ChangeSecretKeyAESCompiler;
use Symfony\Component\DependencyInjection\Compiler\PassConfig;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\HttpKernel\Bundle\Bundle;

class CybersponseCoreBundle extends Bundle
{
    public function build(ContainerBuilder $container)
    {
        parent::build($container);
        $container->addCompilerPass(new ChangeSecretKeyAESCompiler());
        $container->addCompilerPass(new DunglasApiMetadataCompilerPass());
        $container->addCompilerPass(new DunglasAuthorizationCompilerPass(), PassConfig::TYPE_OPTIMIZE);
    }
}
