<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\DataFixtures\Faker\Provider;


use Cybersponse\CoreBundle\Entity\Picklist;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Query;
use Doctrine\ORM\Query\Expr\Join;

class PicklistProvider
{
    /** @var EntityRepository */
    protected static $picklistRepository;

    /** @var array */
    protected static $reducedPicklists = [];

    /**
     * @param $listName
     * @return mixed
     */
    public static function randomPicklistValue($listName)
    {
        if (!array_key_exists($listName, self::$reducedPicklists)) {
            self::$reducedPicklists[$listName] = self::getPicklistIds($listName);
        }

        $value = self::$reducedPicklists[$listName];

        return array_rand($value);
    }

    /**
     * @param EntityRepository $picklistRepository
     */
    public static function setPicklistRepository($picklistRepository)
    {
        self::$picklistRepository = $picklistRepository;
    }

    /**
     * @param $listName
     * @return array
     */
    private static function getPicklistIds($listName)
    {
        $query = self::$picklistRepository->createQueryBuilder('pl')
            ->select('pl.uuid')
            ->innerJoin('pl.listName', 'pln', Join::WITH, 'pln.name = :listName')
            ->setParameter('listName', $listName)
            ->getQuery();

        /** @var Picklist[] $picklists */
        $picklists = $query->getResult();
        $reducedPicklists = array_flip(array_map(function ($element) {
            return $element['uuid'];
        }, $picklists));
        return $reducedPicklists;
    }
}
