<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

use Symfony\Component\Yaml\Yaml;

function startsWith($haystack, $needle)
{
    $length = strlen($needle);
    return (substr($haystack, 0, $length) === $needle);
}

function endsWith($haystack, $needle)
{
    $length = strlen($needle);
    if ($length == 0) {
        return true;
    }

    return (substr($haystack, -$length) === $needle);
}

function decrypt($password)
{
    #Decrypt DB password
    $command = sprintf("python3.6 /opt/cyops/configs/scripts/manage_passwords.py --decrypt '" . $password . "' 'jQp3(7@jod#j38d1'");
    exec($command, $output, $errorCode);
    if (!$errorCode) {
        $output = $output[0];
        if (!startswith($output, 'Password:')) {
            throw new Exception('DB Password decrypt failed with error %s' % $output);
        } else {
            $password = substr($output, strlen('Password:'), strlen($output));
        }
    }
    return $password;
}

$ymlParsedFile = Yaml::parse(file_get_contents('/opt/cyops/configs/database/db_config.yml'));

$postgresHost     = isset($ymlParsedFile['postgres']['pg_host']) ? $ymlParsedFile['postgres']['pg_host'] : '127.0.0.1';
$postgresPort     = isset($ymlParsedFile['postgres']['pg_port']) ? $ymlParsedFile['postgres']['pg_port'] : '5432';
$postgresUsername = isset($ymlParsedFile['postgres']['pg_user']) ? $ymlParsedFile['postgres']['pg_user'] : 'cyberpgsql';
$postgresPassword = $ymlParsedFile['postgres']['pg_password'];
$redisPassword     = isset($ymlParsedFile['redis']['redis_password']) ? $ymlParsedFile['redis']['redis_password'] : 'demo123';
$postgresPassword = decrypt($postgresPassword);
$redisPassword = decrypt($redisPassword);

$container->setParameter('pg_host', $postgresHost);
$container->setParameter('pg_port', $postgresPort);
$container->setParameter('pg_user', $postgresUsername);
$container->setParameter('pg_password', base64_encode($postgresPassword));
$container->setParameter('redis_password', $redisPassword);

try {
    $versionJsonFile = file_get_contents('/opt/cyops-api/web/version.json');
    $versionContent = json_decode($versionJsonFile, true);
    $version = explode('-', $versionContent['version'])[0];
    $container->setParameter('product_version', $version);
} catch (\Exception $e) {
    $container->setParameter('product_version', 'dev');
}
