<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\DependencyInjection;


use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration
 * from your app/config files Configuration
 */
class Configuration implements ConfigurationInterface
{
    const NAMESPACE_TYPE = 'namespace';
    const CLASS_TYPE = 'class';

    /**
     * {@inheritDoc}
     *
     * @return TreeBuilder
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('cybersponse_core');

        $rootNode
            ->children()
            ->arrayNode('api')
            ->isRequired()
            ->requiresAtLeastOneElement()
            ->prototype('array')
            ->children()
            ->scalarNode('type')->defaultValue(self::NAMESPACE_TYPE)->end()
            ->scalarNode('path')->isRequired()->end()
            ->scalarNode('parent')->defaultValue(null)->end()
            ->scalarNode('driver')->defaultValue('orm')->end()
            ->scalarNode('index')->defaultValue(null)->end()
            ->scalarNode('customTransformerService')->defaultValue(null)->end()
            ->end()
            ->end()
            ->end()
            ->end();

        // Here you should define the parameters that are allowed to
        // configure your bundle. See the documentation linked above for
        // more information on that topic.

        return $treeBuilder;
    }
}
