<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Entity;

use Cybersponse\CoreBundle\Traits\Indexable;
use Doctrine\ORM\Mapping as ORM;

/**
 * Picklist
 *
 * @ORM\Table(name="picklists")
 * @ORM\Entity
 * @ORM\Cache(usage="NONSTRICT_READ_WRITE", region="region_picklists")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="picklists")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="application")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\DisplayName\DisplayName(displayName="{{ itemValue }}")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\DefaultSort\DefaultSort(defaultSort={{"field":"orderIndex","direction":"asc"}})
 */
class Picklist extends BaseEntity
{
    use Indexable;

    /**
     * @var string
     *
     * @ORM\ManyToOne(targetEntity="PicklistNames", cascade={"persist"}, inversedBy="picklists")
     * @ORM\JoinColumn(name="listName", referencedColumnName="uuid")
     */
    private $listName;

    /**
     * @var string
     *
     * @ORM\Column(name="itemValue", type="string", nullable=true)
     */
    private $itemValue;

    /**
     * @var integer
     *
     * @ORM\Column(name="orderIndex", type="integer", nullable=true)
     */
    private $orderIndex;

    /**
     * @var string
     *
     * @ORM\Column(name="color", type="string", nullable=true)
     */
    private $color;

    /**
     * @var string
     *
     * @ORM\Column(name="icon", type="string", nullable=true)
     */
    private $icon;

    /**
     * Set itemValue
     *
     * @param string $itemValue
     * @return Picklist
     */
    public function setItemValue($itemValue)
    {
        $this->itemValue = $itemValue;

        return $this;
    }

    /**
     * Get itemValue
     *
     * @return string
     */
    public function getItemValue()
    {
        return $this->itemValue;
    }

    /**
     * Set orderIndex
     *
     * @param integer $orderIndex
     * @return Picklist
     */
    public function setOrderIndex($orderIndex)
    {
        $this->orderIndex = $orderIndex;

        return $this;
    }

    /**
     * Get orderIndex
     *
     * @return integer
     */
    public function getOrderIndex()
    {
        return $this->orderIndex;
    }

    /**
     * Set color
     *
     * @param string $color
     * @return Picklist
     */
    public function setColor($color)
    {
        $this->color = $color;

        return $this;
    }

    /**
     * Get color
     *
     * @return string
     */
    public function getColor()
    {
        return $this->color;
    }

    /**
     * Set icon
     *
     * @param string $icon
     * @return Picklist
     */
    public function setIcon($icon)
    {
        $this->icon = $icon;

        return $this;
    }

    /**
     * Get icon
     *
     * @return string
     */
    public function getIcon()
    {
        return $this->icon;
    }

    /**
     * Set listName
     *
     * @param \Cybersponse\CoreBundle\Entity\PicklistNames $listName
     * @return Picklist
     */
    public function setListName(\Cybersponse\CoreBundle\Entity\PicklistNames $listName = null)
    {
        $this->listName = $listName;

        return $this;
    }

    /**
     * Get listName
     *
     * @return \Cybersponse\CoreBundle\Entity\PicklistNames
     */
    public function getListName()
    {
        return $this->listName;
    }
}
