<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\CoreBundle\Entity;
use Doctrine\ORM\Mapping as ORM;
/**
 * Proxy
 *
 * @Doctrine\ORM\Mapping\Table(name="cyops.proxy", schema="cyops")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="proxy")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="security")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\DisplayName\DisplayName(displayName="{{ uuid }}")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="proxy",plural="proxies")
 */
class Proxy extends \Cybersponse\CoreBundle\Entity\BaseEntity
{
    /**
     * @var boolean
     *
     * @Doctrine\ORM\Mapping\Column(name="`toggle`", type="boolean", length=10485761, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Searchable\Searchable()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\GridColumn\GridColumn()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Toggle")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DefaultValue\DefaultValue(defaultValue="1")
     */
    protected $toggle;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`proxies`", type="string", length=4096, nullable=true, unique=false)
     * @Ambta\DoctrineEncryptBundle\Configuration\Encrypted()
     * @Symfony\Component\Validator\Constraints\NotBlank()
     * @Symfony\Component\Validator\Constraints\NotNull()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Proxies")
     */
    protected $proxies;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`noproxy`", type="json_array", nullable=true, unique=false)
     * @Symfony\Component\Validator\Constraints\NotBlank()
     * @Symfony\Component\Validator\Constraints\NotNull()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="No Proxy")
     */
    protected $noProxy;
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`other`", type="json_array", nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Other")
     */
    protected $other;
    /**
     * @return string
     */
    public function getProxies()
    {
        return $this->proxies;
    }
    /**
     * @param string $proxies
     */
    public function setProxies($proxies)
    {
        $this->proxies = $proxies;
    }
    /**
     * @return string
     */
    public function getNoProxy()
    {
        return $this->noProxy;
    }
    /**
     * @param string $noProxy
     */
    public function setNoProxy($noProxy)
    {
        $this->noProxy = $noProxy;
    }
    /**
     * @return string
     */
    public function getOther()
    {
        return $this->other;
    }
    /**
     * @param string $other
     */
    public function setOther($other)
    {
        $this->other = $other;
    }
    /**
     * Get toggle
     *
     * @return boolean
     */
    public function getToggle()
    {
        return $this->toggle;
    }
    /**
     * Set toggle
     *
     * @param boolean $toggle
     *
     * @return Proxy
     */
    public function setToggle($toggle)
    {
        $this->toggle = $toggle;
        return $this;
    }
}
