<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Listener;


use Doctrine\DBAL\DBALException;
use Symfony\Component\HttpKernel\Event\GetResponseForExceptionEvent;
use Symfony\Component\HttpKernel\EventListener\ExceptionListener;
use Symfony\Component\HttpKernel\Exception\ConflictHttpException;

class ConstraintViolationExceptionListener extends ExceptionListener
{
    const MIN_MAX_CONSTRAINT_VIOLATION = 22001;

    public function onKernelException(GetResponseForExceptionEvent $event)
    {
        $exception = $event->getException();

        if ($exception instanceof DBALException) {
            $previous = $exception->getPrevious();
            if ($previous->getCode() == self::MIN_MAX_CONSTRAINT_VIOLATION) {
                $event->setException(new ConflictHttpException($previous->getMessage(), $exception));
                parent::onKernelException($event);
            }
        }
    }
}
