<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Listener;

use Dunglas\ApiBundle\JsonLd\Event\ContextBuilderEvent;
use Symfony\Component\Routing\RouterInterface;

class ContextBuilderListener
{
    /** @var RouterInterface */
    protected $router;

    /**
     * @param RouterInterface $router
     */
    public function setRouter($router)
    {
        $this->router = $router;
    }

    /**
     * @param ContextBuilderEvent $event
     */
    public function onContextEvent(ContextBuilderEvent $event)
    {
        $context = $event->getContext();
        $resource = $event->getResource();

        if (!is_null($resource)) {
            $context['@resourceVocab'] = $this->router->generate('api_hydra_vocab', [], RouterInterface::ABSOLUTE_URL) . '/' . $resource->getShortName();
        }

        $event->setContext($context);
    }
}
