<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Provider;


use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;
use Symfony\Component\Security\Core\Authentication\Token\TokenInterface;

abstract class ActorDataProvider implements ActorDataProviderInterface
{
    /** @var TokenStorageInterface */
    protected $tokenStorage;

    /**
     * @inheritdoc
     */
    public function getDataForToken(TokenInterface $token)
    {
        $user = $token->getUser();
        return $this->getDataForActor($user);
    }

    /**
     * @inheritdoc
     */
    public function getDataForCurrentUser()
    {
        $token = $this->tokenStorage->getToken();
        return $this->getDataForToken($token);
    }

    /**
     * @param TokenStorageInterface $tokenStorage
     */
    public function setTokenStorage($tokenStorage)
    {
        $this->tokenStorage = $tokenStorage;
    }
}
