<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Provider;

use \Doctrine\Common\Cache\RedisCache;

class Cacheable extends RedisCache implements CacheableInterface
{
    /**
     * @var \Predis\Client|\Redis
     */
    protected $deletesCacheProvider;

    /**
     * @param \Predis\Client|\Redis $deletesCacheProvider
     */
    public function setDeletesCacheProvider($deletesCacheProvider)
    {
        $this->deletesCacheProvider = $deletesCacheProvider;
    }

    /**
     * @param string $cacheKey
     * @return int
     * @throws \Exception
     */
    public function cacheContains($cacheKey)
    {
        return $this->doContains($cacheKey);
    }

    /**
     * @param string $cacheKey
     * @return bool|false|mixed
     * @throws \Exception
     */
    public function getFromCache($cacheKey)
    {
        return $this->doFetch($cacheKey);
    }

    /**
     * @param string $cacheKey
     * @param mixed $value
     * @param int $lifeTime
     * @throws \Exception
     */
    public function persistToCache($cacheKey, $value, $lifeTime = 0)
    {
        $this->doSave($cacheKey, $value, $lifeTime);
    }

    /**
     * @param string $cacheKey
     * @throws \Exception
     */
    public function deleteFromCache($cacheKey)
    {
        $this->doDelete($cacheKey);
    }

    /**
     * @throws \Exception
     */
    public function clearCache()
    {
        $allKeysToClear = $this->getRedis()->keys('*');
        foreach ($allKeysToClear as $cacheKey) {
            $this->deletesCacheProvider->del($cacheKey);
        }
    }
}
