<?php
/* Copyright start
 Copyright (C) 2008 - 2020 Fortinet Inc.
 All rights reserved.
 FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
 Copyright end */

/**
 * Created by PhpStorm.
 * User: Alok-Agarwal
 * Date: 3/23/18
 * Time: 4:18 PM
 */

namespace Cybersponse\CoreBundle\Provider;

use Cybersponse\CoreBundle\Entity\Proxy;
use Cybersponse\CoreBundle\Provider\CacheableInterface;

/**
 * Data provider for the Proxy document.
 */
class ProxyProvider
{
    /** @var ProxyClient */
    protected $proxyClient;
    /** @var DasClient */
    protected $dasClient;
    /** @var $integrationsClient */
    protected $integrationClient;
    /** @var ProxyClient $crudhubClient */
    protected $crudhubClient;
    /** @var gatewayClient $crudhubClient */
    protected $gatewayClient;
    /** @var CacheableInterface */
    protected $cache;
    /** @var int */
    protected $cacheLifetime = 300;
    /**
     * @param CacheableInterface $cache
     */
    public function setCache($cache)
    {
        $this->cache = $cache;
    }
    public function getCache()
    {
        return $this->cache;
    }
    /**
     * @param int $cacheLifetime
     */
    public function setCacheLifetime($cacheLifetime)
    {
        $this->cacheLifetime = $cacheLifetime;
    }
    public function getCacheLifetime()
    {
        return $this->cacheLifetime;
    }
    /**
     * @param $dasClient
     */
    public function setDasClient($dasClient)
    {
        $this->dasClient = $dasClient;
    }
    /**
     * @return DasClient
     */
    public function getDasClient()
    {
        return $this->dasClient;
    }
    /**
     * @param ProxyClient $proxyClient
     */
    public function setProxyClient($proxyClient)
    {
        $this->proxyClient = $proxyClient;
    }
    /**
     * @return ProxyClient
     */
    public function getProxyClient()
    {
        return $this->proxyClient;
    }
    /**
     * @param $integrationClient
     */
    public function setIntegrationClient($integrationClient)
    {
        $this->integrationClient = $integrationClient;
    }
    /**
     * @return integrationClient
     */
    public function getIntegrationClient()
    {
        return $this->integrationClient;
    }
    /**
     * Get the value of gatewayClient
     */
    public function getGatewayClient()
    {
        return $this->gatewayClient;
    }
    /**
     * Set the value of gatewayClient
     *
     * @return self
     */
    public function setgatewayClient($gatewayClient)
    {
        $this->gatewayClient = $gatewayClient;
        return $this;
    }
    /**
     * Get the value of crudhubClient
     */
    public function getCrudhubClient()
    {
        return $this->crudhubClient;
    }
    /**
     * Set the value of crudhubClient
     *
     * @return self
     */
    public function setCrudhubClient($crudhubClient)
    {
        $this->crudhubClient = $crudhubClient;
        return $this;
    }
}
