<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Serializer;


use Cybersponse\CoreBundle\Api\Bulk\BulkManagerError;
use Symfony\Component\Serializer\Normalizer\NormalizerInterface;
use Symfony\Component\Serializer\Normalizer\SerializerAwareNormalizer;

class BulkManagerErrorNormalizer extends SerializerAwareNormalizer implements NormalizerInterface
{
    public function supportsNormalization($data, $format = null)
    {
        return 'json-ld' === $format && $data instanceof BulkManagerError;
    }

    /**
     * @inheritdoc
     * @param BulkManagerError $object
     */
    public function normalize($object, $format = null, array $context = [])
    {
        $result = [];

        $result['error'] = $this->serializer->normalize($object->getError(), 'hydra-error');
        if (count($object->getObjects()) > 0) {
            $normalizedObjects = [];
            foreach ($object->getObjects() as $failedObject) {
                $normalizedObjects[] = $failedObject;
            }
            $result['objects'] = $normalizedObjects;
        }

        return $result;
    }
}
