<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Service;

use Cybersponse\CoreBundle\Service\Config\ModuleConfig;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class ConfigPorter
 * @package Cybersponse\CoreBundle\Service
 */
abstract class ConfigPorter
{   
    /** @var array */
    protected $keys;

    /** @var ContainerInterface */
    protected $container;

    /**
     * @param ContainerInterface $container
     */
    public function setContainer($container)
    {
        $this->container = $container;
    }

    public function __construct() {
        $this->configTypes = [
            'appSettings' => 'cybersponse.core.service.app_settings_config',
            'picklistNames' => 'cybersponse.core.service.picklist_name_config',
            'reports' => 'cybersponse.core.service.report_config',
            'dashboards' => 'cybersponse.core.service.dashboard_config',
            'modules' => 'cybersponse.core.service.module_config',
            'viewTemplates' => 'cybersponse.core.service.view_config',
            'views' => 'cybersponse.core.service.view_config',
            'roles' => 'cybersponse.core.service.role_config',
            'playbooks' => 'cybersponse.core.service.playbook_config'
        ];
    }

}
