<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Service;

use Cybersponse\CoreBundle\Entity\ExportJob;
use Cybersponse\CoreBundle\Service\Config\PortingConfig;

/**
 * Class ExportService
 * @package Cybersponse\CoreBundle\Service
 */
class ExportService extends ConfigPorter
{
    /**
     * 
     *
     * @param array $fullConfig
     * @param ExportJob $exportJob
     * @return mixed
     */
    public function exportConfiguration(ExportJob $exportJob, $tokenType='JWT') {
        $options = $exportJob->getTemplate()->getOptions();
        $exportData = [];
        foreach ($this->configTypes as $key => $service) {
            $config = array_key_exists($key, $options) ? $options[$key] : [];
            /** @var PortingConfig $portingConfig */
            $portingConfig = $this->container->get($service);
            $exportData[$key] = $portingConfig->export($config, $tokenType);
        }
        
        // Added for backwards compatibility
        $exportData['includeMmd'] = true;
        return $exportData;
    }

    /**
     * 
     *
     * @param array $recordSet
     * @param ExportJob $exportJob
     * @return mixed
     */
    public function exportRecordSet(ExportJob $exportJob) {
        return true;
    }

}
