<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Service;

use Cybersponse\CoreBundle\Command\ImportJobCommand;
use Cybersponse\CoreBundle\Entity\ImportJob;
use Cybersponse\CoreBundle\Service\Config\PortingConfig;

/**
 * Class ImportService
 * @package Cybersponse\CoreBundle\Service
 */
class ImportService extends ConfigPorter
{
    /**
     * 
     *
     * @param array $config
     * @return array
     */
    public function importConfiguration(array $fullData, ImportJob $importJob, ImportJobCommand $importJobCommand, $tokenType='JWT') {
        $options = $importJob->getOptions();
        foreach ($this->configTypes as $key => $service) {
            $data = array_key_exists($key, $fullData) ? $fullData[$key] : [];
            $individualOptions = array_key_exists($key, $options) ? $options[$key] : [];
            if (count($data) == 0 || !$individualOptions['include']) {
                continue;
            }
            /** @var PortingConfig $portingConfig */
            $portingConfig = $this->container->get($service);
            $importJobCommand->updateImportJob($importJob, null, null, null, null, $key);
            $success = $portingConfig->import($data, $individualOptions['values'], $tokenType);
            if (!$success) {
                return [
                    "success" => false
                ];
            }
        }

        return [
            "success" => true
        ];
    }
    
    /**
     * 
     *
     * @param array $config
     * @return array
     */
    public function importRecordSet(array $recordSet, ImportJob $importJob) {
        var_dump(array_column($recordSet, 'Name'));
        return true;
    }

}
