<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Service;


use Doctrine\Common\Annotations\AnnotationReader;
use Symfony\Component\Serializer\Mapping\Factory\ClassMetadataFactory;
use Symfony\Component\Serializer\Mapping\Loader\AnnotationLoader;
use Symfony\Component\Serializer\Mapping\Loader\LoaderChain;
use Symfony\Component\Serializer\Normalizer\PropertyNormalizer;

class PropertyNormalizerFactory
{

    /**
     * @param $clientName
     * @param $projectRootDirectory
     * @return PropertyNormalizer
     */
    public static function createPropertyNormalizer($clientName, $projectRootDirectory)
    {
        
        $annotationLoader = new AnnotationLoader(new AnnotationReader());
        $loaders = [$annotationLoader];
        $loaderChain = new LoaderChain($loaders);
        $classMetadataFactory = new ClassMetadataFactory($loaderChain);

        return $classMetadataFactory;
    }
}
