<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Tests\Functional\AuthorizationResourceController\ResolvedInversedFieldImplementation;


use Cybersponse\TestBundle\Functional\ApiTestCase;

class GetFieldTest extends ApiTestCase
{
    const MOCK_Z_ENTITY_UUID = '041e5e6f-f28a-40da-9606-53721fb96b3f';

    const MOCK_A_ENTITY_UUID = 'e71b7c08-d6eb-4d17-92ac-001c60a550dd';

    protected function setUp()
    {
        parent::setUp();
        $this->requestVerb = 'GET';
    }

    public function getRequestUri()
    {
        return '/api/3/mock_a_entities';
    }

    public function test_GivenInvalidPermissions_ShouldReturn403()
    {
        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $this->assertEquals(403, $response->getStatusCode());
    }

    public function test_GivenInvalidPermissions_ShouldReturnAccessDeniedHydraError()
    {
        $this->executeSystemUnderTest();

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $this->assertEquals($deserializedContent['hydra:description'], 'Access Denied.');
    }
}
