<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Tests\Functional\AuthorizationResourceController\ResolvedInversedFieldImplementation;


use Cybersponse\TestBundle\Functional\ApiTestCase;

class GetRelationFromOwningSideTest extends ApiTestCase
{
    const MOCK_M_ENTITY_UUID = 'e39b4db2-14d1-4755-8716-a0b11002f746';

    const MOCK_A_ENTITY_UUID = '539eb877-9c7b-4281-92a3-d6e271acf795';

    protected function setUp()
    {
        parent::setUp();
        $this->requestVerb = 'GET';
    }

    public function getRequestUri()
    {
        return sprintf('/api/3/mock_m_entities/%s/mockAEntities', static::MOCK_M_ENTITY_UUID);
    }

    public function test_GivenExistingFixture_ShouldReturnExpectedUUID()
    {
        $this->setRoles([
            $this->createModulePermission('mock_a_entities', false, true),
            $this->createModulePermission('mock_m_entities', false, true)
        ]);

        $this->executeSystemUnderTest();

        $expectedUuid = static::MOCK_A_ENTITY_UUID;

        $response = $this->client->getResponse();
        $deserializedContent = json_decode($response->getContent(), true);
        $expectedIri = sprintf('/api/3/mock_a_entities/%s', $expectedUuid);
        $this->assertEquals($deserializedContent['hydra:member'][0]['@id'], $expectedIri);
    }
}
