<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Tests\Functional\Controller;


use Cybersponse\TestBundle\Functional\ApiTestCase;

class ReportingControllerTest extends ApiTestCase
{
    protected function setUp()
    {
        parent::setUp();
        $this->requestUri = '/api/reports';
    }

    public function test_ReportingAuthorizationAction_GivenNoToken_ShouldReturn401()
    {
        $this->actor = null;
        $this->executeSystemUnderTest();

        $this->assertEquals(401, $this->client->getResponse()->getStatusCode());
    }

    public function test_ReportingAuthorizationAction_WithValidToken_ShouldReturn403()
    {
        $this->executeSystemUnderTest();

        $this->assertEquals(403, $this->client->getResponse()->getStatusCode());
    }

    public function test_ReportingAuthorizationAction_WithValidToken_WithValidPermissions_ShouldReturn200()
    {
        $this->setRoles([
            $this->createModulePermission('reporting', false, true)
        ]);

        $this->executeSystemUnderTest();

        $this->assertEquals(200, $this->client->getResponse()->getStatusCode());
    }
}
