<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Tests\Functional;


use Cybersponse\TestBundle\Functional\ApiTestCase;
use Symfony\Component\HttpFoundation\Response;

class HttpConflictTest extends ApiTestCase
{
    protected function setUp()
    {
        parent::setUp();
        $this->requestVerb = 'POST';
    }

    public function getRequestUri()
    {
        return '/api/3/mock_actors';
    }

    public function test_GivenPreExistingRecord_ShouldReturn409()
    {
        $this->setRoles([
            $this->createModulePermission('mock_actors', true)
        ]);

        $this->setJsonRequestContent([
            'userId' => '54321'
        ]);

        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_CONFLICT, $response->getStatusCode());
    }
}
