<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Traits;


use Cybersponse\TenantBundle\Entity\Prod\Tenant;


/**
 *
 */
trait PeerReplicable
{
    /**
     * @var Tenant
     *
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly\Readonly()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Searchable\Searchable()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="tenants", query=
     *     @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\Query(logic="AND", sort={{"field"="name", "direction"="ASC"}})
     * )
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Tenant")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\GridColumn\GridColumn()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="lookup")
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="Cybersponse\TenantBundle\Entity\Prod\Tenant", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="tenant", referencedColumnName="uuid", onDelete="CASCADE", columnDefinition="VARCHAR NOT NULL DEFAULT 'b3a700f7-00be-4ef9-90c6-3c8fe6e1be63'")
     * })
     */
    protected $tenant;

    /**
     * @var boolean
     *
     * @Doctrine\ORM\Mapping\Column(name="conflict", type="boolean", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="checkbox")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Visibility\Visibility(visibility=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DefaultValue\DefaultValue(defaultValue="0")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Conflict")
     */
    protected $conflict;

    /**
     * @var integer
     *
     * @ORM\Column(name="tenantrecordid", type="integer", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly\Readonly()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="integer")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Searchable\Searchable()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Tenant Record ID")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\GridColumn\GridColumn()
     */
    protected $tenantRecordId;

    /**
     * Get tenantRecordId
     *
     * @return integer
     */
    public function getTenantRecordId()
    {
        return $this->tenantRecordId;
    }

    /**
     * @param int $tenantRecordId
     */
    public function setTenantRecordId($tenantRecordId)
    {
        $this->tenantRecordId = $tenantRecordId;

        return $this;
    }

    /**
     * @return \Cybersponse\CustomerTenantBundle\Entity\Tenant
     */
    public function getTenant()
    {
        return $this->tenant;
    }

    /**
     * @param \Cybersponse\CustomerTenantBundle\Entity\Tenant
     * @return self
     */
    public function setTenant($tenant)
    {
        $this->tenant = $tenant;

        return $this;
    }

    /**
     * @return boolean
     */
    public function getConflict()
    {
        return $this->conflict;
    }

    /**
     * @param boolean $conflict
     */
    public function setConflict($conflict)
    {
        $this->conflict = $conflict;

        return $this;
    }

}
