<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\CoreBundle\Traits;


use Cybersponse\ActorsBundle\Entity\Actor;

/**
 *
 */
trait Trackable
{
    /**
     * @var Actor
     *
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly\Readonly()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="actors")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Created By")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="lookup")
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="Cybersponse\ActorsBundle\Entity\Actor", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="createuser", referencedColumnName="uuid", onDelete="SET NULL")
     * })
     */
    protected $createUser;

    /**
     * @var \DateTime
     *
     * @Doctrine\ORM\Mapping\Column(name="createdate", type="datetime", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="datetime")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly\Readonly()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Created On")
     */
    protected $createDate;

    /**
     * @var Actor
     *
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Modified By")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly\Readonly()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="actors")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="lookup")
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="Cybersponse\ActorsBundle\Entity\Actor", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="modifyuser", referencedColumnName="uuid", onDelete="SET NULL")
     * })
     */
    protected $modifyUser;

    /**
     * @var \DateTime
     *
     * @Doctrine\ORM\Mapping\Column(name="modifydate", type="datetime", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="datetime")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly\Readonly()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Modified On")
     */
    protected $modifyDate;

    /**
     * @return \Cybersponse\ActorsBundle\Entity\Actor
     */
    public function getCreateUser()
    {
        return $this->createUser;
    }

    /**
     * @param \Cybersponse\ActorsBundle\Entity\Actor $createUser

     * @return self
     */
    public function setCreateUser($createUser)
    {
        $this->createUser = $createUser;

        return $this;
    }

    /**
     * Set createDate
     *
     * @param \DateTime $createDate
     *
     * @return self
     */
    public function setCreateDate($createDate)
    {
        $this->createDate = $createDate;

        return $this;
    }

    /**
     * Get createDate
     *
     * @return \DateTime
     */
    public function getCreateDate()
    {
        return $this->createDate;
    }

    /**
     * @return \Cybersponse\ActorsBundle\Entity\Actor
     */
    public function getModifyUser()
    {
        return $this->modifyUser;
    }

    /**
     * @param $modifyUser
     * @return self
     */
    public function setModifyUser($modifyUser)
    {
        $this->modifyUser = $modifyUser;

        return $this;
    }

    /**
     * Set modifyDate
     *
     * @param \DateTime $modifyDate
     *
     * @return self
     */
    public function setModifyDate($modifyDate)
    {
        $this->modifyDate = $modifyDate;

        return $this;
    }

    /**
     * Get modifyDate
     *
     * @return \DateTime
     */
    public function getModifyDate()
    {
        return $this->modifyDate;
    }

}
