<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\FilesBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class ImagesController extends FilesController
{

    public function downloadAction(Request $request, $id)
    {
        $resource = $this->getResource($request);
        $request->attributes->set('id', $id);
        /** @var Avatar $avatar */
        $avatar = $this->findOrThrowNotFound($resource, $id);
        if (!$avatar) {
            throw $this->createNotFoundException();
        }
        return $this->getSuccessResponse($resource, $avatar, Response::HTTP_OK, [], ['include_file_data' => true]);
    }

    public function uploadAction(Request $request)
    {
        $imageObj = parent::uploadFile($request);
        $securityToken = $this->container->get('security.token_storage')->getToken();
        $iriConverter = $this->container->get('api.iri_converter');
        $userIri = $iriConverter->getIriFromItem($securityToken->getUser());
        $imageObj['uploadUser'] = $userIri;
        return $this->cpostAction($request, $imageObj);
    }
}
