<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\FilesBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Cybersponse\FilesBundle\Entity\AbstractFile;

/**
 * @ORM\Table(name="images")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="images")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="application")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="image",plural="images")
 */
class Image extends AbstractFile
{
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`uploadUser`", type="string", length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Upload User")
     */
    protected $uploadUser;

    /**
     * Set owner
     * @param string $uploadUser
     * @return self
     */
    public function setUploadUser($uploadUser)
    {
        $this->uploadUser = $uploadUser;
        return $this;
    }

    /**
     * Get owner
     *
     * @return string $owner
     */
    public function getUploadUser()
    {
        return $this->uploadUser;
    }
}