<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */
namespace Cybersponse\FilesBundle\Entity;

use Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readable\Readable;
use Doctrine\ORM\Mapping as ORM;
use Ramsey\Uuid\Uuid;

/**
 * @ORM\Table(name="pgfile")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="pgfile")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\DisplayName\DisplayName(displayName="Pg File")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="pgfile",plural="pgfiles")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Operations\Operations(create=false, update=false, delete=false)
 */
class PgFile
{

     /**
     * Constructor
     */
    public function __construct()
    {
        $this->uuid = Uuid::uuid4()->toString();
    }

    /**
     * @var file
     *
     * @Doctrine\ORM\Mapping\Column(name="`file`", type="blob", nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="File")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="pgfile")
     */
    protected $file;

    /**
     * @ORM\Id
     * @ORM\Column(name="uuid", type="string", length=150, nullable=false)
     */
    protected $uuid;

    /**
     * Set uuid
     *
     * @param integer $uuid
     * @return BaseEntity
     */
    public function setUuid()
    {
        $this->uuid = Uuid::uuid4()->toString();

        return $this;
    }

    /**
     * Get uuid
     *
     * @return integer
     */
    public function getUuid()
    {
        return $this->uuid;
    }

    /**
     * Set file
     *
     * @param \Symfony\Component\HttpFoundation\File\File $file
     * @return self
     */
    public function setFile($file)
    {
        $this->file = $file;
        return $this;
    }

    /**
     * Get file
     *
     * @return \Symfony\Component\HttpFoundation\File\File $file
     */
    public function getFile()
    {
        return $this->file;
    }

}
