<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\FilesBundle\Serializer;


use Cybersponse\CoreBundle\Serializer\EfficientItemNormalizer;
use Cybersponse\FilesBundle\Entity\Image;
use Symfony\Component\Serializer\Normalizer\NormalizerInterface;

class ImageNormalizer extends EfficientItemNormalizer implements NormalizerInterface
{
    /**
     * @inheritdoc
     */
    public function supportsNormalization($data, $format = null)
    {
        return self::FORMAT === $format && ($data instanceof Image);
    }

    /**
     * @param Image $image
     * @inheritdoc
     */
    public function normalize($image, $format = null, array $context = [])
    {
        $result = parent::normalize($image, $format, $context + [
            'include_file_data' => true
        ]);

        return $result;
    }
}
