<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\FilesBundle\Tests\Functional\FilesController;


use Cybersponse\FilesBundle\Document\File;
use Cybersponse\FilesBundle\Tests\Functional\FilesControllerTestCase;
use Symfony\Component\HttpFoundation\Response;

class FileListTest extends FilesControllerTestCase
{
    protected function setUp()
    {
        $this->modelType = 'files';
        $this->requestVerb = 'POST';
        $this->className = File::class;
        $this->classShortName = 'File';
        parent::setUp();

        $this->allowRead = true;
        $this->allowCreate = true;

        // Upload initial file for listing
        $this->executeSystemUnderTest();

        $this->requestVerb = 'GET';
    }

    public function test_GetFileList_GivenReadPermissions_ShouldReturn200()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_OK, $response->getStatusCode());
    }

    public function test_GetFileList_GivenOneFileUploaded_ShouldReturnOneItem()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $normalizedResponse = json_decode($response->getContent(), true);

        $this->assertCount(1, $normalizedResponse['hydra:member']);
    }
}
