<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\FilesBundle\Tests\Functional\ImageController;


use Cybersponse\FilesBundle\Document\Image;
use Cybersponse\FilesBundle\Tests\Functional\FilesControllerTestCase;
use Symfony\Component\HttpFoundation\Response;

class DownloadTest extends FilesControllerTestCase
{
    protected function setUp()
    {
        $this->modelType = 'images';
        $this->moduleType = 'application';
        $this->className = Image::class;
        $this->classShortName = 'Image';
        $this->requestVerb = 'POST';
        parent::setUp();

        $this->allowCreate = true;
        $this->allowRead = true;

        $this->executeSystemUnderTest();

        $response = $this->getResponse();
        $this->requestUri = $response->headers->get('Location');

        $this->requestVerb = 'GET';
    }

    public function test_GetImage_GivenReadPermissions_ShouldReturnImage()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_OK, $response->getStatusCode());
    }

    public function test_GetImage_GivenReadPermissions_ShouldReturnUploadedContent()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $content = $response->getContent();

        $this->assertEquals($this->fileContents, $content);
    }
}
