<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\FilesBundle\Tests\Functional\ImageController;


use Cybersponse\FilesBundle\Document\Image;
use Cybersponse\FilesBundle\Tests\Functional\FilesControllerTestCase;
use Symfony\Component\HttpFoundation\Response;

class ImageListTest extends FilesControllerTestCase
{
    protected function setUp()
    {
        $this->modelType = 'images';
        $this->moduleType = 'application';
        $this->requestVerb = 'POST';
        $this->className = Image::class;
        $this->classShortName = 'Image';
        parent::setUp();

        $this->allowRead = true;
        $this->allowCreate = true;

        // Upload initial image for listing
        $this->executeSystemUnderTest();

        $this->requestVerb = 'GET';
    }

    public function test_GetImageList_GivenReadPermissions_ShouldReturn200()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $this->assertEquals(Response::HTTP_OK, $response->getStatusCode());
    }

    public function test_GetImageList_GivenOneImageUploaded_ShouldReturnOneItem()
    {
        $this->executeSystemUnderTest();

        $response = $this->getResponse();

        $normalizedResponse = json_decode($response->getContent(), true);

        $this->assertCount(1, $normalizedResponse['hydra:member']);
    }
}
