<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Command;

use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

/**
 * Class DropModelMetaDataCopyCommand
 */
class DropModelMetaDataCopyCommand extends ContainerAwareCommand
{
    protected function configure()
    {
        $this
            ->setName('cybersponse:drop:metadata:copy')
            ->setDescription('Drop Model Meta Data and Attributes Metadata Copies');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $io = new SymfonyStyle($input, $output);

        $container = $this->getContainer();
        $metadataEntityManager = $container->get('doctrine.orm.entity_manager');

        $commandsToExecute = [
            "DROP TABLE IF EXISTS attrib_model_metadata_copy",
            "DROP TABLE IF EXISTS model_meta_copy",
        ];

        foreach ($commandsToExecute as $commandToExecute) {
            $metadataEntityDatabase = $metadataEntityManager->getConnection()->prepare($commandToExecute);
            try{
                $metadataEntityDatabase->execute();
            }catch(\Exception $e) {
                throw new \Exception('Failure: ' . $e);
            }
        }

        $io->success('Successfully Removed ModelMetaData Copy and Attribute Metadata Copy');
    }
}
