<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Filesystem\Filesystem;

class UnlockApiCommand extends ContainerAwareCommand
{

    protected function configure()
    {
        $this
            ->setName('cybersponse:publish:unlock')
            ->setDescription('Unset 503 on the current node.')
            ->setHelp("This command allows you to unlock api requests by unsetting 503.json.");
            
        $this->filesystem = new Filesystem();
    }


    protected function execute(InputInterface $input, OutputInterface $output)
    {

        $output->writeln([
            '===========================================================',
            'UnLocking the API request',
            '===========================================================',
            '',
        ]);
        $container = $this->getContainer();
        $rootDir = $container->getParameter('kernel.root_dir');
        $logDir = sprintf('%s/../web', $rootDir);
        
        $this->filesystem->remove(sprintf('%s/503.json', $logDir));
       
        $output->writeln([
            '===========================================================',
            'API request UnLocked',
            '===========================================================',
            '',
        ]);
    }
}