<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Entity;


use Cybersponse\CoreBundle\Entity\BaseEntity;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\Exportable\Exportable;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass="Doctrine\ORM\EntityRepository")
 * @ORM\Table(name="cyops.clustercommand")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="clustercommand")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="clustercommand")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\DisplayName\DisplayName(displayName="{{ nodeId }} {{ opId }}")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="Cross-Cluster Operation",plural="Cross-Cluster Operation")
 */
class ClusterCommand extends BaseEntity
{
    /**
     * @var string
     * 
     * @ORM\Column(name="nodeId", type="string", nullable=false)
     */
    protected $nodeId;

    /**
     * @var string
     * 
     * @ORM\Column(name="commandId", type="string", nullable=false)
     */
    protected $commandId;

    /**
     * @var string
     *
     * @ORM\Column(name="sequenceId", type="string", nullable=false)
     */
    protected $sequenceId;

    /**
     * @var string
     * 
     * @ORM\Column(name="status", type="string", nullable=true)
     */
    protected $status;

    /**
     * @var string
     * 
     * @ORM\Column(name="result", type="string", nullable=true)
     */
    protected $result;

    /**
     * Set Node Id
     *
     * @param string $nodeId
     * @return Workflow
     */
    public function setNodeId($nodeId)
    {
        $this->nodeId = $nodeId;

        return $this;
    }

    /**
     * Get Node Id
     *
     * @return string
     */
    public function getNodeId()
    {
        return $this->nodeId;
    }

    /**
     * Set opId
     *
     * @param string $opId
     * @return string
     */
    public function setCommandId($commandId)
    {
        $this->commandId = $commandId;

        return $this;
    }

    /**
     * Get commandId
     *
     * @return string
     */
    public function getCommandId()
    {
        return $this->commandId;
    }

    

    /**
     * Get the value of sequenceId
     *
     * @return  string
     */ 
    public function getSequenceId()
    {
        return $this->sequenceId;
    }

    /**
     * Set sequenceId
     *
     * @param sting $sequenceId
     *
     * @return self
     */ 
    public function setSequenceId($sequenceId)
    {
        $this->sequenceId = $sequenceId;

        return $this;
    }

    /**
     * Get the value of status
     *
     * @return  string
     */ 
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set the value of status
     *
     * @param  string  $status
     *
     * @return  self
     */ 
    public function setStatus(string $status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * Get the value of result
     *
     * @return  string
     */ 
    public function getResult()
    {
        return $this->result;
    }

    /**
     * Set the value of result
     *
     * @param  string  $result
     *
     * @return  self
     */ 
    public function setResult(string $result)
    {
        $this->result = $result;

        return $this;
    }
}