<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Classes;


use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\AnnotationGeneratorInterface;
use Cybersponse\MetadataBundle\Generation\Metadata\ModelClassMetadata;
use Doctrine\ORM\Mapping\ClassMetadataInfo;

interface ClassAnnotationGeneratorInterface extends AnnotationGeneratorInterface
{
    /**
     * @param ModelMetadata $modelMetadata
     * @param ClassMetadataInfo $metadata
     * @return bool|string In the format '@Full\Namespace\Annotation(etc)' or false
     */
    public function generateClassAnnotationFromModelMetadata($modelMetadata, $metadata);

    /**
     * @param ModelClassMetadata $metadata
     * @param $annotation
     * @return mixed
     */
    public function loadClassMetadata($metadata, $annotation);

    /**
     * @param ModelMetadata $metadata
     * @inheritdoc
     */
    public function supportsGenerationForMetadata($metadata);
}
