<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Classes\DisplayName;


use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\Classes\ClassAnnotationGeneratorInterface;
use Doctrine\ORM\Mapping\ClassMetadataInfo;

class DisplayNameAnnotationGenerator implements ClassAnnotationGeneratorInterface
{
    /**
     * @return string
     */
    public function getAnnotationClassName()
    {
        return DisplayName::class;
    }

    /**
     * @param ModelMetadata $metadata
     * @inheritdoc
     */
    public function supportsGenerationForMetadata($metadata)
    {
        return !empty($metadata->getDisplayName());
    }

    /**
     * @param ModelMetadata $modelMetadata
     * @param ClassMetadataInfo $metadata
     * @return bool|string In the format '@Full\Namespace\Annotation(etc)' or false
     */
    public function generateClassAnnotationFromModelMetadata($modelMetadata, $metadata)
    {
        return sprintf(
            '@%s(displayName="%s")',
            DisplayName::class,
            str_replace('"', '""', $modelMetadata->getDisplayName())
        );
    }

    /**
     * @inheritdoc
     */
    public function loadClassMetadata($metadata, $annotation)
    {
        $metadata->setDisplayName($annotation->displayName);
    }
}
