<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType;


use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\Classes\ClassAnnotationGeneratorInterface;
use Doctrine\ORM\Mapping\ClassMetadataInfo;

class ModelTypeAnnotationGenerator implements ClassAnnotationGeneratorInterface
{
    /**
     * @return string
     */
    public function getAnnotationClassName()
    {
        return ModelType::class;
    }

    /**
     * @param ModelMetadata $metadata
     * @inheritdoc
     */
    public function supportsGenerationForMetadata($metadata)
    {
        return !empty($metadata->getType());
    }

    /**
     * @param ModelMetadata $modelMetadata
     * @param ClassMetadataInfo $metadata
     * @return bool|string In the format '@Full\Namespace\Annotation(etc)' or false
     */
    public function generateClassAnnotationFromModelMetadata($modelMetadata, $metadata)
    {
        return sprintf('@%s(modelType="%s")', ModelType::class, str_replace('"', '""', $modelMetadata->getType()));
    }

    /**
     * @inheritdoc
     */
    public function loadClassMetadata($metadata, $annotation)
    {
        $metadata->setType($annotation->modelType);
    }
}
