<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Fields\Column;

use Cybersponse\MetadataBundle\Entity\AttributeMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\FieldAnnotationGeneratorInterface;
use Doctrine\ORM\Mapping\Column;

class ColumnAnnotationGenerator implements FieldAnnotationGeneratorInterface
{

    /**
     * @inheritdoc
     */
    public function getAnnotationClassName()
    {
        return Column::class;
    }

    /**
     * @param Column $annotation
     * @inheritdoc
     */
    public function loadAttributeMetadata($metadata, $annotation)
    {
        $metadata->setUnique($annotation->unique);
    }

    /**
     * @param AttributeMetadata $attributeMetadata
     * @return bool
     */
    public function supportsGenerationForMetadata($attributeMetadata)
    {
        return false;
    }

    /**
     * @inheritdoc
     */
    public function generateFieldAnnotationFromAttributeMetadata($attributeMetadata, $metadata)
    {
        return '@' . Column::class . '()';
    }
}
