<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Fields\DefaultValue;


use Cybersponse\MetadataBundle\Entity\AttributeMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\FieldAnnotationGeneratorInterface;

class DefaultValueAnnotationGenerator implements FieldAnnotationGeneratorInterface
{
    /**
     * @inheritdoc
     */
    public function getAnnotationClassName()
    {
        return DefaultValue::class;
    }

    /**
     * @param DefaultValue $annotation
     * @inheritdoc
     */
    public function loadAttributeMetadata($metadata, $annotation)
    {
        $metadata->setDefaultValue($annotation->defaultValue);
    }

    /**
     * @param AttributeMetadata $attributeMetadata
     * @return bool
     */
    public function supportsGenerationForMetadata($attributeMetadata)
    {
        return false;
    }

    /**
     * @param AttributeMetadata $attributeMetadata
     * @inheritdoc
     */
    public function generateFieldAnnotationFromAttributeMetadata($attributeMetadata, $metadata)
    {
        return '@' . DefaultValue::class . sprintf('(defaultValue="%s")', $attributeMetadata->getDefaultValue());
    }
}
