<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Fields;


use Cybersponse\MetadataBundle\Entity\AttributeMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\AnnotationGeneratorInterface;
use Cybersponse\MetadataBundle\Generation\Metadata\ModelAttributeMetadata;
use Doctrine\ORM\Mapping\ClassMetadataInfo;

interface FieldAnnotationGeneratorInterface extends AnnotationGeneratorInterface
{
    /**
     * @param AttributeMetadata $attributeMetadata
     * @param ClassMetadataInfo $metadata
     * @return bool|string In the format '@Full\Namespace\Annotation(etc)' or false
     */
    public function generateFieldAnnotationFromAttributeMetadata($attributeMetadata, $metadata);

    /**
     * @param ModelAttributeMetadata $metadata
     * @param $annotation
     * @return mixed
     */
    public function loadAttributeMetadata($metadata, $annotation);

    /**
     * @param AttributeMetadata $attributeMetadata
     * @return bool
     */
    public function supportsGenerationForMetadata($attributeMetadata);
}
