<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Fields\Ip;

use Cybersponse\MetadataBundle\Entity\AttributeMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\FieldAnnotationGeneratorInterface;
use Cybersponse\MetadataBundle\Generation\Metadata\ModelAttributeMetadata;
use Doctrine\ORM\Mapping\ClassMetadataInfo;
use Symfony\Component\Validator\Constraints\Ip;

class IpAnnotationGenerator implements FieldAnnotationGeneratorInterface
{

    /**
     * @return string
     */
    public function getAnnotationClassName()
    {
        return Ip::class;
    }

    /**
     * @param AttributeMetadata $attributeMetadata
     * @param ClassMetadataInfo $metadata
     * @return bool|string In the format '@Full\Namespace\Annotation(etc)' or false
     */
    public function generateFieldAnnotationFromAttributeMetadata($attributeMetadata, $metadata)
    {
        return sprintf('@%s(version="all")', Ip::class);
    }

    /**
     * @param ModelAttributeMetadata $metadata
     * @param $annotation
     * @return mixed
     */
    public function loadAttributeMetadata($metadata, $annotation)
    {
        $validation = $metadata->getValidation();
        $validation['ip'] = true;
        $metadata->setValidation($validation);
    }

    /**
     * @param AttributeMetadata $attributeMetadata
     * @return bool
     */
    public function supportsGenerationForMetadata($attributeMetadata)
    {
        $validation = (array)$attributeMetadata->getValidation();

        return array_key_exists('ip', $validation)
            && filter_var($validation['ip'], FILTER_VALIDATE_BOOLEAN);
    }
}
