<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Annotations\Fields\Readonly;


use Cybersponse\MetadataBundle\Entity\AttributeMetadata;
use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\FieldAnnotationGeneratorInterface;
use Doctrine\ORM\Mapping\ClassMetadataInfo;

class ReadonlyAnnotationGenerator implements FieldAnnotationGeneratorInterface
{
    /**
     * @inheritdoc
     */
    public function getAnnotationClassName()
    {
        return Readonly::class;
    }

    /**
     * TODO: Shit. This causes issues during trackable fields export
     * @param Readonly $annotation
     * @inheritdoc
     */
    public function loadAttributeMetadata($metadata, $annotation)
    {
        $metadata->setWritable(false);
    }

    /**
     * @param AttributeMetadata $attributeMetadata
     * @return bool
     */
    public function supportsGenerationForMetadata($attributeMetadata)
    {
        return !$attributeMetadata->isWriteable();
    }

    /**
     * @param ModelMetadata $attributeMetadata
     * @param ClassMetadataInfo $metadata
     * @return bool|string In the format '@Full\Namespace\Annotation(etc)' or false
     */
    public function generateFieldAnnotationFromAttributeMetadata($attributeMetadata, $metadata)
    {
        return '@' . Readonly::class . '()';
    }
}
