<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Traits;


use Cybersponse\AuthorizationBundle\Traits\Ownable;
use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Generation\Metadata\ModelClassMetadata;

class OwnableTraitGenerator implements TraitGeneratorInterface
{

    /**
     * @return string
     */
    public function getTraitClassName()
    {
        return Ownable::class;
    }

    /**
     * @param ModelClassMetadata $metadata
     * @param $annotation
     * @return mixed
     */
    public function loadClassMetadata($metadata, $annotation)
    {
        $metadata->setOwnable(true);
    }

    /**
     * @param ModelMetadata $metadata
     * @return bool
     */
    public function supportsGenerationForMetadata($metadata)
    {
        return $metadata->isOwnable();
    }
}
