<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Generation\Traits;

use Cybersponse\AuthorizationBundle\Traits\Taggable;
use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Generation\Metadata\ModelClassMetadata;

class TaggableTraitGenerator implements TraitGeneratorInterface
{
    /**
     * @return string
     */
    public function getTraitClassName()
    {
        return Taggable::class;
    }
    /**
     * @param ModelClassMetadata $metadata
     * @param $annotation
     * @return mixed
     */
    public function loadClassMetadata($metadata, $annotation)
    {
        $metadata->setTaggable(true);
    }
    /**
     * @param ModelMetadata $metadata
     * @return bool
     */
    public function supportsGenerationForMetadata($metadata)
    {
        return $metadata->isTaggable();
    }
}
