<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Tests\Unit\Conditional\Query;


use Cybersponse\MetadataBundle\Conditional\QueryInterface;
use Cybersponse\MetadataBundle\Conditional\QueryMatcher;
use Dunglas\ApiBundle\Api\IriConverterInterface;
use Symfony\Component\PropertyAccess\PropertyAccessor;

class QueryMatcherTestCase extends \PHPUnit_Framework_TestCase
{
    /** @var mixed */
    protected $objectToValidate;

    /** @var QueryInterface|\PHPUnit_Framework_MockObject_MockObject */
    protected $query;

    /** @var QueryMatcher */
    protected $queryMatcher;

    /** @var IriConverterInterface|\PHPUnit_Framework_MockObject_MockObject */
    protected $mockIriConverter;

    protected function setUp()
    {
        parent::setUp();

        $propertyAccessor = new PropertyAccessor();

        $this->queryMatcher = new QueryMatcher();
        $this->queryMatcher->setPropertyAccessor($propertyAccessor);

        $this->mockIriConverter = $this->getMockBuilder(IriConverterInterface::class)->getMock();
        $this->queryMatcher->setIriConverter($this->mockIriConverter);
    }

    protected function executeSystemUnderTest()
    {
        return $this->queryMatcher->matches(
            $this->objectToValidate,
            $this->query
        );
    }

    protected function tearDown()
    {
        parent::tearDown();
        unset($this->queryMatcher);
        unset($this->mockIriConverter);
        unset($this->objectToValidate);
        unset($this->query);
    }
}