<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Tests\Unit\Validation\Constraint\ModelMetadataCollection;


use Cybersponse\MetadataBundle\Entity\ModelMetadata;
use Cybersponse\MetadataBundle\Tests\Unit\Validation\MockConstraint;
use Cybersponse\MetadataBundle\Tests\Unit\Validation\ValidatorTestCase;
use Cybersponse\MetadataBundle\Validation\ModelMetadataCollectionConstraint;
use Cybersponse\MetadataBundle\Validation\ModelMetadataCollectionConstraintValidator;
use Symfony\Component\Validator\ExecutionContextInterface;

class ModelMetadataCollectionTestCase extends ValidatorTestCase
{
    const CORE_TYPE = 'core_type';
    const CORE_TYPE_2 = 'core_type_2';
    const CUSTOM_TYPE = 'custom_type';
    const CUSTOM_TYPE_2 = 'custom_type_2';

    /** @var ModelMetadata[] */
    protected $modelMetadataList;

    protected $uniqueFieldName = 'test';

    protected function setUp()
    {
        $this->constraint = new ModelMetadataCollectionConstraint();
        $this->validator = new ModelMetadataCollectionConstraintValidator();
        $this->validator->setCoreClassTypeMap([
            self::CORE_TYPE => MockClass::class,
            self::CORE_TYPE_2 => MockClass::class
        ]);
        parent::setUp();
    }

    protected function tearDown()
    {
        unset($this->objectList);
        $this->objectList = [];
        parent::tearDown();
    }

    protected function executeSystemUnderTest()
    {
        $this->value = $this->modelMetadataList;

        parent::executeSystemUnderTest();
    }

    public function test_GivenNonModelMetadataCollectionConstraint_ShouldReturnZeroViolations()
    {
        $this->constraint = new MockConstraint();
        $this->objectList = [];
        $this->violationCount = 0;

        $this->executeSystemUnderTest();
    }

    public function test_GivenNonExecutionContext_ShouldReturnZeroViolations()
    {
        $this->mockExecutionContext = $this->getMockBuilder(ExecutionContextInterface::class)->getMock();
        $this->objectList = [];
        $this->violationCount = 0;

        $this->executeSystemUnderTest();
    }
}

class MockClass
{

}