<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Tests\Unit\Validation\Constraint\UniqueCollection;


class UniqueStringTest extends UniqueCollectionTestCase
{
    public function test_GivenNonUniqueObjectList_ShouldReturnOneViolation()
    {
        $this->objectList = [
            new MockObject(true),
            new MockObject(true)
        ];

        $this->violationCount = 1;

        $this->executeSystemUnderTest();
    }

    public function test_GivenUniqueObjectList_ShouldReturnZeroViolations()
    {
        $this->objectList = [
            new MockObject(true),
            new MockObject(false)
        ];

        $this->violationCount = 0;

        $this->executeSystemUnderTest();
    }

    public function test_GivenNonUniqueObjectList_GivenNull_ShouldReturnOneViolation()
    {
        $this->objectList = [
            new MockObject(null),
            new MockObject(null)
        ];

        $this->violationCount = 1;

        $this->executeSystemUnderTest();
    }

    public function test_GivenUniqueObjectList_GivenNull_ShouldReturnZeroViolations()
    {
        $this->objectList = [
            new MockObject(true),
            new MockObject(null)
        ];

        $this->violationCount = 0;

        $this->executeSystemUnderTest();
    }
}