<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Validation;


use Cybersponse\MetadataBundle\Conditional\ConditionSet;
use Symfony\Component\Validator\Constraint;

/**
 * Class ConditionSetConstraint
 *
 * @Annotation
 * @Target("CLASS")
 *
 * @package Cybersponse\MetadataBundle\Validation
 */
class ConditionSetConstraint extends Constraint implements ConditionSet
{
    const MESSAGE = 'Class validation not met.';

    /** @var array */
    public $fields;

    public function validatedBy()
    {
        return 'condition_set_constraint_validator';
    }

    public function getTargets()
    {
        return self::CLASS_CONSTRAINT;
    }

    /**
     * @return array
     */
    public function getFields()
    {
        return $this->fields;
    }
}
