<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\MetadataBundle\Validation;


use Symfony\Component\Validator\Constraint;

class ModelMetadataCollectionConstraint extends Constraint
{
    public $coreTypeViolation = "Type '{{ value }}' already exists as core model metadata.";
    public $attributeTypeViolation = "Attribute type '{{ value }}' does not exist as core or custom model metadata.";
    public $inversedFieldViolation = "Inverse field '{{ value }}' does not exist on related model metadata.";
    // Sample: Duplicate field fileName exist in alerts module. 
    // Do note the attribute name are case insensitive.
    // filename and fileName are considered same fields by framework.
    public $duplicateFieldViolation = "Duplicate field: '{{ value }}' exists in '{{ model }}' module. Do note fields name are case insensitive";

    public function validatedBy()
    {
        return 'model_metadata_collection_constraint_validator';
    }
}
