<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

/**
 * Created by PhpStorm.
 * User: Santosh-Diwase
 * Date: 04/04/17
 * Time: 4:04 PM
 */

namespace Cybersponse\ProxyBundle\Provider;


class JwtLogoutKeyProvider
{
    /** @var CacheableInterface */
    protected $cache;

    /**
     * @var int
     */
    protected $cacheLifeTime;


    /**
     * @param CacheableInterface $cache
     */
    public function setCache($cache)
    {
        $this->cache = $cache;
    }

    /**
     * @param string $keyIdentifier
     * @return boolean
     * @throws \Exception
     */
    public function isJwtLogoutKey($keyIdentifier)
    {
        $cacheKey = $this->cache->getFromCache($keyIdentifier);

        if ($cacheKey === null || empty($cacheKey)) {
            return false;
        }

        return true;
    }

    /**
     * @param string $keyIdentifier
     * @throws \Exception
     */
    public function setJwtLogoutKey($keyIdentifier)
    {
        $this->cache->persistToCache($keyIdentifier, $keyIdentifier, 7200);
    }

}
