<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ProxyBundle\Repository;


use Cybersponse\ActorsBundle\Entity\Actor;
use Doctrine\ORM\EntityRepository;

class ProxyRepository extends EntityRepository
{
    /**
     * @param $userId
     * @return Actor
     */
    public function getActorForSaml($userId)
    {
        $actorQueryBuilder = $this->createQueryBuilder('actor');
        /** @var Actor $actor */
        $actor = $actorQueryBuilder
            ->select('actor.uuid')
            ->from('Cybersponse\ActorsBundle\Entity\Actor', 'actor')
            ->where($actorQueryBuilder->expr()->eq('actor.user_id', ':userId'))
            ->setParameter('userId', $userId)
            ->getQuery()
            ->execute();

        return $actor;
    }
}
