<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\QueryBundle\Provider;

use Dunglas\ApiBundle\Api\ResourceInterface;
use Dunglas\ApiBundle\Model\DataProviderInterface;
use Symfony\Component\HttpFoundation\Request;

interface AggregateDataProviderInterface extends DataProviderInterface
{
    /**
     * Retrieves an item.
     *
     * @param ResourceInterface $resource
     * @param Request $request
     *
     * @return object|null
     */
    public function getAggregate(ResourceInterface $resource, Request $request);

    /**
     * Retrieves an item.
     *
     * @param ResourceInterface $resource
     * @param array             $filters
     * @param bool              $fetchData
     *
     * @return object|null
     */
    public function getItemWithWhere(ResourceInterface $resource, $filters, $fetchData = false);
}
