<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\QueryBundle\Query;


class ExpressionBuilder
{
    /**
     * @param string $fieldName
     * @return FieldExpressionBuilder
     */
    public static function field($fieldName)
    {
        return new FieldExpressionBuilder($fieldName);
    }

    /**
     * @param array $filters
     * @return Query
     */
    public static function logicAnd($filters = [])
    {
        if (!is_array($filters)) {
            $filters = func_get_args();
        }
        $query = new Query('AND');
        foreach ($filters as $filter) {
            $query->addFilter($filter);
        }
        return $query;
    }

    /**
     * @param array $filters
     * @return Query
     */
    public static function logicOr($filters = [])
    {
        if (!is_array($filters)) {
            $filters = func_get_args();
        }
        $query = new Query('OR');
        foreach ($filters as $filter) {
            $query->addFilter($filter);
        }
        return $query;
    }
}
