<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\QueryBundle\Query;


class FieldExpression implements ExpressionInterface
{
    /** @var string */
    protected $fieldName;

    /** @var string */
    protected $operator;

    /** @var mixed */
    protected $value;

    /**
     * ExpressionResult constructor.
     * @param string $fieldName
     * @param string $operator
     * @param mixed $value
     */
    public function __construct($fieldName, $operator, $value)
    {
        $this->fieldName = $fieldName;
        $this->operator = $operator;
        $this->value = $value;
    }

    /**
     * @return array
     */
    public function toArray()
    {
        return [
            'field' => $this->fieldName,
            'operator' => $this->operator,
            'value' => $this->value
        ];
    }
}
