<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\SettingsBundle\Controller;


use Cybersponse\SettingsBundle\Entity\SystemSettings;
use Cybersponse\SettingsBundle\Repository\SystemSettingsRepository;
use Cybersponse\SettingsBundle\Utility\Resolver;
use Cybersponse\SettingsBundle\Utility\UndefinedIndexException;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

/**
 * Class PublicSettingsController
 */
class PublicSettingsController extends Controller
{
    /**
     * @return JsonResponse
     */
    public function getAction()
    {
        // TODO: Don't hardcode this
        $path = 'authentication';
        $documentManagerRegistry = $this->getDoctrine();
        $systemSettingsManager = $documentManagerRegistry->getManagerForClass(SystemSettings::class);

        /** @var SystemSettingsRepository $systemSettingsRepository */
        $systemSettingsRepository = $systemSettingsManager->getRepository(SystemSettings::class);
        $systemSettings = $systemSettingsRepository->getSystemSettings();
        $systemSettingsValues = $systemSettings->getPrivateValues();

        try {
            $resolvedValues = Resolver::get($systemSettingsValues, $path);
        } catch (UndefinedIndexException $e) {
            throw new NotFoundHttpException('Not Found');
        }

        return JsonResponse::create($resolvedValues);
    }
}
