<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */


namespace Cybersponse\SettingsBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\ORM\Mapping\UniqueConstraint;


/**
 * @ORM\Table(name="cyops.system_settings", schema="cyops", uniqueConstraints={@UniqueConstraint(name="restriction_unique", columns={"restriction"})})
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Cybersponse\SettingsBundle\Repository\SystemSettingsRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="system_settings")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="application")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="system_setting",plural="system_settings")
 */
class SystemSettings extends Settings
{

    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`privatevalues`", type="jsonb", nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Private Value")
     */
    protected $privateValues;

    /**
     * @Doctrine\ORM\Mapping\Column(name="`restriction`", type="string", length=255, nullable=true, unique=false)
     *
     * This variable should not be set by the user. It is used to ensure only one system setting exists.
     */
    private $restriction = null;

    /**
     * Get privateValues
     *
     * @return array $privateValues
     */
    public function getPrivateValues()
    {
        return $this->privateValues;
    }

    /**
     * Set privateValues
     *
     * @param array $privateValues
     * @return self
     */
    public function setPrivateValues($privateValues)
    {
        $this->privateValues = $privateValues;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getRestriction()
    {
        return $this->restriction;
    }
}
