<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\TenantBundle\DataFixtures\ORM;


use Cybersponse\TenantBundle\DataFixtures\AbstractFixtureLoader;
use Doctrine\Common\Collections\Collection;
use Nelmio\Alice\Fixtures;

class SystemFixtureLoader extends AbstractFixtureLoader
{
    /**
     * @return array
     */
    public function getProviders()
    {
        return [
            $this->container->get('cybersponse.core.faker.provider.picklist'),
            $this->container->get('cybersponse.core.faker.provider.iri'),
            new ArrayProvider()
        ];
    }

    /**
     * @inheritdoc
     */
    public function getConfigName()
    {
        return 'ORM';
    }
}

class ArrayProvider
{
    public static function getNthIndex(Collection $collection, $index, $attribute = null)
    {
        $item = $collection->get($index);
        if (is_null($attribute)) {
            return $item;
        }
        $reflectProperty = new \ReflectionProperty(get_class($item), $attribute);
        if (is_null($reflectProperty)) {
            return $item;
        }

        $reflectProperty->setAccessible(true);

        return $reflectProperty->getValue($item);
    }
}
