### The Tenant Bundle
The Tenant Bundle deals with custom client data. It contains all of the custom code generated entities as well as the data fixture classes.

### Fixtures ###

Fixtures are used for the following:
  1. Loading Demo Data for All Entities (Users, Companies, Custom)
  1. Loading Metadata for Custom Entities
  1. Loading Baseline Migrations

#### Fixture Structure

There are two fixture directories: `app/Fixtures/ORM` and `app/Fixtures/ODM`, for each object manager we use. The default data that is loaded is defined by `app/Fixtures/config_{env}.yml`, where `env` is the environment that is being used. These should not be checked in and should be automatically built from templates. See the `crudhub_server` role.

##### Example Config.yml
```
---
ORM:
    <entity_manager>:
        Folder1
        Folder2:
            - load_me.yml
            - load_me_too.json
        Folder3:
            - 3_order.yml
            - 1_order.yml
ODM:
    <document_manager>:
        Folder1
```

In this example, everything in `Folder1` will be loaded. Only the files `load_me.yml` and `load_me_too.json` under the `Folder2` folder will be loaded as they are defined explicitly. Fixture files are loaded depth first. In `Folder3`, the list order will be retained as it is written and the fixtures will be loaded in that order.

#### Fixture Types

The supported types are:
 * `yml` - Alice expressive fixture files. See https://github.com/nelmio/alice
 * `json` - JSON objects with the `@type` defined.
