<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ViewTemplateBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Cybersponse\ViewTemplateBundle\Provider\UserPreferenceProvider;
use Cybersponse\ViewTemplateBundle\Entity\UserPreference;

class UserPreferenceController extends Controller
{

    public function getUserPreferenceAction()
    {
        $userPrefProvider = $this->userPrefProvider();
        /** @var UserPreference $userPref */
        $userPref = $userPrefProvider->getUserPref();
        $serializer = $this->get('serializer');
        $normalizedUserPref = $serializer->normalize($userPref, 'json');
        return JsonResponse::create($normalizedUserPref);
    }

    /**
     * @return UserPreferenceProvider
     */
    private function userPrefProvider()
    {
        return $this->get('cybersponse.user_pref.provider.user_pref');
    }

    public function createUserPreferenceAction(Request $request)
    {
        $userPrefProvider = $this->userPrefProvider();
        $reqBody = json_decode($request->getContent(), true);
        /** @var UserPreference $userPref */
        $userPref = $userPrefProvider->saveUserPref($reqBody);
        $serializer = $this->get('serializer');
        $normalizedUserPref = $serializer->normalize($userPref, 'json');
        return JsonResponse::create($normalizedUserPref);
    }
}
