<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

/**
 * Created by PhpStorm.
 * User: Santosh-Diwase
 * Date: 16/02/17
 * Time: 12:39 PM
 */

namespace Cybersponse\ViewTemplateBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Cybersponse\CoreBundle\Entity\BaseEntity;
use Doctrine\ORM\Mapping\UniqueConstraint;

/**
 * @ORM\Table(name="default_template", uniqueConstraints={@UniqueConstraint(name="default_user_unique", columns={"user_id", "templateId"})})
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Cybersponse\ViewTemplateBundle\Repository\GenericTemplateRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="default_template")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="application")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="default_template",plural="default_templates")
 */
class UserDefaultTemplate extends BaseEntity
{
    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`type`", type="string", length=255, nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Type")
     */
    protected $type;

    /**
     * @var \Cybersponse\ViewTemplateBundle\Entity\GenericTemplate
     *
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="\Cybersponse\ViewTemplateBundle\Entity\GenericTemplate",cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="templateId", referencedColumnName="uuid", onDelete="CASCADE")
     * })
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="GenericTemplate")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Template Id")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\BulkAction\BulkAction(allow=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $templateId;
       
    /**
     * @var \Cybersponse\ActorsBundle\Entity\Actor
     *
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="Cybersponse\ActorsBundle\Entity\Actor", cascade={"persist"})
     * @Doctrine\ORM\Mapping\JoinColumns({
     *   @Doctrine\ORM\Mapping\JoinColumn(name="user_id", referencedColumnName="uuid", onDelete="SET NULL")
     * })
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\DataSource\DataSource(model="actors")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="User Id")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="lookup")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize()
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Denormalize\Denormalize()
     */
    protected $userId;

    /**
     * Get $templateId
     *
     * @return id $templateId
     */
    public function getTemplateId()
    {
        return $this->templateId;
    }

    /**
     * @param String $templateId
     */
    public function setTemplateId($templateId)
    {
        $this->templateId = $templateId;
    }

    /**
     *
     * @param string $type
     * @return self
     */
    public function setType($type)
    {
        $this->type = $type;
        return $this;
    }

    /**
     * @return string $type
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     *
     * @param Cybersponse\ActorsBundle\Entity\Actor $userId
     * @return self
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
        return $this;
    }

    /**
     *
     * @return string $userId
     */
    public function getUserId()
    {
        return $this->userId;
    }

}
