<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ViewTemplateBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Cybersponse\CoreBundle\Entity\BaseEntity;

/**
 * @ORM\Table(name="cyops.user_preference", schema="cyops")
 * @Doctrine\ORM\Mapping\Entity(repositoryClass="Cybersponse\ViewTemplateBundle\Repository\UserPreferenceRepository")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="user_preference")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="application")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\Descriptions\Descriptions(singular="user_preference",plural="user_preferences")
 */
class UserPreference extends BaseEntity
{

    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`userid`", type="string", length=255, nullable=true, unique=false)
     * @Symfony\Component\Validator\Constraints\NotBlank()
     * @Symfony\Component\Validator\Constraints\NotNull()
     * @Symfony\Component\Validator\Constraints\Regex(pattern="/^ *$/",
     * match=false,
     * message="Required value should not contain only space.")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="User Id")
     */
    protected $userId;


    /**
     * @var string
     *
     * @Doctrine\ORM\Mapping\Column(name="`preferences`", type="json_array", nullable=true, unique=false)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Preferences")
     */
    protected $preferences;

    /**
     * @var \DateTime
     *
     * @Doctrine\ORM\Mapping\Column(name="updatedate", type="datetime", nullable=true)
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\FormType\FormType(type="datetime")
     * @Cybersponse\MetadataBundle\Generation\Annotations\Fields\Title\Title(name="Update Date")
     */
    protected $updateDate;

    /**
     *
     * @return string $userId
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     *
     * @param string $userId
     * @return self
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
        return $this;
    }

    /**
     * Get config
     *
     * @return array $preferences
     */
    public function getPreferences()
    {
        return $this->preferences;
    }

    /**
     * Set config
     *
     * @return self
     */
    public function setPreferences($preferences)
    {
        $this->preferences = $preferences;
        return $this;
    }

    /**
     * Get updateDate
     *
     * @return int $uploadDate
     */
    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    /**
     * Set updateDate
     *
     * @param int $updateDate
     * @return self
     */
    public function setUpdateDate($updateDate)
    {
        $this->updateDate = $updateDate;
        return $this;
    }

}
