<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ViewTemplateBundle\Repository;

use Cybersponse\ViewTemplateBundle\Entity\GenericTemplate;
use Cybersponse\ViewTemplateBundle\Entity\UserDefaultTemplate;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Query;

/**
 * GenericTemplateRepository
 */
class GenericTemplateRepository extends EntityRepository
{


    /**
     * @param $type
     * @param string $__selectFields
     * @return mixed
     */
    public function getAllGenericTemplate($type, $__selectFields = "")
    {
        # ToDo Add Support for filter in simple_array once available
        if($__selectFields){
            $templates = $this->createQueryBuilder('o')
                ->select(explode(",", $__selectFields))
                ->andWhere('o.templateType = :templateType')
                ->setParameter('templateType', $type)
                ->getQuery()
                ->execute();

        }else{
            $templates = $this->createQueryBuilder('o')
                ->andwhere('o.templateType = :templateType')
                ->setParameter('templateType', $type)
                ->getQuery()
                ->execute();
        }

        return $templates;
    }

    /**
     * @param $templateId string
     * @param $type string
     */
    public function removeAllDefaultTemplate($type, $templateId)
    {

        $qb = $this->createQueryBuilder('o');
        $qb->delete();
        $qb->where('o.templateId = :templateId');
        $qb->setParameter('templateId', $templateId);
        $qb->andWhere('o.type = :type');
        $qb->setParameter('type', $type);
        $qb->getQuery()->execute();
    }

    /**
     * @param $userId String
     * @param $type String
     * @return UserDefaultTemplate
     */
    public function getDefaultUserTemplate($type, $userId)
    {

        $template = $this->createQueryBuilder('o')
            ->where('o.type = :type')
            ->andWhere('o.userId = :userId')
            ->setParameter('type', $type)
            ->setParameter('userId', $userId)
            ->getQuery()
            ->getOneOrNullResult();


        return $template;
    }

    /**
     * @param $id string
     * @param $type string
     * @return GenericTemplate
     */
    public function getGenericTemplate($type, $id)
    {
        $templates = $this->createQueryBuilder('o')
            ->andWhere('o.uuid = :id')
            ->andWhere('o.templateType = :type')
            ->setParameter('id', $id)
            ->setParameter('type', $type)
            ->getQuery()
            ->getOneOrNullResult();

        return $templates;
    }

}
