<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\ViewTemplateBundle\Repository;

use Cybersponse\ViewTemplateBundle\Entity\UserViewTemplate;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Query;

/**
 * UserViewTemplateRepository
 */
class UserViewTemplateRepository extends EntityRepository
{
    /**
     * @param $user
     * @param $name
     * @return UserViewTemplate
     * @throws \Doctrine\ORM\NonUniqueResultException
     */
    public function getUserViewTemplate($user, $name)
    {

        $viewTemplate = $this->createQueryBuilder('o')
            ->andWhere('o.owner = :owner')
            ->andWhere('o.name = :name')
            ->setParameter('owner', $user)
            ->setParameter('name', $name)
            ->getQuery()
            ->getOneOrNullResult();
        return $viewTemplate;
    }
}
