<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\WorkflowBundle\Entity;


use Cybersponse\CoreBundle\Entity\BaseEntity;
use Cybersponse\MetadataBundle\Generation\Annotations\Fields\Normalize\Normalize;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 * @ORM\Table(name="workflow_step_type_collection")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="step_type_collections")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="workflows")
 */
class StepTypeCollection extends BaseEntity
{
    use \Cybersponse\CoreBundle\Traits\Indexable;

    /**
     * @ORM\Column(type="string", length=140)
     */
    protected $name;

    /**
     * @ORM\OneToMany(targetEntity="WorkflowStepType", mappedBy="collection")
     * @Normalize()
     */
    protected $stepTypes;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    protected $index;

    /**
     * @ORM\Column(type="boolean",options={"default" = true})
     */
    protected $visible = true;


    /**
     * Constructor
     */
    public function __construct()
    {
        $this->stepTypes = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * Set name
     *
     * @param string $name
     * @return StepTypeCollection
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Add stepTypes
     *
     * @param \Cybersponse\WorkflowBundle\Entity\WorkflowStepType $stepTypes
     * @return StepTypeCollection
     */
    public function addStepType(\Cybersponse\WorkflowBundle\Entity\WorkflowStepType $stepTypes)
    {
        $this->stepTypes[] = $stepTypes;

        return $this;
    }

    /**
     * Remove stepTypes
     *
     * @param \Cybersponse\WorkflowBundle\Entity\WorkflowStepType $stepTypes
     */
    public function removeStepType(\Cybersponse\WorkflowBundle\Entity\WorkflowStepType $stepTypes)
    {
        $this->stepTypes->removeElement($stepTypes);
    }

    /**
     * Get stepTypes
     *
     * @return \Doctrine\Common\Collections\Collection
     */
    public function getStepTypes()
    {
        return $this->stepTypes;
    }

    /**
     * Set index
     *
     * @param integer $index
     * @return WorkflowStepType
     */
    public function setIndex($index)
    {
        $this->index = $index;

        return $this;
    }

    /**
     * Get index
     *
     * @return integer
     */
    public function getIndex()
    {
        return $this->index;
    }

    /**
     * Set visible
     *
     * @param boolean $visible
     * @return self
     */
    public function setVisible($visible)
    {
        $this->visible = $visible;
    }

    /**
     * Get visible
     *
     * @return boolean
     */
    public function getVisible()
    {
        return $this->visible;
    }
}
