<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\WorkflowBundle\Entity;


use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity
 * @ORM\Table(name="workflow_routes")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModelType\ModelType(modelType="workflow_routes")
 * @Cybersponse\MetadataBundle\Generation\Annotations\Classes\ModuleType\ModuleType(moduleType="workflows")
 */
class WorkflowRoute
{
    /**
     * @ORM\Id
     * @ORM\Column(name="uuid", type="string", nullable=false)
     */
    protected $uuid;

    /**
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="WorkflowStep", cascade={"detach"})
     * @ORM\JoinColumn(name="targetstep_uuid", referencedColumnName="uuid", nullable=false, onDelete="CASCADE")
     */
    protected $targetStep;

    /**
     * @Doctrine\ORM\Mapping\ManyToOne(targetEntity="WorkflowStep", cascade={"detach"})
     * @ORM\JoinColumn(name="sourcestep_uuid", referencedColumnName="uuid", nullable=false, onDelete="CASCADE")
     */
    protected $sourceStep;

    /**
     * @ORM\Column(type="string", length=140, nullable=true)
     */
    protected $name;

    /**
     * @ORM\Column(type="string", length=140, nullable=true)
     */
    protected $label;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $isExecuted = false;

    /**
     * Set uuid
     *
     * @param integer $uuid
     * @return WorkflowRoute
     */
    public function setUuid($uuid)
    {
        $this->uuid = $uuid;

        return $this;
    }

    /**
     * Get uuid
     *
     * @return integer
     */
    public function getUuid()
    {
        return $this->uuid;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return WorkflowRoute
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set label
     *
     * @param string $label
     * @return WorkflowRoute
     */
    public function setLabel($label)
    {
        $this->label = $label;

        return $this;
    }

    /**
     * Get label
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * Set isExecuted
     *
     * @param boolean $isExecuted
     * @return WorkflowRoute
     */
    public function setIsExecuted($isExecuted)
    {
        $this->isExecuted = $isExecuted;

        return $this;
    }

    /**
     * Get isExecuted
     *
     * @return boolean
     */
    public function getIsExecuted()
    {
        return $this->isExecuted;
    }

    /**
     * Set targetStep
     *
     * @param \Cybersponse\WorkflowBundle\Entity\WorkflowStep $targetStep
     * @return WorkflowRoute
     */
    public function setTargetStep(\Cybersponse\WorkflowBundle\Entity\WorkflowStep $targetStep)
    {
        $this->targetStep = $targetStep;

        return $this;
    }

    /**
     * Get targetStep
     *
     * @return \Cybersponse\WorkflowBundle\Entity\WorkflowStep
     */
    public function getTargetStep()
    {
        return $this->targetStep;
    }

    /**
     * Set sourceStep
     *
     * @param \Cybersponse\WorkflowBundle\Entity\WorkflowStep $sourceStep
     * @return WorkflowRoute
     */
    public function setSourceStep(\Cybersponse\WorkflowBundle\Entity\WorkflowStep $sourceStep)
    {
        $this->sourceStep = $sourceStep;

        return $this;
    }

    /**
     * Get sourceStep
     *
     * @return \Cybersponse\WorkflowBundle\Entity\WorkflowStep
     */
    public function getSourceStep()
    {
        return $this->sourceStep;
    }
}
