<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\WorkflowBundle\Serializer;


use Cybersponse\CoreBundle\Serializer\EfficientItemNormalizer;
use Cybersponse\WorkflowBundle\Entity\RuleCollection;
use Dunglas\ApiBundle\Api\ResourceInterface;
use Symfony\Component\Serializer\Serializer;

class RuleCollectionNormalizer extends EfficientItemNormalizer
{
    const FORMAT_JSON_LD = 'json-ld';

    /** @var Serializer */
    protected $serializer;

    /** @var ResourceInterface */
    protected $ruleCollectionResource;

    /**
     * {@inheritdoc}
     */
    public function supportsNormalization($data, $format = null)
    {
        return self::FORMAT_JSON_LD === $format && ($data instanceof RuleCollection);
    }

    /**
     * {@inheritdoc}
     */
    public function supportsDenormalization($data, $type, $format = null)
    {
        return false;
    }

    /**
     * {@inheritdoc}
     */
    public function normalize($object, $format = null, array $context = [])
    {
        $context['ignore_depth'] = true;

        $normalizationContext = $this->ruleCollectionResource->getNormalizationContext();

        return parent::normalize(
            $object,
            $format,
            $context + $normalizationContext
        );
    }

    /**
     * @param ResourceInterface $workflowResource
     */
    public function setRuleCollectionResource($ruleCollectionResource)
    {
        $this->ruleCollectionResource = $ruleCollectionResource;
    }
    
}
