<?php
/* Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end */

namespace Cybersponse\WorkflowBundle\Subscriber;


use Dunglas\ApiBundle\Api\ResourceInterface;
use Dunglas\ApiBundle\Event\DataEvent as DunglasDataEvent;
use Symfony\Component\HttpFoundation\Response;


/**
 * Class DataEvent
 *
 * @package Cybersponse\WorkflowBundle\Subscriber
 */
class DataEvent extends DunglasDataEvent
{
    /** @var array */
    protected $previous;

    /** @var Response */
    protected $response = null;

    /** @var array */
    protected $wfHeaderObject = null;

    public function __construct(ResourceInterface $resource, $data, $previous = null, $headerObjs = null)
    {
        parent::__construct($resource, $data);
        $this->previous = $previous;
        $this->setWfHeaderObject($headerObjs);
    }

    /**
     * @return array
     */
    public function getPrevious()
    {
        return $this->previous;
    }

    /**
     * @param array $previous
     */
    public function setPrevious($previous)
    {
        $this->previous = $previous;
    }

    /**
     * @return Response
     */
    public function getResponse()
    {
        return $this->response;
    }

    /**
     * @param Response $response
     */
    public function setResponse($response)
    {
        $this->response = $response;
    }

    /**
     * Get the value of wfHeaderObject
     */
    public function getWfHeaderObject()
    {
        return $this->wfHeaderObject;
    }

    /**
     * Set the value of wfHeaderObject
     *
     * @return  self
     */
    public function setWfHeaderObject($wfHeaderObject)
    {
        $this->wfHeaderObject = $wfHeaderObject;

        return $this;
    }
}
