# DunglasApiBundle

DunglasApiBundle is an easy to use and powerful system to create [hypermedia-driven REST APIs](https://en.wikipedia.org/wiki/HATEOAS).
It is a component of the [API Platform framework](https://api-platform.com) and it can be used
as a standalone bundle for [the Symfony framework](https://symfony.com).

It embraces [JSON for Linked Data (JSON-LD)](http://json-ld.org) and [Hydra Core Vocabulary](http://www.hydra-cg.com) web standards. 

Build a working and fully-featured CRUD API in minutes. Leverage the awesome features of the tool to develop complex and
high performance API-first projects.

[![JSON-LD enabled](http://json-ld.org/images/json-ld-button-88.png)](http://json-ld.org)
[![Build Status](https://travis-ci.org/dunglas/DunglasApiBundle.svg?branch=1.x)](https://travis-ci.org/dunglas/DunglasApiBundle)
[![Build status](https://ci.appveyor.com/api/projects/status/grwuyprts3wdqx5l/branch/1.x?svg=true)](https://ci.appveyor.com/project/dunglas/dunglasapibundle/branch/1.x)
[![SensioLabsInsight](https://insight.sensiolabs.com/projects/a93f5a40-483f-4c46-ba09-3e1033b62552/mini.png)](https://insight.sensiolabs.com/projects/a93f5a40-483f-4c46-ba09-3e1033b62552)
[![Dependency Status](https://www.versioneye.com/user/projects/5552e93306c318a32a0000fa/badge.svg?style=flat)](https://www.versioneye.com/user/projects/5552e93306c318a32a0000fa)
[![HHVM Status](http://hhvm.h4cc.de/badge/dunglas/api-bundle.svg?style=flat-square)](http://hhvm.h4cc.de/package/dunglas/api-bundle)

## Documentation

The documentation of this bundle is available online and can be edited in
[its dedicated repository](https://github.com/api-platform/doc).

* [Get started with API Platform](https://api-platform.com/doc/1.0/getting-started/)
* [A documentation](https://api-platform.com/doc/1.0/api-bundle/)
