#!/bin/sh
# Copyright start
# Copyright (C) 2008 - 2020 Fortinet Inc.
# All rights reserved.
# FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
# Copyright end
search_word="/location \/wf"
file_path="/etc/nginx/conf.d/"
file_name="cyops-api.conf"

update_error_log_file_loc()
{
    local file=$file_path/$file_name
    echo "Updating the error log location in [$file]"
    sudo sed -i "s/^\s*error_log \+\/var\/log\/nginx\/ssl_cyops-api_error\.log *;$/    error_log \/var\/log\/cyops\/cyops-api\/ssl_cyops_api_error.log;/g"  $file
}

update_access_log_file_loc()
{
    local file=$file_path/$file_name
    echo "Updating the access log location in [$file]" 
    sudo sed -i "s/^\s*access_log \+\/var\/log\/nginx\/ssl_cyops-api_access\.log *;$/    access_log \/var\/log\/cyops\/cyops-api\/ssl_cyops_api_access.log;/g"  $file 
}

#####
#  MAIN program starts here
###

if [ ! -f $file_path/$file_name ]; then
    echo "File not found: $file_path/$file_name"
    exit 1
fi

sudo cp $file_path/$file_name $file_path/$file_name.ori

update_error_log_file_loc

update_access_log_file_loc

grep "cindex" $file_path/$file_name
if [ $? = 0 ];then
    echo "Exiting...";
    exit 1
fi  
 
sudo sed -i 's/location @siteupui/location @siteupui_old/' $file_path/$file_name

sudo sed -i -e $VAR "$search_word"/'i\
set $uiRootDir \x27/opt/cyops-ui/\x27;\
    location = /cindex.html {\
        root $uiRootDir;\
        add_header Cache-Control \x27no-store, no-cache, max-age=0\x27;\
    }\
    location @siteupui {\
        root $uiRootDir/;\
        index cindex.html;\
        try_files $uri /cindex.html;\
    }' $file_path/$file_name

exit 0
